/* MoonView.h
 * Part of the Moon application for the NeXT computer.
 * Author:  Geoffrey S. Knauth
 * Date:    January 4, 1992
 *
 * Permission to copy this program is hereby granted under the terms
 * of the Free Software Foundation's General Public License.
 */


/* Initially generated by Interface Builder */

#import <appkit/View.h>
#import "all.h"

struct moonInfo {
    float top, bottom, left, right;
};

@interface MoonView : View
{
  /* initialized in initFrame: */
    id image;
    NXPoint center;
    float xradius, yradius;
    float phase;		/* 0.0 .. 1.0 */

  /* initialized in mouseDown: */
    id hugeWindow;
    id hugeMoonView;

}

- initFrame :(const NXRect *)frameRect;
- drawSelf :(const NXRect *)rects :(int)rectCount;
- free;

- mouseDown:(NXEvent *)theEvent;

- (float)phase;
- setPhase :(float)phase;

@end
