#import <appkit/View.h>
#import "Glyph.h"
#import <objc/List.h>
#define GLYPHVIEWTAG 040651
// I use a tag to locate the resizebutton, and
// an ivar to hold the freezeButton outlet.  A bug in
// 3.0 IB prevents me from setting resizeButton 
// through IB's outlet mechanism 
#define RESIZEBUTTONTAG 040652
struct glyphViewFlags
{ unsigned freeWhenClosed:1 ;
  unsigned playing: 1 ;
  unsigned resizing: 1 ;
} ;

@interface GlyphView: View
{ @public
  id glyphMsgView, mouseObject ;
  id playButton, freezeButton, lockButton, resizeButton ;
  Glyph *rootGlyph ;
  struct glyphViewFlags flags ;
  char *fileName ;
  // music kit data
  double beatsPerMinute, headRoom, deltaT, samplingRate, tickPeriod ;
  BOOL fastResponse ;
}
+ become: (List *) newIds if: (List *) oldIds views: viewList;
+ cursor ;
+ (BOOL) glyph: (Glyph *) aGlyph become: (List *) newList if: (List *) oldList ;
+ glyphViewList ;
+ initialize ;
- browse: sender ;
- clearGlyphMsgView: aView ;
- displayRaised: sender ;
- fileName: (char *) fname ;
- freezeButton ;
- freezeButton: sender ;
- glyphMsg: (char *) aMsg ;
- lock: sender ;
- mouseDown: (NXEvent *) anEvent ;
- mouseDragged: (NXEvent *) anEvent ;
- mouseUp: (NXEvent *) anEvent ;
- resizeButton ;
- rightMouseDown: (NXEvent *) anEvent ;
- rightMouseDragged: (NXEvent *) anEvent ;
- rightMouseUp: (NXEvent *) anEvent ;
- rootGlyph ;
- rootGlyph: aGlyph ;
- (BOOL) save:sender ;
- (BOOL) saveAs:sender ;
- (BOOL) saveToFile ;
- setCursor: aCursor ;
- setFreeWhenClosed: (BOOL) YESorNO ;
- setGlyphMsgView: anObject ;
- setMKMBeatsPerMinute: (double) beatsPerMinute ;
- setMKMDeltaT: (double) seconds ;
- setMKMFastResponse: (BOOL) YESorNO ;
- setMKMHeadRoom: (double) seconds ;
- setMKMTickPeriod: (double) seconds ;
- setMKMSamplingRate: (double) seconds ;
- setupArchived ;
- setupCommon ;
- setupNew ;
- sizeTo: (float) x :(float) y ;
- (int) tag ;
- targetGlyph ;
- updateMKManager ;
- windowDidBecomeMain: sender ;
- windowWillClose: sender ;
@end
