#import <objc/Storage.h>

/*
** StringStorage.h,v 1.2 1992/11/08 13:45:23 nwc Exp
**
** Copyright (c) 1991 Ronin Consulting, Inc.
**
** StringStorage is a subclass of Storage designed to store null 
** terminated character strings. Null termination is guaranteed, therefore
** should this object's setStringValue method be called with a (char *)0
** arguement the resulting value from stringValue will be a null terminated
** empty string, i.e. "" not (char *)0.
*/

@interface StringStorage : Storage

- init;
- init: (const char *) str;

- setStringValue: (const char *) str;	     /* Set the string value */
- (const char *) stringValue;		     /* return the string pointer */

- appendStringValue: (const char *)str;	     /* append another string to the strings contents */
- appendCharValue: (char) c;		     /* append a character to the strings contents */

@end
