static char rcsid[] = "$Header: misc.c,v 1.2 90/09/05 22:10:21 mara Exp $";

/*  misc.c
 *
 *  Written by Mara Helmuth
 *
 *  Description: Miscellaneous functions
 *  	for Cmix X graphical interface
 * 
 *  $Log:	misc.c,v $
 * Revision 1.2  90/09/05  22:10:21  mara
 * *** empty log message ***
 * 
 * Revision 1.1  90/08/27  17:09:08  mara
 * Initial revision
 * 
 * Revision 1.5  90/03/01  20:08:26  mara
 * *** empty log message ***
 * 
 * Revision 1.4  90/02/21  13:45:33  mara
 * With tree stuff
 * 
 * Revision 1.3  90/02/11  16:19:47  mara
 * includes showit()
 * 
 * Revision 1.2  90/01/30  10:57:35  mara
 * *** empty log message ***
 * 
 * Revision 1.1  90/01/21  12:48:47  mara
 * Initial revision
 * 
 */

#include "plus.h"
#include "misc.h"

void errx(char* str)
{
	perror(str);
	exit(1);
}

void showit(int i)
{
	switch(ugen[i].type) {
		case OSCIL:
			printf("ugen[%d].oscil->amp->in_ugen = %d\n",i,ugen[i].oscil->amp->in_ugen);
			printf("ugen[%d].oscil->freq->in_ugen = %d\n",i,ugen[i].oscil->freq->in_ugen);
			printf("ugen[%d].oscil->phs->in_ugen = %d\n",i,ugen[i].oscil->phs->in_ugen);
			break;
		case BUZZ:
			printf("ugen[%d].buzz->amp->in_ugen = %d\n",i,ugen[i].buzz->amp->in_ugen);
			printf("ugen[%d].buzz->freq->in_ugen = %d\n",i,ugen[i].buzz->freq->in_ugen);
			printf("ugen[%d].buzz->nhar->in_ugen = %d\n",i,ugen[i].buzz->nhar->in_ugen);
			break;
		case EVP:
			printf("ugen[%d].evp->amp->in_ugen = %d\n",i,ugen[i].evp->amp->in_ugen);
			printf("ugen[%d].evp->rise->in_ugen = %d\n",i,ugen[i].evp->rise->in_ugen);
			printf("ugen[%d].evp->decay->in_ugen = %d\n",i,ugen[i].evp->decay->in_ugen);
			printf("ugen[%d].evp->nfunc->in_ugen = %d\n",i,ugen[i].evp->nfunc->in_ugen);
			break;
		case ADD:
		case SUBTRACT:
		case MULTIPLY:
		case DIVIDE:
			printf("ugen[%d].side->in0->in_ugen = %d\n",i,ugen[i].side->in0->in_ugen);
			printf("ugen[%d].side->in1->in_ugen = %d\n",i,ugen[i].side->in1->in_ugen);
			break;
		case RAND:
			break;
		case OUT:
			printf("ugen[%d].out->in->in_ugen = %d\n",i,ugen[i].out->in->in_ugen);
			break;
		default:
			break;
	}
}

int get_in0(int i)
{
	switch(ugen[i].type) {
		case OSCIL:
			return(ugen[i].oscil->amp->in_ugen);
		case EVP:
			return(ugen[i].evp->amp->in_ugen);
		case OUT:
			return(ugen[i].out->in->in_ugen);
		case ADD:
		case SUBTRACT:
		case MULTIPLY:
		case DIVIDE:
			return(ugen[i].side->in0->in_ugen);
		default:
			return(0);
	}
}

int get_in1(int i)
{
	switch(ugen[i].type) {
		case OSCIL:
			return(ugen[i].oscil->freq->in_ugen);
		case OUT:
			return(0);
		case ADD:
		case SUBTRACT:
		case MULTIPLY:
		case DIVIDE:
			return(ugen[i].side->in1->in_ugen);
		default:
			return(0);
	}
}
