// $Header: plus.h,v 1.4 91/02/13 09:47:59 mara Exp $

/*  plus.h
 *
 *  Written by Mara Helmuth
 *
 *  Description: Includes & macros 
 *	for Cmix X graphical interface
 * 
 *  $Log:	plus.h,v $
 * Revision 1.4  91/02/13  09:47:59  mara
 * panel fixes, includes X
 * 
 * Revision 1.3  90/09/08  12:51:41  mara
 * side panel
 * 
 * Revision 1.2  90/09/05  22:13:36  mara
 * ugen struct flags
 * 
 * Revision 1.1  90/08/27  17:11:10  mara
 * Initial revision
 * 
 * Revision 1.6  90/05/18  23:24:30  mara
 * data window
 * 
 * Revision 1.5  90/05/18  19:26:06  mara
 * *** empty log message ***
 * 
 * Revision 1.4  90/03/01  20:10:20  mara
 * *** empty log message ***
 * 
 * Revision 1.3  90/02/21  13:48:08  mara
 * *** empty log message ***
 * 
 * Revision 1.2  90/01/30  11:08:27  mara
 * *** empty log message ***
 * 
 * Revision 1.1  90/01/21  12:54:40  mara
 * Initial revision
 * 
 */

#include <g++/stdio.h>
#include <g++/std.h>
#include "struct.h" 
#include "misc.h"
#include "list.h"
#include "inst.h"
#include "graph.h"
#include "unit_gen.h"
#include "tree.h"
#include "nutree.h"
#include "soundfile.h"
#include "x.h"

extern	void	setup_windows(int, char*[]); 
extern	void	setup_images();
extern	void	setup_canvas();
extern	void	setup_mbar();
extern	void	setup_panel();
extern	void	setup_qpanel();
extern	void	setup_oscpanel();
extern	void	setup_evppanel();
extern	void	setup_buzzpanel();
extern	void	setup_sidepanel();
extern	void	map_windows();
extern	void	setup_datpanel();
extern	void	select_data();
extern	int	event_loop();
extern	make_oscil(ugen_str *);
extern	make_out(ugen_str *);
extern	make_side(ugen_str *);

ugen_str	ugen[35];
ugen_str	temp_ugen;
data_str	data;

#ifdef	PATCH

instrument	inst;
soundfile	sfile;
graphics	graph;

#else

extern 	instrument	inst;
extern 	soundfile	sfile;
extern	graphics	graph;

#endif

void 	errx(char*);
