// $Header: unit_gen.h,v 1.5 90/09/08 12:52:07 mara Exp $

/* unit_gen.h
 *
 *  Written by Mara Helmuth
 *
 *  Description: Unit Generator class declaration for cmix X graphical interface
 *	inherit specific ugens later
 * 
 *  $Log:	unit_gen.h,v $
 * Revision 1.5  90/09/08  12:52:07  mara
 * side panel
 * 
 * Revision 1.4  90/09/07  20:51:53  mara
 * fm
 * 
 * Revision 1.3  90/09/05  22:14:26  mara
 * +,-,*,/ ugens added
 * 
 * Revision 1.2  90/09/02  18:21:35  mara
 * NeXT fixes
 * 
 * Revision 1.1  90/08/27  17:11:28  mara
 * Initial revision
 * 
*/

class unit_generator
{
	friend void instrument::body(int);
	friend void instrument::process_ugen(int, int, int);
	private:
		FILE* fp;
		int num,left,right;
		int beg_int, beg_float, beg_float_ptr;
		char file[50],cmd[50];
		char oscil_type[10],si_var[10],amp_var[10];
	public:
		unit_generator();
		void write_oscil(int, int, int);
		void write_evp(int, int, int);
		void write_buzz(int, int, int);
		void write_add(int, int, int);
		void write_sub(int, int, int);
		void write_mult(int, int, int);
		void write_div(int, int, int);
		void write_out(int, int, int);
		void write_rand(int, int, int);
		void declare(int, int, int);
		~unit_generator(); 
};

//***********************************************

class ugen_loc
{
	int size, xoffset, yoffset;
	public:
		ugen_loc(int);
		int get_size();
		int get_xoffset();
		int get_yoffset();
		~ugen_loc() {};
};
