/*  $Header: x.h,v 1.2 90/09/08 12:52:20 mara Exp $";
 *
 *  x.h
 *
 *  Written by Mara Helmuth
 *
 *  Description: X macros for Cmix X graphical interface
 * 
 *  $Log:	x.h,v $
 * Revision 1.2  90/09/08  12:52:20  mara
 * side panel
 * 
 * Revision 1.1  90/08/27  17:11:33  mara
 * Initial revision
 * 
 */

#include <g++/stdio.h>
#include <g++/std.h>

extern "C"
{
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "/usr/local/src/lxt/lxt.h"


#include "bitmap/oscil.bitmap"
#include "bitmap/buzz.bitmap"
#include "bitmap/evp.bitmap"
#include "bitmap/add.bitmap"
#include "bitmap/subtract.bitmap"
#include "bitmap/multiply.bitmap"
#include "bitmap/divide.bitmap"
#include "bitmap/out.bitmap"
#include "bitmap/dot.bitmap"
#include "bitmap/rect.bitmap"
}

#define	SFRAME_WIDTH	400
#define	SFRAME_HEIGHT	150
#define	DFRAME_WIDTH	400
#define	DFRAME_HEIGHT	200

#ifdef	WOOF

#define WFRAME_WIDTH	900
#define WFRAME_HEIGHT	900
#define PFRAME_WIDTH	900
#define PFRAME_HEIGHT	150
#define MFRAME_WIDTH	900
#define MFRAME_HEIGHT	 50
#define CFRAME_WIDTH	900 
#define CFRAME_HEIGHT	700
#define CANVAS_WIDTH	900
#define CANVAS_HEIGHT	700
#define TFRAME_WIDTH	400
#define TFRAME_HEIGHT	500
#define	QFRAME_WIDTH	400 
#define	QFRAME_HEIGHT	150
#define	OFRAME_WIDTH	400
#define	OFRAME_HEIGHT	200
#define	EFRAME_WIDTH	500
#define	EFRAME_HEIGHT	200
#define	UBITMAP_SIZE	100
#define	SBITMAP_SIZE	 50

#else
#define WFRAME_WIDTH	700
#define WFRAME_HEIGHT	700
#define PFRAME_WIDTH	700
#define PFRAME_HEIGHT	150
#define MFRAME_WIDTH	700
#define MFRAME_HEIGHT	 40
#define CFRAME_WIDTH	700 
#define CFRAME_HEIGHT	510
#define CANVAS_WIDTH	700
#define CANVAS_HEIGHT	500
#define TFRAME_WIDTH	400
#define TFRAME_HEIGHT	500
#define	QFRAME_WIDTH	250 
#define	QFRAME_HEIGHT	100
#define	OFRAME_WIDTH	300
#define	OFRAME_HEIGHT	200
#define	EFRAME_WIDTH	400
#define	EFRAME_HEIGHT	200
#define	UBITMAP_SIZE	 72
#define	SBITMAP_SIZE	 36

#endif

#ifdef	WOOF

#define FONT		"fg-18"
#define SMALL_FONT	"fg-13"

#else

#define FONT		"9x15"
#define SMALL_FONT	"8x13"

#endif

#define OK		0
#define NO		1

#ifdef 	XSET
	
Display *dpy;
XFontStruct *fontstruct, *fontstructS;
Window wwin, pwin, cwin, canvas_win, mwin, mbar_win;
Window qwin,oscwin,datwin,sidewin,buzzwin,evpwin;
Window twin;
Pixmap canvas_pm, mbar_pm;
GC canvas_gc, mbar_gc, sf_gc, clear_gc;

Panel *panel;
Panel_item *title;
Panel_item *pi_name, *pi_srate, *pi_inchans, *pi_outchans;
Panel_item *quit_button;
Panel_item *compile_button;
Panel_item *run_button;
Panel_item *set_data_button;
Panel_item *rescale_button;
Panel_item *play_button;
Panel_item *reset_button;
Panel_item *font_button;

Panel *qpanel;
Panel_item *qmsg;
Panel_item *ok_button;
Panel_item *no_button;

Panel *oscpanel;
Panel_item *osctitle;
Panel_item *oscamp;
Panel_item *oscfreq;
Panel_item *oscphs;
Panel_item *resetosc_button;
Panel_item *quitosc_button;

Panel *buzzpanel;
Panel_item *buzztitle;
Panel_item *buzzamp;
Panel_item *buzzfreq;
Panel_item *buzznhar;
Panel_item *resetbuzz_button;
Panel_item *quitbuzz_button;

Panel *evppanel;
Panel_item *evptitle;
Panel_item *evpamp;
Panel_item *evprise;
Panel_item *evpdecay;
Panel_item *evpfunc;
Panel_item *resetevp_button;
Panel_item *quitevp_button;

Panel *sidepanel;
Panel_item *sidetitle;
Panel_item *sidein0;
Panel_item *sidein1;
Panel_item *sidetoggle;
Panel_item *resetside_button;
Panel_item *quitside_button;

Panel *datpanel;
Panel_item *dattitle;
Panel_item *datout;
Panel_item *datdur;
Panel_item *datamp;
Panel_item *resetdat_button;
Panel_item *quitdat_button;

Canvas *canvas, *menu_bar;
int header_spaces = 7;

Menu *generator_menu, *processor_menu, *connect_menu; 
Menu *converter_menu, *options_menu, *help_menu;

XImage *dot_im, *oscil_im, *add_im, *subtract_im, *multiply_im, *divide_im, *out_im, *rect_im, *buzz_im, *evp_im;

Textsw *text_read;

char *progname;
char font[20], small_font[20];
unsigned long black, white;
char *string;

int lx, ly;
int text, tx, ty;

int 	find_ugen(int, int); 	/* find functions defined in xselect.c */
param_str *find_ugen_param(int, int);
void	ugen_select(int, int);
connector(int, int);
make_oscil(ugen_str *);
make_buzz(ugen_str *);
make_evp(ugen_str *);
make_out(ugen_str *);
make_side(ugen_str *);
make_rand(ugen_str *);
zone_oscil(ugen_str *);
zone_evp(ugen_str *);
zone_buzz(ugen_str *);
zone_out(ugen_str *);
zone_side(side_str *, int, int);
zone_rand(side_str *, int, int);
draw_oscil(int, int, int);
draw_evp(int, int, int);
draw_buzz(int, int, int);
draw_out(int);
draw_side(int, int, XImage*);
draw_rand(int, int, XImage*);
pm_select(XPointerMovedEvent *);
bp_select(XButtonPressedEvent *);

void linker(int, ugen_str *);
void 	errx(char *);

void	oscil_params(ugen_str *);
void	evp_params(ugen_str *);
void	buzz_params(ugen_str *);
void	side_params(ugen_str *);
void	set_params(int, int);
void	oscamp_proc(Panel *p, Panel_item *pi, char *s);
void	oscfreq_proc(Panel *p, Panel_item *pi, char *s);
void	oscphs_proc(Panel *p, Panel_item *pi, char *s);
void	reset_oscil(Panel *p, Panel_item *pi);
void	quit_oscil(Panel *p, Panel_item *pi);
void	evprise_proc(Panel *p, Panel_item *pi, char *s);
void	evpamp_proc(Panel *p, Panel_item *pi, char *s);
void	evpdecay_proc(Panel *p, Panel_item *pi, char *s);
void	reset_evp(Panel *p, Panel_item *pi);
void	quit_evp(Panel *p, Panel_item *pi);
void	buzzamp_proc(Panel *p, Panel_item *pi, char *s);
void	buzzfreq_proc(Panel *p, Panel_item *pi, char *s);
void	buzznhar_proc(Panel *p, Panel_item *pi, char *s);
void	reset_buzz(Panel *p, Panel_item *pi);
void	quit_buzz(Panel *p, Panel_item *pi);
void	sidein0_proc(Panel *p, Panel_item *pi, char *s);
void	sidein1_proc(Panel *p, Panel_item *pi, char *s);
void	reset_side(Panel *p, Panel_item *pi);
void	quit_side(Panel *p, Panel_item *pi);

void	ok(Panel *p, Panel_item *pi);
void	no(Panel *p, Panel_item *pi);
void	reset_choice(Panel *p, Panel_item *pi);
int	pi_name_proc(Panel *p, Panel_item *pi, char *s);
int	pi_srate_proc(Panel *p, Panel_item *pi, char *s);
void	compile(Panel *p, Panel_item *pi);
void	set_data(Panel *p, Panel_item *pi);
void	run(Panel *p, Panel_item *pi);
void	rescale(Panel *p, Panel_item *pi);
void	play(Panel *p, Panel_item *pi);
void	quit(Panel *p, Panel_item *pi);
void	reset_dat(Panel *p, Panel_item *pi);
void	quit_dat(Panel *p, Panel_item *pi);
int	datout_proc(Panel *p, Panel_item *pi, char *s);
int	datdur_proc(Panel *p, Panel_item *pi, char *s);
int	datamp_proc(Panel *p, Panel_item *pi, char *s);

void 	draw_menubar();
void	setup_menus();
void	oscil(Menu *m, Menu_item *mi);
void	buzz(Menu *m, Menu_item *mi);
void	rand(Menu *m, Menu_item *mi);
void	comb(Menu *m, Menu_item *mi);
void	elliptical(Menu *m, Menu_item *mi);
void	evp(Menu *m, Menu_item *mi);
void	pluck(Menu *m, Menu_item *mi);
void	reson(Menu *m, Menu_item *mi);
void	reverb(Menu *m, Menu_item *mi);
void	pitchtohertz(Menu *m, Menu_item *mi);
void	pitchtooct(Menu *m, Menu_item *mi);
void	hertztopitch(Menu *m, Menu_item *mi);
void	hertztooct(Menu *m, Menu_item *mi);
void	octtopitch(Menu *m, Menu_item *mi);
void	octtohertz(Menu *m, Menu_item *mi);
void	unlinkp(Menu *m, Menu_item *mi);
void	move_ugen(Menu *m, Menu_item *mi);
void	remove_ugen(Menu *m, Menu_item *mi);
void	framing(Menu *m, Menu_item *mi);
void	read_function(Menu *m, Menu_item *mi);

XWMHints xwmh= {
	(InputHint | StateHint),	/* flags */
	False,				/* input */
	NormalState,			/* initial_state */
	0,				/* icon pixmap */
	0,				/* icon window */
	0, 0,				/* icon location */
	0,				/* icon mask */
	0,				/* Window group */
};

extern ugen_str	ugen[MAX];
extern ugen_str temp_ugen;
extern data_str data;
int		ugen_no = 1, n_ugens = 0;
int		param_ugen_no;
int 		first,first_conn = 1,first_out = 1,first_add = 1;
int		first_sub = 1; first_mult = 1; first_div = 1;
int		first_ugen = 0;
int		firstx,firsty,firstvx,firstvy;
int		mbar_setting;

#else

extern Display *dpy;
extern XFontStruct *fontstruct, *fontstructS;
extern Window wwin, pwin, cwin, canvas_win, mwin, mbar_win;
extern Pixmap canvas_pm, mbar_pm;
extern GC canvas_gc, mbar_gc, sf_gc, clear_gc;

extern Panel *panel;
extern Panel_item *title;
extern Panel_item *pi_name, *pi_srate, *pi_inchans, *pi_outchans;
extern Panel_item *quit_button;
extern Panel_item *compile_button;
extern Panel_item *set_data_button;
extern Panel_item *run_button;
extern Panel_item *rescale_button;
extern Panel_item *play_button;
extern Panel_item *reset_button;
extern Panel_item *font_button;

extern Panel *qpanel;
extern Panel_item *qmsg;
extern Panel_item *ok_button;
extern Panel_item *no_button;

extern Panel *oscpanel;
extern Panel_item *osctitle;
extern Panel_item *oscamp;
extern Panel_item *oscfreq;
extern Panel_item *oscphs;
extern Panel_item *resetosc_button;
extern Panel_item *quitosc_button;

extern Panel *evppanel;
extern Panel_item *evptitle;
extern Panel_item *evpamp;
extern Panel_item *evprise;
extern Panel_item *evpdecay;
extern Panel_item *evpfunc;
extern Panel_item *resetevp_button;
extern Panel_item *quitevp_button;

extern Panel *buzzpanel;
extern Panel_item *buzztitle;
extern Panel_item *buzzamp;
extern Panel_item *buzzfreq;
extern Panel_item *buzznhar;
extern Panel_item *resetbuzz_button;
extern Panel_item *quitbuzz_button;

extern Panel *sidepanel;
extern Panel_item *title;
extern Panel_item *sidein0;
extern Panel_item *sidein1;
extern Panel_item *sidetoggle;
extern Panel_item *resetside_button;
extern Panel_item *quitside_button;

extern Panel *datpanel;
extern Panel_item *dattitle;
extern Panel_item *datout;
extern Panel_item *datdur;
extern Panel_item *datamp;
extern Panel_item *resetdat_button;
extern Panel_item *quitdat_button;

extern Canvas *canvas, *menu_bar;
extern int header_spaces;

extern Menu *generator_menu, *processor_menu, *connect_menu; 
extern Menu *options_menu, *help_menu, *converter_menu;

extern Textsw *text_read;

extern char *progname;
extern char font[20], small_font[20];
extern unsigned long black, white;
extern char *string;

extern XImage *dot_im, *oscil_im, *add_im, *subtract_im, *multiply_im, *divide_im, *out_im, *rect_im, *buzz_im, *evp_im;

extern int lx, ly;
extern int text, tx, ty;

extern int find_ugen(int, int);
extern param_str *find_ugen_param(int, int);
extern void ugen_select(int, int);
extern connector(int, int);

extern make_oscil(ugen_str *);
extern make_evp(ugen_str *);
extern make_buzz(ugen_str *);
extern make_out(ugen_str *);
extern make_side(ugen_str *);
extern make_rand(ugen_str *);
extern zone_oscil(ugen_str *);
extern zone_evp(ugen_str *);
extern zone_buzz(ugen_str *);
extern zone_out(ugen_str *);
extern zone_side(side_str *, int, int);
extern zone_rand(ugen_str *);
extern draw_oscil(int, int, int);
extern draw_evp(int, int, int);
extern draw_buzz(int, int, int);
extern draw_out(int);
extern draw_side(int, int, XImage*);
extern draw_rand(int, int, int);
extern pm_select(XPointerMovedEvent *);
extern bp_select(XButtonPressedEvent *);

extern void linker(int, ugen_str *);
extern void errx(char *);

extern void set_params(int, int);
extern void oscil_params(ugen_str *u);
extern void evp_params(ugen_str *u);
extern void buzz_params(ugen_str *u);
extern void side_params(ugen_str *u);

extern void oscamp_proc(Panel *p, Panel_item *pi, char *s);
extern void oscfreq_proc(Panel *p, Panel_item *pi, char *s);
extern void oscphs_proc(Panel *p, Panel_item *pi, char *s);
extern void reset_oscil(Panel *p, Panel_item *pi);
extern void quit_oscil(Panel *p, Panel_item *pi);

extern void evprise_proc(Panel *p, Panel_item *pi, char *s);
extern void evpamp_proc(Panel *p, Panel_item *pi, char *s);
extern void evpdecay_proc(Panel *p, Panel_item *pi, char *s);
extern void reset_evp(Panel *p, Panel_item *pi);
extern void quit_evp(Panel *p, Panel_item *pi);

extern void buzzamp_proc(Panel *p, Panel_item *pi, char *s);
extern void buzzfreq_proc(Panel *p, Panel_item *pi, char *s);
extern void buzznhar_proc(Panel *p, Panel_item *pi, char *s);
extern void reset_buzz(Panel *p, Panel_item *pi);
extern void quit_buzz(Panel *p, Panel_item *pi);

extern void sidein0_proc(Panel *p, Panel_item *pi, char *s);
extern void sidein1_proc(Panel *p, Panel_item *pi, char *s);
extern void reset_side(Panel *p, Panel_item *pi);
extern void quit_side(Panel *p, Panel_item *pi);

extern void no(Panel *p, Panel_item *pi);
extern void ok(Panel *p, Panel_item *pi);
extern void reset_choice(Panel *p, Panel_item *pi);
extern int  pi_name_proc(Panel *p, Panel_item *pi, char *s);
extern int  pi_srate_proc(Panel *p, Panel_item *pi, char *s);
extern void compile(Panel *p, Panel_item *pi);
extern void set_data(Panel *p, Panel_item *pi);
extern void run(Panel *p, Panel_item *pi);
extern void rescale(Panel *p, Panel_item *pi);
extern void play(Panel *p, Panel_item *pi);
extern void quit(Panel *p, Panel_item *pi);
extern int  datout_proc(Panel *p, Panel_item *pi);
extern int  datdur_proc(Panel *p, Panel_item *pi);
extern int  datamp_proc(Panel *p, Panel_item *pi);
extern void reset_dat(Panel *p, Panel_item *pi);
extern void quit_dat(Panel *p, Panel_item *pi);

extern void draw_menubar();
extern void setup_menus();

extern void oscil(Menu *m, Menu_item *mi);
extern void buzz(Menu *m, Menu_item *mi);
extern void randp(Menu *m, Menu_item *mi);
extern void comb(Menu *m, Menu_item *mi);
extern void elliptical(Menu *m, Menu_item *mi);
extern void evp(Menu *m, Menu_item *mi);
extern void pluck(Menu *m, Menu_item *mi);
extern void reson(Menu *m, Menu_item *mi);
extern void reverb(Menu *m, Menu_item *mi);
extern void pitchtohertz(Menu *m, Menu_item *mi);
extern void pitchtooct(Menu *m, Menu_item *mi);
extern void hertztopitch(Menu *m, Menu_item *mi);
extern void hertztooct(Menu *m, Menu_item *mi);
extern void octtopitch(Menu *m, Menu_item *mi);
extern void octtohertz(Menu *m, Menu_item *mi);
extern void linkp(Menu *m, Menu_item *mi);
extern void unlinkp(Menu *m, Menu_item *mi);
extern void move_ugen(Menu *m, Menu_item *mi);
extern void remove_ugen(Menu *m, Menu_item *mi);
extern void framing(Menu *m, Menu_item *mi);
extern void read_function(Menu *m, Menu_item *mi);

extern ugen_str	ugen[MAX];
extern ugen_str temp_ugen;
extern data_str data;
extern ugen_no, n_ugens, first_conn, first_out, first_add;
extern first_sub, first_mult, first_div;
extern first_ugen,first, param_ugen_no;
int    firstx,firsty,firstvx,firstvy;
int	mbar_setting;

#endif
