static char rcsid[] = "$Header: xmenu.c,v 1.3 90/09/08 12:50:48 mara Exp $";

/*  xmenu.c
 *
 *  Written by Mara Helmuth
 *
 *  Description: X graphics functions in C
 * 	called by graphics class
 *	for Cmix X graphical interface
 * 
 *  $Log:	xmenu.c,v $
 * Revision 1.3  90/09/08  12:50:48  mara
 * *** empty log message ***
 * 
 * Revision 1.2  90/09/05  22:11:50  mara
 * *** empty log message ***
 * 
 * Revision 1.1  90/08/27  17:10:15  mara
 * Initial revision
 * 
 * Revision 1.2  90/05/13  15:45:25  mara
 * *** empty log message ***
 * 
 * Revision 1.1  90/02/11  16:20:52  mara
 * Initial revision
 * 
 * Revision 1.3  90/02/04  12:14:07  mara
 * connector exits correctly, ugen array
 * passed to linker ok
 * 
 * Revision 1.2  90/01/30  10:59:11  mara
 * oscil graphics, side icons, ugen array structs 
 * calloced and sent to linker()
 * zone(), find_ugen(), find_ugen_param()
 * add_select(), preset_select(), out_select()
 * 
 * Revision 1.1  90/01/21  12:59:04  mara
 * Initial revision
 * 
 */

#include "plus.h"

void draw_menubar()
{
	static char *mbar_headers[] = {
		"GENERATOR",
		"PROCESSOR",
		"CONVERTER",
		"PARAMETER",
		"CONNECT",
		"OPTIONS",
		"HELP",
		0
	};
	int loc, offset, len, i;
	int frac = MFRAME_WIDTH/(header_spaces);
	loc = frac/2;

	mbar_pm = *((Pixmap *) canvas_get(menu_bar, LXC_PIXMAP));
	canvas_clear(menu_bar);

	for(i = 0; i < header_spaces; i++) {
		len = strlen(mbar_headers[i]);
		offset = XTextWidth(fontstruct, mbar_headers[i], len)*0.5;
		XDrawString(dpy, mbar_pm, mbar_gc, loc-offset, 25,
				mbar_headers[i], len);
		loc += frac;
	}
	canvas_flush(menu_bar);
}

void setup_menus()
{
	Menu_item *mi;

	/************ Create Generator Menu *****************************/

	if((generator_menu = menu_create(progname, dpy, mwin,
			LXM_TITLE, "Create Generator",
			LXM_NULL)) == (Menu *) NULL)
		exit(-1);
	if((mi = menuitem_create(LXMI_STRING, "Oscil",
			LXMI_PROC, oscil,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(generator_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Buzz",
			LXMI_PROC, buzz,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(generator_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Rrand",
			LXMI_PROC, randp,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(generator_menu, mi);

	/************ Create Processor Menu *****************************/

	/* add setline and delay (allpose & allpass, too?) */

	if((processor_menu = menu_create(progname, dpy, mwin,
			LXM_TITLE, "Create Processor",
			LXM_NULL)) == (Menu *) NULL)
		exit(-1);
	if((mi = menuitem_create(LXMI_STRING, "Comb",
			LXMI_PROC, comb,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(processor_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Elliptical",
			LXMI_PROC, elliptical,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(processor_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Evp",
			LXMI_PROC, evp,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(processor_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Pluck",
			LXMI_PROC, pluck,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(processor_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Reson",
			LXMI_PROC, reson,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(processor_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Reverb",
			LXMI_PROC, reverb,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(processor_menu, mi);

	/************* Converter Menu **************************************/

	if((converter_menu = menu_create(progname, dpy, mwin,
			LXM_TITLE, "CONVERTER",
			LXM_NULL)) == (Menu *) NULL)
		exit(-1);
	if((mi = menuitem_create(LXMI_STRING, "Pitch to Hertz",
			LXMI_PROC, pitchtohertz,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(converter_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Pitch to Oct",
			LXMI_PROC, pitchtooct,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(converter_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Hertz to Pitch",
			LXMI_PROC, hertztopitch,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(converter_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Hertz to Oct",
			LXMI_PROC, hertztooct,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(converter_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Oct to Pitch",
			LXMI_PROC, octtopitch,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(converter_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Oct to Hertz",
			LXMI_PROC, octtohertz,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(converter_menu, mi);

	/************* Connect Menu **************************************/

	if((connect_menu = menu_create(progname, dpy, mwin,
			LXM_TITLE, "CONNECT",
			LXM_NULL)) == (Menu *) NULL)
		exit(-1);
	if((mi = menuitem_create(LXMI_STRING, "Link",
			LXMI_PROC, linkp,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(connect_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Unlink",
			LXMI_PROC, unlinkp,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(connect_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Move Ugen",
			LXMI_PROC, move_ugen,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(connect_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Remove Ugen",
			LXMI_PROC, remove_ugen,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(connect_menu, mi);

	/************* Options Menu **************************************/

	if((options_menu = menu_create(progname, dpy, mwin,
			LXM_TITLE, "OPTIONS",
			LXM_NULL)) == (Menu *) NULL)
		exit(-1);
	if((mi = menuitem_create(LXMI_STRING, "Framing",
			LXMI_PROC, framing,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(options_menu, mi);
	if((mi = menuitem_create(LXMI_STRING, "Read Function",
			LXMI_PROC, read_function,
			LXMI_NULL)) == (Menu_item *) NULL)
		exit(-1);
	menuitem_insert(options_menu, mi);

	/*************** Help Menu **************************************/

	if((help_menu = menu_create(progname, dpy, mwin,
			LXM_TITLE, "HELP",
			LXM_NULL)) == (Menu *) NULL)
		exit(-1);

}

/*********** Menu Processes **************************************/

void generator(Menu *m, Menu_item *mi)
{
	printf("generator menuitem slected\n");
}

void oscil(Menu *m, Menu_item *mi)
{
	if(ugen[ugen_no].made)
		ugen_no++;
	printf("oscil menuitem selected\n");
	ugen[ugen_no].type = OSCIL;
	printf("ugen[ugen_no].type = %d\n",ugen[ugen_no].type);
	first = 1;
}

void buzz(Menu *m, Menu_item *mi)
{
	if(ugen[ugen_no].made)
		ugen_no++;
	printf("buzz menuitem selected\n");
	ugen[ugen_no].type = BUZZ;
	printf("ugen[ugen_no].type = %d\n",ugen[ugen_no].type);
	first = 1;
}

void randp(Menu *m, Menu_item *mi)
{
	if(ugen[ugen_no].made)
		ugen_no++;
	printf("rand menuitem selected\n");
	ugen[ugen_no].type = RAND;
	printf("ugen[ugen_no].type = %d\n",ugen[ugen_no].type);
	first = 1;
}

void processor(Menu *m, Menu_item *mi)
{
	printf("processor menuitem selected\n");
}

void comb(Menu *m, Menu_item *mi)
{
	printf("comb menuitem selected\n");
	first = 1;
	ugen[ugen_no].type = COMB;
}

void elliptical(Menu *m, Menu_item *mi)
{
	printf("elliptical menuitem selected\n");
	ugen[ugen_no].type = ELLIPTICAL;
	first = 1;
}

void evp(Menu *m, Menu_item *mi)
{
	if(ugen[ugen_no].made)
		ugen_no++;
	printf("ugen[ugen_no].type = %d\n",ugen[ugen_no].type);
	printf("evp menuitem selected\n");
	ugen[ugen_no].type = EVP;
	first = 1;
}

void pluck(Menu *m, Menu_item *mi)
{
	printf("pluck menuitem selected\n");
	ugen[ugen_no].type = PLUCK;
	first = 1;
}

void reson(Menu *m, Menu_item *mi)
{
	printf("reson menuitem selected\n");
	ugen[ugen_no].type = RESON;
	first = 1;
}

void reverb(Menu *m, Menu_item *mi)
{
	printf("reverb menuitem selected\n");
	ugen[ugen_no].type = REVERB;
	first = 1;
}

void pitchtohertz(Menu *m, Menu_item *mi)
{
	printf("cpspch menuitem selected\n");
}

void pitchtooct(Menu *m, Menu_item *mi)
{
	printf("octpch menuitem selected\n");
}

void hertztopitch(Menu *m, Menu_item *mi)
{
	printf("pchcps menuitem selected\n");
}

void hertztooct(Menu *m, Menu_item *mi)
{
	printf("octcps menuitem selected\n");
}

void octtopitch(Menu *m, Menu_item *mi)
{
	printf("pchoct menuitem selected\n");
}

void octtohertz(Menu *m, Menu_item *mi)
{
	printf("cpsoct menuitem selected\n");
}

void linkp(Menu *m, Menu_item *mi)
{
	printf("link menuitem selected\n");
}

void unlinkp(Menu *m, Menu_item *mi)
{
	printf("unlink menuitem selected\n");
}

void move_ugen(Menu *m, Menu_item *mi)
{
	printf("move ugen menuitem selected\n");
}

void remove_ugen(Menu *m, Menu_item *mi)
{
	printf("remove ugen menu selected\n");
}

void framing(Menu *m, Menu_item *mi)
{
	printf("framing menuitem selected\n");
}

void read_function(Menu *m, Menu_item *mi)
{
	printf("read function menuitem selected\n");
}

