static char rcsid[] = "$Header: xparam.c,v 1.6 91/02/13 09:47:16 mara Exp $";

/*  xparam.c
 *
 *  Written by Mara Helmuth
 *
 *  Description: Dialog windows for setting
 *	unit generator params and p-fields
 *	for Cmix X graphical interface
 * 
 *  $Log:	xparam.c,v $
 * Revision 1.6  91/02/13  09:47:16  mara
 * panel fixes
 * 
 * Revision 1.5  90/10/11  10:32:30  mara
 * *** empty log message ***
 * 
 * Revision 1.4  90/09/08  12:51:00  mara
 * side panel
 * 
 * Revision 1.3  90/09/07  20:51:06  mara
 * fm
 * 
 * Revision 1.2  90/09/02  18:20:01  mara
 * NeXT fixes
 * 
 * Revision 1.1  90/08/27  17:10:25  mara
 * Initial revision
 */

#include "plus.h"

void set_params(int x, int y)
{
	param_ugen_no = find_ugen(x,y);
	fprintf(stderr,"ugen %d found in set_params\n",param_ugen_no);
	switch(ugen[param_ugen_no].type) {
		case OSCIL:
			oscil_params(&ugen[param_ugen_no]);
			break;
		case EVP:
			evp_params(&ugen[param_ugen_no]);
			break;
		case BUZZ:
			buzz_params(&ugen[param_ugen_no]);
			break;
		case ADD:
		case SUBTRACT:
		case MULTIPLY:
		case DIVIDE:
			side_params(&ugen[param_ugen_no]);
			break;
		default:
			break;
	}
}

void oscil_params(ugen_str *u)
{
	int val;
printf("oscil_params: param_ugen_no = %d\n",param_ugen_no);
fprintf(stderr,"u->oscil->amp->value is %s\n",u->oscil->amp->value);

	strcpy(temp_ugen.oscil->amp->value,u->oscil->amp->value);
	strcpy(temp_ugen.oscil->freq->value,u->oscil->freq->value);
	strcpy(temp_ugen.oscil->phs->value,u->oscil->phs->value);
	temp_ugen.oscil->amp->in_ugen = u->oscil->amp->in_ugen;
	temp_ugen.oscil->freq->in_ugen = u->oscil->freq->in_ugen;
	temp_ugen.oscil->phs->in_ugen = u->oscil->phs->in_ugen;
	(void) panelitem_set(oscpanel, oscamp, LXPTEXT_VALUE, u->oscil->amp->value, LXPI_NULL);
	(void) panelitem_set(oscpanel, oscfreq, LXPTEXT_VALUE, u->oscil->freq->value, LXPI_NULL);
	(void) panelitem_set(oscpanel, oscphs, LXPTEXT_VALUE, u->oscil->phs->value, LXPI_NULL);

     	(void) panel_block(oscpanel, &val);
	     switch (val) {
		     case OK:
			     exit(0);
			     break;
		     case NO:
			     break;
		     default:
			     break;
	    }
}

void oscamp_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.oscil->amp->value,s);
	else if(strlen(temp_ugen.oscil->amp->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.oscil->amp->value[strlen(temp_ugen.oscil->amp->value) - 1] = '\0';
}

void
oscfreq_proc(Panel *p, Panel_item *pi, char *s)
{
printf("oscfreq_proc: param_ugen_no = %d\n",param_ugen_no);
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.oscil->freq->value,s);
	else if(strlen(temp_ugen.oscil->freq->value)) // if(s[0] == '\10')
		temp_ugen.oscil->freq->value[strlen(temp_ugen.oscil->freq->value) - 1] = '\0';

}

void
oscphs_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'z')
		strcat(temp_ugen.oscil->phs->value,s);
	else if(strlen(temp_ugen.oscil->phs->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.oscil->phs->value[strlen(temp_ugen.oscil->phs->value) - 1] = '\0';

}

void
reset_oscil(Panel *p, Panel_item *pi)
{
	(void) panelitem_set(oscpanel, oscamp, LXPTEXT_VALUE, "1" , LXPI_NULL);
	(void) panelitem_set(oscpanel, oscfreq, LXPTEXT_VALUE, "440" , LXPI_NULL);
	(void) panelitem_set(oscpanel, oscphs, LXPTEXT_VALUE, "0" , LXPI_NULL);
	
	strcpy(temp_ugen.oscil->amp->value,"1");
	strcpy(temp_ugen.oscil->freq->value,"440");
	strcpy(temp_ugen.oscil->phs->value,"0");
	temp_ugen.oscil->amp->in_ugen = 0;
	temp_ugen.oscil->freq->in_ugen = 0;
	temp_ugen.oscil->phs->in_ugen = 0;
}

void
quit_oscil(Panel *p, Panel_item *pi)
{
/* copy all into the ugen array */
printf("quit_oscil: param_ugen_no = %d\n",param_ugen_no);

	strcpy(ugen[param_ugen_no].oscil->amp->value,temp_ugen.oscil->amp->value);
	strcpy(ugen[param_ugen_no].oscil->freq->value,temp_ugen.oscil->freq->value);
	strcpy(ugen[param_ugen_no].oscil->phs->value,temp_ugen.oscil->phs->value);

fprintf(stderr,"amp: %s\n",ugen[param_ugen_no].oscil->amp->value);
fprintf(stderr,"freq: %s\n",ugen[param_ugen_no].oscil->freq->value);
fprintf(stderr,"phase: %s\n",ugen[param_ugen_no].oscil->phs->value);

	(void) panel_unblock(oscpanel, NO);
}

//*****************  EVP PARAMS **********************************

void evp_params(ugen_str *u)
{
	int val;
printf("evp_params: param_ugen_no = %d\n",param_ugen_no);
fprintf(stderr,"u->evp->amp->value is %s\n",u->evp->amp->value);

	strcpy(temp_ugen.evp->amp->value,u->evp->amp->value);
	strcpy(temp_ugen.evp->rise->value,u->evp->rise->value);
	strcpy(temp_ugen.evp->decay->value,u->evp->decay->value);
	strcpy(temp_ugen.evp->nfunc->value,u->evp->nfunc->value);
	temp_ugen.evp->amp->in_ugen = u->evp->amp->in_ugen;
	temp_ugen.evp->rise->in_ugen = u->evp->rise->in_ugen;
	temp_ugen.evp->decay->in_ugen = u->evp->decay->in_ugen;
	temp_ugen.evp->nfunc->in_ugen = u->evp->nfunc->in_ugen;
	(void) panelitem_set(evppanel, evpamp, LXPTEXT_VALUE, u->evp->amp->value, LXPI_NULL);
	(void) panelitem_set(evppanel, evprise, LXPTEXT_VALUE, u->evp->rise->value, LXPI_NULL);
	(void) panelitem_set(evppanel, evpdecay, LXPTEXT_VALUE, u->evp->decay->value, LXPI_NULL);
	(void) panelitem_set(evppanel, evpfunc, LXPENUM_VALUE, u->evp->nfunc->value, LXPI_NULL);

     	(void) panel_block(evppanel, &val);
	     switch (val) {
		     case OK:
			     exit(0);
			     break;
		     case NO:
			     break;
		     default:
			     break;
	    }
}

void evpamp_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.evp->amp->value,s);
	else if(strlen(temp_ugen.evp->amp->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.evp->amp->value[strlen(temp_ugen.evp->amp->value) - 1] = '\0';
}

void
evprise_proc(Panel *p, Panel_item *pi, char *s)
{
printf("evprise_proc: param_ugen_no = %d\n",param_ugen_no);
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.evp->rise->value,s);
	else if(strlen(temp_ugen.evp->rise->value)) // if(s[0] == '\10')
		temp_ugen.evp->rise->value[strlen(temp_ugen.evp->rise->value) - 1] = '\0';

}

void
evpdecay_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'z')
		strcat(temp_ugen.evp->decay->value,s);
	else if(strlen(temp_ugen.evp->decay->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.evp->decay->value[strlen(temp_ugen.evp->decay->value) - 1] = '\0';

}

void
reset_evp(Panel *p, Panel_item *pi)
{
	(void) panelitem_set(evppanel, evpamp, LXPTEXT_VALUE, "1" , LXPI_NULL);
	(void) panelitem_set(evppanel, evprise, LXPTEXT_VALUE, "440" , LXPI_NULL);
	(void) panelitem_set(evppanel, evpdecay, LXPTEXT_VALUE, "0" , LXPI_NULL);
	
	strcpy(temp_ugen.evp->amp->value,"1");
	strcpy(temp_ugen.evp->rise->value,".1");
	strcpy(temp_ugen.evp->decay->value,".1");
	strcpy(temp_ugen.evp->nfunc->value,"0");
	temp_ugen.evp->amp->in_ugen = 0;
	temp_ugen.evp->rise->in_ugen = 0;
	temp_ugen.evp->decay->in_ugen = 0;
	temp_ugen.evp->nfunc->in_ugen = 0;
}

void
quit_evp(Panel *p, Panel_item *pi)
{
/* copy all into the ugen array */
printf("quit_evp: param_ugen_no = %d\n",param_ugen_no);

	strcpy(ugen[param_ugen_no].evp->amp->value,temp_ugen.evp->amp->value);
	strcpy(ugen[param_ugen_no].evp->rise->value,temp_ugen.evp->rise->value);
	strcpy(ugen[param_ugen_no].evp->decay->value,temp_ugen.evp->decay->value);
	strcpy(ugen[param_ugen_no].evp->nfunc->value,temp_ugen.evp->nfunc->value);

fprintf(stderr,"QUIT_EVP amp: %s\n",ugen[param_ugen_no].evp->amp->value);
fprintf(stderr,"amp: %s\n",ugen[param_ugen_no].evp->amp->value);
fprintf(stderr,"rise: %s\n",ugen[param_ugen_no].evp->rise->value);
fprintf(stderr,"decay: %s\n",ugen[param_ugen_no].evp->decay->value);
fprintf(stderr,"nfunc: %s\n",ugen[param_ugen_no].evp->nfunc->value);

	(void) panel_unblock(evppanel, NO);
}
//*****************  BUZZ PARAMS **********************************
void buzz_params(ugen_str *u)
{
	int val;
printf("buzz_params: param_ugen_no = %d\n",param_ugen_no);
fprintf(stderr,"u->buzz->amp->value is %s\n",u->buzz->amp->value);

	strcpy(temp_ugen.buzz->amp->value,u->buzz->amp->value);
	strcpy(temp_ugen.buzz->freq->value,u->buzz->freq->value);
	strcpy(temp_ugen.buzz->nhar->value,u->buzz->nhar->value);
printf("after strcpy\n");
	temp_ugen.buzz->amp->in_ugen = u->buzz->amp->in_ugen;
	temp_ugen.buzz->freq->in_ugen = u->buzz->freq->in_ugen;
	temp_ugen.buzz->nhar->in_ugen = u->buzz->nhar->in_ugen;
printf("after set temp in-ug\n");
	(void) panelitem_set(buzzpanel, buzzamp, LXPTEXT_VALUE, u->buzz->amp->value, LXPI_NULL);
	(void) panelitem_set(buzzpanel, buzzfreq, LXPTEXT_VALUE, u->buzz->freq->value, LXPI_NULL);
	(void) panelitem_set(buzzpanel, buzznhar, LXPTEXT_VALUE, u->buzz->nhar->value, LXPI_NULL);

printf("after panelitem_sets\n");
     	(void) panel_block(buzzpanel, &val);
	     switch (val) {
		     case OK:
			     exit(0);
			     break;
		     case NO:
			     break;
		     default:
			     break;
	    }
}

void buzzamp_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.buzz->amp->value,s);
	else if(strlen(temp_ugen.buzz->amp->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.buzz->amp->value[strlen(temp_ugen.buzz->amp->value) - 1] = '\0';
}

void
buzzfreq_proc(Panel *p, Panel_item *pi, char *s)
{
printf("buzzfreq_proc: param_ugen_no = %d\n",param_ugen_no);
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.buzz->freq->value,s);
	else if(strlen(temp_ugen.buzz->freq->value)) // if(s[0] == '\10')
		temp_ugen.buzz->freq->value[strlen(temp_ugen.buzz->freq->value) - 1] = '\0';

}

void
buzznhar_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'z')
		strcat(temp_ugen.buzz->nhar->value,s);
	else if(strlen(temp_ugen.buzz->nhar->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.buzz->nhar->value[strlen(temp_ugen.buzz->nhar->value) - 1] = '\0';

}

void
reset_buzz(Panel *p, Panel_item *pi)
{
	(void) panelitem_set(buzzpanel, buzzamp, LXPTEXT_VALUE, "1" , LXPI_NULL);
	(void) panelitem_set(buzzpanel, buzzfreq, LXPTEXT_VALUE, "440" , LXPI_NULL);
	(void) panelitem_set(buzzpanel, buzznhar, LXPTEXT_VALUE, "8" , LXPI_NULL);
	
	strcpy(temp_ugen.buzz->amp->value,"1");
	strcpy(temp_ugen.buzz->freq->value,"440");
	strcpy(temp_ugen.buzz->nhar->value,"8");
	temp_ugen.buzz->amp->in_ugen = 0;
	temp_ugen.buzz->freq->in_ugen = 0;
	temp_ugen.buzz->nhar->in_ugen = 0;
}

void
quit_buzz(Panel *p, Panel_item *pi)
{
/* copy all into the ugen array */
printf("quit_buzz: param_ugen_no = %d\n",param_ugen_no);

	strcpy(ugen[param_ugen_no].buzz->amp->value,temp_ugen.buzz->amp->value);
	strcpy(ugen[param_ugen_no].buzz->freq->value,temp_ugen.buzz->freq->value);
	strcpy(ugen[param_ugen_no].buzz->nhar->value,temp_ugen.buzz->nhar->value);

fprintf(stderr,"amp: %s\n",ugen[param_ugen_no].buzz->amp->value);
fprintf(stderr,"freq: %s\n",ugen[param_ugen_no].buzz->freq->value);
fprintf(stderr,"phase: %s\n",ugen[param_ugen_no].buzz->nhar->value);

	(void) panel_unblock(buzzpanel, NO);
}

//**************** SIDE PARAMS ************************************
void side_params(ugen_str *u)
{
	int val;
printf("side_params: param_ugen_no = %d\n",param_ugen_no);
fprintf(stderr,"u->side->in0->value is %s\n",u->side->in0->value);
fprintf(stderr,"u->side->in1->value is %s\n",u->side->in1->value);

	strcpy(temp_ugen.side->in0->value,u->side->in0->value);
	strcpy(temp_ugen.side->in1->value,u->side->in1->value);
	(void) panelitem_set(sidepanel, sidein0, LXPTEXT_VALUE, u->side->in0->value, LXPI_NULL);
	(void) panelitem_set(sidepanel, sidein1, LXPTEXT_VALUE, u->side->in1->value, LXPI_NULL);

     	(void) panel_block(sidepanel, &val);
	     switch (val) {
		     case OK:
			     exit(0);
			     break;
		     case NO:
			     break;
		     default:
			     break;
	    }
}

void sidein0_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.side->in0->value,s);
	else if(strlen(temp_ugen.side->in0->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.side->in0->value[strlen(temp_ugen.side->in0->value) - 1] = '\0';
}

void sidein1_proc(Panel *p, Panel_item *pi, char *s)
{
	if(s[0] >= '.' && s[0] <= 'A')
		strcat(temp_ugen.side->in1->value,s);
	else if(strlen(temp_ugen.side->in1->value)) // if(s[0] == '\10')
	//else if(s[0] == '\10')
		temp_ugen.side->in1->value[strlen(temp_ugen.side->in1->value) - 1] = '\0';
}

void reset_side(Panel *p, Panel_item *pi)
{
	(void) panelitem_set(sidepanel, sidein0, LXPTEXT_VALUE, "1" , LXPI_NULL);
	(void) panelitem_set(sidepanel, sidein1, LXPTEXT_VALUE, "1" , LXPI_NULL);
	
	strcpy(temp_ugen.side->in0->value,"1");
	strcpy(temp_ugen.side->in1->value,"1");
}

void quit_side(Panel *p, Panel_item *pi)
{
/* copy all into the ugen array */
printf("quit_side: param_ugen_no = %d\n",param_ugen_no);

	strcpy(ugen[param_ugen_no].side->in0->value,temp_ugen.side->in0->value);
	strcpy(ugen[param_ugen_no].side->in1->value,temp_ugen.side->in1->value);

fprintf(stderr,"in0: %s\n",ugen[param_ugen_no].side->in0->value);
fprintf(stderr,"in1: %s\n",ugen[param_ugen_no].side->in1->value);

	(void) panel_unblock(sidepanel, NO);
}
