static char rcsid[] = "$Header: xselect.c,v 1.5 91/02/13 09:47:24 mara Exp $";

/*  xselect.c
 *
 *  Written by Mara Helmuth
 *
 *  Description: Select appropriate unit generator
 *	and params for Cmix X graphical interface
 * 
 *  $Log:	xselect.c,v $
 * Revision 1.5  91/02/13  09:47:24  mara
 * panel fixes
 * 
 * Revision 1.4  90/10/11  10:32:35  mara
 * *** empty log message ***
 * 
 * Revision 1.3  90/09/05  22:12:36  mara
 * many fixes, reset, +,-,*,/ ugens work
 * 
 * Revision 1.2  90/09/02  18:20:13  mara
 * NeXT fixes
 * 
 * Revision 1.1  90/08/27  17:10:30  mara
 * Initial revision
 * 
 */


#include "plus.h"

void ugen_select(int x, int y)
{
	int vx, vy;

	vx= *((int *) canvas_get(canvas, LXC_XOFFSET));
	vy= *((int *) canvas_get(canvas, LXC_YOFFSET));

	if(ugen[ugen_no].connected) 
		return;

	ugen[ugen_no].x = x;
	ugen[ugen_no].y = y;

	if((x + vx) < 72 && (y + vy) < 290) { 
		return;
	}
	switch(ugen[ugen_no].type) {
		case OSCIL:
			if(!ugen[ugen_no].made)
				make_oscil(&ugen[ugen_no]);
			zone_oscil(&ugen[ugen_no]);
			draw_oscil(ugen_no,vx,vy);
			break;
		case EVP:
			if(!ugen[ugen_no].made)
				make_evp(&ugen[ugen_no]);
			zone_evp(&ugen[ugen_no]);
			draw_evp(ugen_no,vx,vy);
			break;
		case RAND:
			if(!ugen[ugen_no].made)
				make_rand(&ugen[ugen_no]);
			zone_rand(&ugen[ugen_no]);
			draw_rand(ugen_no,vx,vy);
			break;
		case BUZZ:
			if(!ugen[ugen_no].made)
				make_buzz(&ugen[ugen_no]);
			zone_buzz(&ugen[ugen_no]);
			draw_buzz(ugen_no,vx,vy);
			break;
		case OUT:
			if(!ugen[ugen_no].made)
				make_out(&ugen[ugen_no]);
			zone_out(&ugen[ugen_no]);
			draw_out(ugen_no);
			break;
		case ADD:
			if(!ugen[ugen_no].made)
				make_side(&ugen[ugen_no]);
			ugen[ugen_no].side->type = ADD;
			zone_side(ugen[ugen_no].side,ugen[ugen_no].x,
				ugen[ugen_no].y);
			draw_side(ugen_no,first_add,add_im);
			first_add = 0;
			break;
		case SUBTRACT:
			if(!ugen[ugen_no].made)
				make_side(&ugen[ugen_no]);
			ugen[ugen_no].side->type = SUBTRACT;
			zone_side(ugen[ugen_no].side,ugen[ugen_no].x,
				ugen[ugen_no].y);
			draw_side(ugen_no,first_sub,subtract_im);
			first_sub = 0;
			break;
		case MULTIPLY:
			if(!ugen[ugen_no].made)
				make_side(&ugen[ugen_no]);
			ugen[ugen_no].side->type = MULTIPLY;
			zone_side(ugen[ugen_no].side,ugen[ugen_no].x,
				ugen[ugen_no].y);
			draw_side(ugen_no,first_mult,multiply_im);
			first_mult = 0;
			break;
		case DIVIDE: 
			if(!ugen[ugen_no].made)
				make_side(&ugen[ugen_no]);
			ugen[ugen_no].side->type = DIVIDE;
			zone_side(ugen[ugen_no].side,ugen[ugen_no].x,
				ugen[ugen_no].y);
			draw_side(ugen_no,first_div,divide_im);
			first_div = 0;
			break;
		default:
			fprintf(stderr,"ugen:select: No ugen specified\n");
			break;
	}

	first = 0;
	if(n_ugens < ugen_no)
		n_ugens = ugen_no;
	canvas_flush(canvas);
}

make_oscil(ugen_str *u)
{
	if(!(u->oscil = (oscil_str *)calloc(1,sizeof(oscil_str))))
		errx("make_oscil");
	if(!(u->oscil->amp = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_oscil");
	if(!(u->oscil->freq = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_oscil");
	if(!(u->oscil->phs = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_oscil");
	if(!(u->oscil->out = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_oscil");

	strcpy(u->oscil->amp->value,"1");
	strcpy(u->oscil->freq->value,"440");	/* default value */
	strcpy(u->oscil->phs->value,"0");	/* default value */
	u->oscil->amp->in_ugen = 0;
	u->oscil->freq->in_ugen = 0;
	u->oscil->phs->in_ugen = 0;
	u->made = 1;
}

make_evp(ugen_str *u)
{
	if(!(u->evp = (evp_str *)calloc(1,sizeof(evp_str))))
		errx("make_evp");
	if(!(u->evp->amp = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_evp");
	if(!(u->evp->rise = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_evp");
	if(!(u->evp->decay = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_evp");
	if(!(u->evp->nfunc = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_evp");
	if(!(u->evp->out = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_evp");

	strcpy(u->evp->amp->value,"1");
	strcpy(u->evp->rise->value,".1");	/* default value */
	strcpy(u->evp->decay->value,".1");
	strcpy(u->evp->nfunc->value,"0");
	u->evp->amp->in_ugen = 0;
	u->evp->rise->in_ugen = 0;
	u->evp->decay->in_ugen = 0;
	u->evp->nfunc->in_ugen = 0;
	u->made = 1;
}

make_buzz(ugen_str *u)
{
printf("make_buzz\n");
	if(!(u->buzz = (buzz_str *)calloc(1,sizeof(buzz_str))))
		errx("make_buzz");
	if(!(u->buzz->amp = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_buzz");
	if(!(u->buzz->freq = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_buzz");
	if(!(u->buzz->nhar = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_buzz");
	if(!(u->buzz->out = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_buzz");

	strcpy(u->buzz->amp->value,"1");
	strcpy(u->buzz->freq->value,"440");	/* default value */
	strcpy(u->buzz->nhar->value,"8");	/* default value */
	u->buzz->amp->in_ugen = 0;
	u->buzz->freq->in_ugen = 0;
	u->buzz->nhar->in_ugen = 0;
	u->made = 1;
}

make_out(ugen_str *u)
{
	if(!(u->out = (out_str *)calloc(1,sizeof(out_str))))
		errx("out_select");
	if(!(u->out->in = (param_str *)calloc(1,sizeof(param_str))))
		errx("out_select");
	u->made = 1;
}

make_side(ugen_str *u)
{
	if(!(u->side = (side_str *)calloc(1,sizeof(side_str))))
		errx("make_side");
	if(!(u->side->in0 = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_side");
	if(!(u->side->in1 = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_side");
	if(!(u->side->out = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_side");
	u->made = 1;
	strcpy(u->side->in0->value,"1.");
	strcpy(u->side->in1->value,"1.");
}

make_rand(ugen_str *u)
{
printf("make rand");
	if(!(u->rand = (rand_str *)calloc(1,sizeof(rand_str))))
		errx("make_rand");
	if(!(u->rand->out = (param_str *)calloc(1,sizeof(param_str))))
		errx("make_rand");
	u->made = 1;
}

zone_oscil(ugen_str *u)
{
	int x,y;
	int xoff = 37;
	int yoff = 37;

	x = ugen[ugen_no].x;
	y = ugen[ugen_no].y;

#ifdef	WOOF
	u->oscil->amp->x = x + 27;
	u->oscil->amp->y = y + 22;
	u->oscil->freq->x = x + 66;
	u->oscil->freq->y = y + 22;
	u->oscil->phs->x = x + 99;
	u->oscil->phs->y = y + 34;
	u->oscil->out->x = x + 50;
	u->oscil->out->y = y + 90;
#else
	u->oscil->amp->x = x + 26-xoff;
	u->oscil->amp->y = y + 10-yoff;
	u->oscil->freq->x = x + 47-xoff;
	u->oscil->freq->y = y + 10-yoff;
	u->oscil->phs->x = x + 72-xoff;
	u->oscil->phs->y = y + 17-yoff;
	u->oscil->out->x = x + 37-xoff;
	u->oscil->out->y = y + 74-yoff;
#endif
}

zone_evp(ugen_str *u)
{
	int x,y;
	int xoff = 37;
	int yoff = 37;

	x = ugen[ugen_no].x;
	y = ugen[ugen_no].y;

#ifdef	WOOF
	u->evp->amp->x = x + 28;
	u->evp->amp->y = y + 13;
	u->evp->rise->x = x + 10;
	u->evp->rise->y = y + 22;
	u->evp->decay->x = x + 99;
	u->evp->decay->y = y + 34;
	u->evp->out->x = x + 50;
	u->evp->out->y = y + 90;
#else
	u->evp->amp->x = x + 28-xoff;
	u->evp->amp->y = y + 13-yoff;
	u->evp->rise->x = x + 10-xoff;
	u->evp->rise->y = y + 24-yoff;
	u->evp->decay->x = x + 62-xoff;
	u->evp->decay->y = y + 24-yoff;
	u->evp->out->x = x + 36-xoff;
	u->evp->out->y = y + 50-yoff;
#endif
}

zone_buzz(ugen_str *u)
{
printf("zone_buzz\n");
	int x,y;
	int xoff = 37;
	int yoff = 37;

	x = ugen[ugen_no].x;
	y = ugen[ugen_no].y;

#ifdef	WOOF
	u->buzz->amp->x = x + 27;
	u->buzz->amp->y = y + 22;
	u->buzz->freq->x = x + 66;
	u->buzz->freq->y = y + 22;
	u->buzz->nhar->x = x + 99;
	u->buzz->nhar->y = y + 34;
	u->buzz->out->x = x + 50;
	u->buzz->out->y = y + 90;
#else
	u->buzz->amp->x = x + 26-xoff;
	u->buzz->amp->y = y + 10-yoff;
	u->buzz->freq->x = x + 47-xoff;
	u->buzz->freq->y = y + 10-yoff;
	u->buzz->nhar->x = x + 72-xoff;
	u->buzz->nhar->y = y + 17-yoff;
	u->buzz->out->x = x + 37-xoff;
	u->buzz->out->y = y + 74-yoff;
#endif
}

zone_rand(ugen_str *u)
{
printf("zone_rand\n");
	int x,y;
	int xoff = 37;
	int yoff = 37;

	x = ugen[ugen_no].x;
	y = ugen[ugen_no].y;

#ifdef	WOOF
	u->rand->out->x = x + 50;
	u->rand->out->y = y + 90;
#else
	u->rand->out->x = x + 37-xoff;
	u->rand->out->y = y + 74-yoff;
#endif
}

zone_out(ugen_str *u)
{
	int x,y;
	int xoff = 18;
	int yoff = 18;

	x = ugen[ugen_no].x;
	y = ugen[ugen_no].y;

#ifdef	WOOF
	u->out->in->x = x + 25;	
	u->out->in->y = y + 10;	
#else		
	u->out->in->x = x + 18-xoff;	
	u->out->in->y = y + 3-yoff;	
#endif
}

zone_side(side_str *u,int x, int y)
{
	int xoff = 18;
	int yoff = 18;

#ifdef	WOOF
	u->in0->x = x + 20;
	u->in0->y = y + 4;
	u->in1->x = x + 30;
	u->in1->y = y + 4;
	u->out->x = x + 25;
	u->out->y = y + 47;
#else	
	u->in0->x = x + 14 - xoff;
	u->in0->y = y + 4 - yoff;
	u->in1->x = x + 22 - xoff;
	u->in1->y = y + 4 - yoff;
	u->out->x = x + 18 -xoff;
	u->out->y = y + 33 -yoff;
#endif
}

draw_oscil(int ugen_no,int vx, int vy)
{
	XImage *last_im;
	int ug_size = UBITMAP_SIZE;

#ifdef 	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 37;
	int yoff = 37;
#endif

#ifdef	WOOF

	if (!first) {   /* erase last image */
		XPutImage(dpy, canvas_pm, canvas_gc, oscil_im, 0, 0, lx, ly,
			500, 500);
		XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "oscil", 5);
		XDrawString(dpy, canvas_win, sf_gc, lx+25, ly+60, "oscil", 5);

		XDrawString(dpy, canvas_pm, sf_gc, lx+15, ly+10, "amp", 3);
		XDrawString(dpy, canvas_win, sf_gc, lx+15-vx, ly+10-vy, "amp", 3);
		XDrawString(dpy, canvas_pm, sf_gc, lx+50, ly+10, "freq", 4);
		XDrawString(dpy, canvas_win, sf_gc, lx+50-vx, ly+10-vy, "freq", 4);
		XDrawString(dpy, canvas_pm, sf_gc, lx+100, ly+25, "phs", 3);
		XDrawString(dpy, canvas_win, sf_gc, lx+100-vx, ly+25-vy, "phs", 3);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, oscil_im, 0, 0, lx, ly,
		100, 100);
	XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "oscil", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+25-vx, ly+60-vy, "oscil", 5);

	XDrawString(dpy, canvas_pm, sf_gc, lx+15, ly+10, "amp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+15-vx, ly+10-vy, "amp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx+50, ly+10, "freq", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+50-vx, ly+10-vy, "freq", 4);
	XDrawString(dpy, canvas_pm, sf_gc, lx+100, ly+25, "phs", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+100-vx, ly+25-vy, "phs", 3);
	first = 0;
#else
	if (!first) {   /* erase last image */
		XFillRectangle(dpy, canvas_pm, clear_gc, lx-xoff-5,ly-yoff-5,
			ug_size+35,ug_size);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, oscil_im, 0, 0, lx-xoff, ly-yoff,
		ug_size, ug_size);
	XDrawString(dpy, canvas_pm, sf_gc, lx+20-xoff, ly+35-yoff, 
		"oscil", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+20-xoff, ly+35-yoff,
		"oscil", 5);
	XDrawString(dpy, canvas_pm, sf_gc, lx+11-xoff, 
		ly+5-yoff, "amp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+11-xoff-vx, 
		ly+5-yoff-vy, "amp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx+40-xoff, ly+5-yoff, 
		"freq", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+40-xoff-vx, 
		ly+5-yoff-vy, "freq", 4);
	XDrawString(dpy, canvas_pm, sf_gc, lx+77-xoff, 
		ly+17-yoff, "phs", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+77-xoff-vx, 
		ly+17-yoff-vy, "phs", 3);
	first = 0;
#endif
}

draw_evp(int ugen_no,int vx, int vy)
{
	XImage *last_im;
	int ug_size = UBITMAP_SIZE;

#ifdef 	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 37;
	int yoff = 37;
#endif

#ifdef	WOOF

	if (!first) {   /* erase last image */
		XPutImage(dpy, canvas_pm, canvas_gc, evp_im, 0, 0, lx, ly,
			500, 500);
		XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "evp", 5);
		XDrawString(dpy, canvas_win, sf_gc, lx+25, ly+60, "evp", 5);

		XDrawString(dpy, canvas_pm, sf_gc, lx+15, ly+10, "amp", 3);
		XDrawString(dpy, canvas_win, sf_gc, lx+15-vx, ly+10-vy, "amp", 3);
		XDrawString(dpy, canvas_pm, sf_gc, lx+50, ly+10, "freq", 4);
		XDrawString(dpy, canvas_win, sf_gc, lx+50-vx, ly+10-vy, "freq", 4);
		XDrawString(dpy, canvas_pm, sf_gc, lx+100, ly+25, "phs", 3);
		XDrawString(dpy, canvas_win, sf_gc, lx+100-vx, ly+25-vy, "phs", 3);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, evp_im, 0, 0, lx, ly,
		100, 100);
	XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "evp", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+25-vx, ly+60-vy, "evp", 5);

	XDrawString(dpy, canvas_pm, sf_gc, lx+15, ly+10, "amp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+15-vx, ly+10-vy, "amp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx+50, ly+10, "freq", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+50-vx, ly+10-vy, "freq", 4);
	XDrawString(dpy, canvas_pm, sf_gc, lx+100, ly+25, "phs", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+100-vx, ly+25-vy, "phs", 3);
	first = 0;
#else
	if (!first) {   /* erase last image */
		XFillRectangle(dpy, canvas_pm, clear_gc, lx-xoff-15,ly-yoff-5,
			ug_size+45,ug_size);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, evp_im, 0, 0, lx-xoff, ly-yoff,
		ug_size, ug_size);
	XDrawString(dpy, canvas_pm, sf_gc, lx+26-xoff, ly+40-yoff, 
		"evp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+26-xoff, ly+40-yoff,
		"evp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx+13-xoff, 
		ly+10-yoff, "amp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+13-xoff-vx, 
		ly+10-yoff-vy, "amp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx-15-xoff, ly+24-yoff, 
		"rise", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx-15-xoff-vx, 
		ly+24-yoff-vy, "rise", 4);
	XDrawString(dpy, canvas_pm, sf_gc, lx+62-xoff, 
		ly+24-yoff, "decay", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+62-xoff-vx, 
		ly+24-yoff-vy, "decay", 5);
	XDrawString(dpy, canvas_pm, sf_gc, lx+40-xoff, 
		ly+10-yoff, "dur", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+40-xoff-vx, 
		ly+10-yoff-vy, "dur", 3);
	first = 0;
#endif
}

draw_buzz(int ugen_no,int vx, int vy)
{
	XImage *last_im;
	int ug_size = UBITMAP_SIZE;

#ifdef 	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 37;
	int yoff = 37;
#endif

#ifdef	WOOF

	if (!first) {   /* erase last image */
		XPutImage(dpy, canvas_pm, canvas_gc, buzz_im, 0, 0, lx, ly,
			500, 500);
		XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "buzz", 5);
		XDrawString(dpy, canvas_win, sf_gc, lx+25, ly+60, "buzz", 5);

		XDrawString(dpy, canvas_pm, sf_gc, lx+15, ly+10, "amp", 3);
		XDrawString(dpy, canvas_win, sf_gc, lx+15-vx, ly+10-vy, "amp", 3);
		XDrawString(dpy, canvas_pm, sf_gc, lx+50, ly+10, "freq", 4);
		XDrawString(dpy, canvas_win, sf_gc, lx+50-vx, ly+10-vy, "freq", 4);
		XDrawString(dpy, canvas_pm, sf_gc, lx+100, ly+25, "nhar", 3);
		XDrawString(dpy, canvas_win, sf_gc, lx+100-vx, ly+25-vy, "nhar", 3);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, buzz_im, 0, 0, lx, ly,
		100, 100);
	XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "buzz", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+25-vx, ly+60-vy, "buzz", 4);

	XDrawString(dpy, canvas_pm, sf_gc, lx+15, ly+10, "amp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+15-vx, ly+10-vy, "amp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx+50, ly+10, "freq", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+50-vx, ly+10-vy, "freq", 4);
	XDrawString(dpy, canvas_pm, sf_gc, lx+100, ly+25, "nhar", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+100-vx, ly+25-vy, "nhar", 4);
	first = 0;
#else
printf("beg non-woof\n");
	if (!first) {   /* erase last image */
		XFillRectangle(dpy, canvas_pm, clear_gc, lx-xoff-5,ly-yoff-5,
			ug_size+35,ug_size);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, buzz_im, 0, 0, lx-xoff, ly-yoff,
		ug_size, ug_size);
	XDrawString(dpy, canvas_pm, sf_gc, lx+20-xoff, ly+35-yoff, 
		"buzz", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+20-xoff, ly+35-yoff,
		"buzz", 5);
	XDrawString(dpy, canvas_pm, sf_gc, lx+11-xoff, 
		ly+5-yoff, "amp", 3);
	XDrawString(dpy, canvas_win, sf_gc, lx+11-xoff-vx, 
		ly+5-yoff-vy, "amp", 3);
	XDrawString(dpy, canvas_pm, sf_gc, lx+40-xoff, ly+5-yoff, 
		"freq", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+40-xoff-vx, 
		ly+5-yoff-vy, "freq", 4);
	XDrawString(dpy, canvas_pm, sf_gc, lx+77-xoff, 
		ly+17-yoff, "nhar", 4);
	XDrawString(dpy, canvas_win, sf_gc, lx+77-xoff-vx, 
		ly+17-yoff-vy, "nhar", 4);
	first = 0;
#endif
printf("end draw_buzz\n");
}

draw_out(int ugen_no)
{
	int ug_size = UBITMAP_SIZE;
#ifdef	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 18;
	int yoff = 18;
#endif

#ifdef	WOOF

	if(first_out) {
		XPutImage(dpy, canvas_pm, canvas_gc, out_im, 0, 0, 0, 310,
			50, 50);
	}
	else {
	XPutImage(dpy, canvas_pm, canvas_gc, out_im, 0, 0, lx, ly,
		50, 50);
	}
	first_out = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;
	XPutImage(dpy, canvas_pm, canvas_gc, out_im, 0, 0, lx, ly,
		100, 100);
#else

	if(first_out) {
		XPutImage(dpy, canvas_pm, canvas_gc, out_im, 0, 0, 0, 250,
			36, 36);
	}
	else {
		XFillRectangle(dpy, canvas_pm, clear_gc, lx-xoff,ly-yoff,
			ug_size,ug_size);
	}
	first_out = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;
	XPutImage(dpy, canvas_pm, canvas_gc, out_im, 0, 0, lx-xoff, ly-yoff,
		ug_size, ug_size);
#endif
}

int draw_side(int ugen_no, int f, XImage *im)
{		// f is first flag
	int ug_size = SBITMAP_SIZE;
#ifdef	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 18;
	int yoff = 18;
#endif
	if(!f && (lx-xoff > 40 || ly-yoff > 290)) 
		XFillRectangle(dpy, canvas_pm, clear_gc, lx-xoff,ly-yoff,
			ug_size,ug_size);
	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	if(lx-xoff > 40 || ly-yoff > 290) 
		XPutImage(dpy, canvas_pm, canvas_gc, im, 0, 0, 
			lx-xoff, ly-yoff, ug_size, ug_size);
}

draw_rand(int ugen_no,int vx, int vy)
{
printf("draw_rand\n");
	XImage *last_im;
	int ug_size = UBITMAP_SIZE;

#ifdef 	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 37;
	int yoff = 37;
#endif

#ifdef	WOOF

	if (!first) {   /* erase last image */
		XPutImage(dpy, canvas_pm, canvas_gc, rect_im, 0, 0, lx, ly,
			500, 500);
		XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "rrand", 5);
		XDrawString(dpy, canvas_win, sf_gc, lx+25, ly+60, "rrand", 5);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, rect_im, 0, 0, lx, ly,
		100, 100);
	XDrawString(dpy, canvas_pm, sf_gc, lx+25, ly+60, "rrand", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+25-vx, ly+60-vy, "rrand", 5);
	first = 0;
#else
	if (!first) {   /* erase last image */
		XFillRectangle(dpy, canvas_pm, clear_gc, lx-xoff-5,ly-yoff-5,
			ug_size+35,ug_size);
	}
	first = 0;

	lx = ugen[ugen_no].x;
	ly = ugen[ugen_no].y;

	XPutImage(dpy, canvas_pm, canvas_gc, rect_im, 0, 0, lx-xoff, ly-yoff,
		ug_size, ug_size);
	XDrawString(dpy, canvas_pm, sf_gc, lx+20-xoff, ly+35-yoff, 
		"rrand", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+20-xoff, ly+35-yoff,
		"rrand", 5);
	XDrawString(dpy, canvas_win, sf_gc, lx+77-xoff-vx, 
		ly+17-yoff-vy, "phs", 3);
	first = 0;
#endif
}

connector(int x, int y)
{
	int vx, vy;
	param_str *param;

	if(!(param = (param_str *)calloc(1,sizeof(param_str)))) 
		errx("connector");

	vx= *((int *) canvas_get(canvas, LXC_XOFFSET));
	vy= *((int *) canvas_get(canvas, LXC_YOFFSET));

	if(first_conn) {
		if((first_ugen = find_ugen(x,y)) > n_ugens) 
			return 0;
		XPutImage(dpy, canvas_pm, canvas_gc, dot_im, 0, 0, x-6, y-6,
			12, 12);
		firstx = x;
		firsty = y;
		firstvx = vx;
		firstvy = vy;
		first_conn = 0;
	}
	else {
		if((param = find_ugen_param(x,y))) {
			XPutImage(dpy, canvas_pm, canvas_gc, dot_im, 0, 0, 
				x-6, y-6, 12, 12);
			XDrawLine(dpy, canvas_pm, canvas_gc, firstx, firsty, 
				x, y);
			XDrawLine(dpy, canvas_win, canvas_gc, firstx-firstvx, 
				firsty-firstvy, x-vx, y-vy);
			first_conn = 1;
			param->in_ugen = first_ugen;
			ugen[first_ugen].connected = 1;
		}
		else 
			return 0;
	}

	canvas_flush(canvas);
}

find_ugen(int x, int y) /* finds ugen number when given canvas coordinates */
{
	int i;
	int ug_b = 20;  /* ugen border area of zone */
	int ug_size = UBITMAP_SIZE;

#ifdef	WOOF
	int xoff = 0;
	int yoff = 0;
#else
	int xoff = 37;
	int yoff = 37;
#endif

	for(i = 0; i <= n_ugens + 1; i++) 
		if(x > ugen[i].x - ug_b - xoff && x < ugen[i].x+ug_size + ug_b -xoff && y > ugen[i].y - ug_b - yoff && y < ugen[i].y+ug_size + ug_b - yoff)  
			break;
	return(i);
}


param_str* find_ugen_param(int x, int y) /* return ugen param */
{
	int i;
#ifdef	WOOF
	int ug_b = 30, p_b = 10;  /* ugen & param border area of zone */
#else
	int ug_b = 20, p_b = 10;  /* ugen & param border area of zone */
#endif

	i = find_ugen(x, y);
	if(i == MAX) {
	       return 0;
	}

	switch(ugen[i].type) {
		case OSCIL: 
			if(x > ugen[i].oscil->amp->x - p_b && x < ugen[i].oscil->amp->x + p_b && y > ugen[i].oscil->amp->y - p_b && y < ugen[i].oscil->amp->y + p_b) {
				printf("oscil amp selected\n");
				ugen[i].connected = 1;
				return(ugen[i].oscil->amp);
			}
			if(x > ugen[i].oscil->freq->x - p_b && x < ugen[i].oscil->freq->x + p_b && y > ugen[i].oscil->freq->y - p_b && y < ugen[i].oscil->freq->y + p_b) {
				printf("oscil freq selected\n");
				ugen[i].connected = 1;
				return(ugen[i].oscil->freq);
			}
			if(x > ugen[i].oscil->phs->x - p_b && x < ugen[i].oscil->phs->x + p_b && y > ugen[i].oscil->phs->y - p_b && y < ugen[i].oscil->phs->y + p_b) {
				printf("oscil phs selected\n");
				ugen[i].connected = 1;
				return(ugen[i].oscil->phs);
			}
			else if(x > ugen[i].oscil->out->x - p_b && x < ugen[i].oscil->out->x + p_b && y > ugen[i].oscil->out->y - p_b && y < ugen[i].oscil->out->y + p_b) {
				printf("oscil out selected\n");
				ugen[i].connected = 1;
				return(ugen[i].oscil->out);
			}
			else printf("oscil: no conn selected\n");
			return 0;
			break;

		case EVP: 
			if(x > ugen[i].evp->amp->x - p_b && x < ugen[i].evp->amp->x + p_b && y > ugen[i].evp->amp->y - p_b && y < ugen[i].evp->amp->y + p_b) {
				printf("evp amp selected\n");
				ugen[i].connected = 1;
				return(ugen[i].evp->amp);
			}
/*
			if(x > ugen[i].evp->rise->x - p_b && x < ugen[i].evp->rise->x + p_b && y > ugen[i].evp->rise->y - p_b && y < ugen[i].evp->rise->y + p_b) {
				printf("evp rise selected\n");
				ugen[i].connected = 1;
				return(ugen[i].evp->rise);
			}
			if(x > ugen[i].evp->decay->x - p_b && x < ugen[i].evp->decay->x + p_b && y > ugen[i].evp->decay->y - p_b && y < ugen[i].evp->decay->y + p_b) {
				printf("evp decay selected\n");
				ugen[i].connected = 1;
				return(ugen[i].evp->decay);
			}
*/
			else if(x > ugen[i].evp->out->x - p_b && x < ugen[i].evp->out->x + p_b && y > ugen[i].evp->out->y - p_b && y < ugen[i].evp->out->y + p_b) {
				printf("evp out selected\n");
				ugen[i].connected = 1;
				return(ugen[i].evp->out);
			}
			else printf("evp: no valid conn selected\n");
			return 0;
			break;

		case BUZZ: 
			if(x > ugen[i].buzz->amp->x - p_b && x < ugen[i].buzz->amp->x + p_b && y > ugen[i].buzz->amp->y - p_b && y < ugen[i].buzz->amp->y + p_b) {
				printf("buzz amp selected\n");
				ugen[i].connected = 1;
				return(ugen[i].buzz->amp);
			}
			if(x > ugen[i].buzz->freq->x - p_b && x < ugen[i].buzz->freq->x + p_b && y > ugen[i].buzz->freq->y - p_b && y < ugen[i].buzz->freq->y + p_b) {
				printf("buzz freq selected\n");
				ugen[i].connected = 1;
				return(ugen[i].buzz->freq);
			}
			if(x > ugen[i].buzz->nhar->x - p_b && x < ugen[i].buzz->nhar->x + p_b && y > ugen[i].buzz->nhar->y - p_b && y < ugen[i].buzz->nhar->y + p_b) {
				printf("buzz nhar selected\n");
				ugen[i].connected = 1;
				return(ugen[i].buzz->nhar);
			}
			else if(x > ugen[i].buzz->out->x - p_b && x < ugen[i].buzz->out->x + p_b && y > ugen[i].buzz->out->y - p_b && y < ugen[i].buzz->out->y + p_b) {
				printf("buzz out selected\n");
				ugen[i].connected = 1;
				return(ugen[i].buzz->out);
			}
			else printf("buzz: no conn selected\n");
			return 0;
			break;

		case ADD:
		case SUBTRACT:
		case MULTIPLY:
		case DIVIDE:
			if(ugen[i].side->num_ins == 0 && x > ugen[i].side->in0->x - p_b && x < ugen[i].side->in0->x + p_b && y > ugen[i].side->in0->y - p_b && y < ugen[i].side->in0->y + p_b) {
				printf("side in0 selected\n");
				ugen[i].side->num_ins++;
				ugen[i].connected = 1;
				return(ugen[i].side->in0);
			}
			else if(x > ugen[i].side->in1->x - p_b && x < ugen[i].side->in1->x + p_b && y > ugen[i].side->in1->y - p_b && y < ugen[i].side->in1->y + p_b) {
				printf("side in1 selected\n");
				ugen[i].side->num_ins++;
				ugen[i].connected = 1;
				return(ugen[i].side->in1);
			}
			else if(x > ugen[i].side->out->x - p_b && x < ugen[i].side->out->x + p_b && y > ugen[i].side->out->y - p_b && y < ugen[i].side->out->y + p_b) {
				printf("side out selected\n");
				ugen[i].connected = 1;
				return(ugen[i].side->out);
			}
			else printf("side: no conn selected\n");
			return 0;
			break;
		case OUT:
			printf("out->in selected\n");
			ugen[i].connected = 1;
			return(ugen[i].out->in);
			break;
		default:
			printf("find_ugen_param: some other ugen selected\n");
			return 0;
			break;
	}
}				
