{\rtf0\ansi{\fonttbl\f0\fswiss Helvetica;\f2\fmodern Courier;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 /* The Archie application subclass.  It is responsible for document\
	management and maintains application objects such as Preferences\
	and error NXStringTables. */\
#ifndef ARCHIEAPP_H\
#define ARCHIEAPP_H\
#import <appkit/Application.h>\
\
@interface ArchieApp : Application\
\{\
	/* Reference to the Workspace object 
{{\NeXTHelpLink311 \markername ;\linkFilename CodeHelp.rtf;\linkMarkername workspace;}
}\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 */\
	id <NXWorkspaceRequestProtocol> workspace;\
\
	id preferences;	// The application Preferences object\
\
	/* Help Panel outlets */\
	id helpPanelID;		// The help panel\
	id helpScrollViewID;	// The ScrollView in the help panel\
\
	/* Other variables */\
	id msgStringTable;	// An NXStringTable of the program error messages\
	id errStringTable;	// An NXStringTable of the program error messages\
	id infoPanelID;		// The application info Panel\
	const char *sendTypes[2];	// The data types we can put on pasteboard\
\
\}\
\
/*\\ ---------------------- Document Menu Actions ---------------------- \\*/\
- new: sender;\
- open: sender;\
- saveAll: sender;\
\
/*\\ ----------------------- Panel Display Methods ----------------------- \\*/\
/* Bring up the info panel */\
- infoPanel: sender;\
\
/* Display the query options panel */\
- preferences: sender;\
\
/*\\ ------------------------ Pasteboard Methods ------------------------ \\*/\
/* Access GatorFTP+ to initiate an anonymous ftp session via\
	the services menu when a host is selected in the browser */\
- validRequestorForSendType:(NXAtom)typeSent\
	andReturnType:(NXAtom)typeReturned;\
\
/* Write the currently selected hostname to the pasteboard */\
- (BOOL)writeSelectionToPasteboard:pboard types:(NXAtom *)types;\
\
/*\\ --------------------- App Value Access Methods --------------------- \\*/\
- preferences;\
/* Return the application NXStringTable of error messages */\
- errTable;\
- msgTable;\
\
/*\\ ---------------------- App Delegate Methods ---------------------- \\*/\
- appDidInit: sender;\
- appDidUnhide: sender;\
- (BOOL)appAcceptsAnotherFile:sender;\
- (int)app:sender openFile:(const char *)filename type:(const char *)aType;\
- appWillTerminate: sender;\
\
/*\\ ---------------------- Menu Update Methods ---------------------- \\*/\
- (BOOL) menuItemUpdate: menuCell;\
- (BOOL)validateCommand: menuCell;\
\
@end\
\
/*\\ -------------------- Error & Debugging Categories -------------------- \\*/\
#import "errMessages.keys"\
#import "appMessages.keys"\
#import "Object_AllocNDebug.h"\
\
#endif ARCHIEAPP_H\
/* RCS Information:\
	$Author: $;\
	$Date: $;\
	$Source: $;\
	$Revision: $;\
	$Log$;\
*/\

}
