// GeoClient.h
// By Charles G. Fleming, Educational Computing Services, Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.
// This work was partially supported by a grant from the Vira Heinz Endowment.

#import <appkit/Window.h>

@interface GeoClient:Window
{
    id loginMessageWindow;
    id searchingMessageWindow;
    id errorMessageWindow;
    id errorMessageScrollView;
    id queryButton;
    id statesPullDownListButton;
    id statesPullDownList;
    id moreStatesPullDownListButton;
    id moreStatesPullDownList;
    id	cityTextField;
    id stateTextField;
    id countyCodeTextField;
    id countyNameTextField;
    id stateAbbrTextField;
    id stateNameTextField;
    id nationAbbrTextField;
    id nationNameTextField;
    id areaCodeTextField;
    id elevationTextField;
    id featureCodeTextField;
    id featureNameTextField;
    id latitudeTextField;
    id longitudeNameTextField;
    id censusTextField;
    id remarkTextField;
    id timeZoneTextField;
    id zipScrollView;
    id subprocess;
    id records;
    struct dataRecord
    {
        char city[30];
	char countyCode[30];
	char countyName[30];
	char stateAbbr[30];
	char stateName[30]; 
        char nationAbbr[30];
	char nationName[30];
	char areaCode[30];
	char elevation[30];
	char featureCode[30]; 
	char featureName[30]; 
        char latitude[30];
	char longitude[30];  
	char census[30];
	char remark[30];
	char timeZone[30];
	char zip[4000]; 
    } record;		
}

- appDidInit:sender;
- query:sender;
- selectState:sender;
- clearTextFields;
- resetPullDownList;
- subprocessOutput:(char *)buffer;
- subprocessDone;
- appWillTerminate:sender;
- selectState:sender;
@end
