/*
 * Simple default handler.
 * M. J. Hawley
 * mike@media-lab.mit.edu
 * Copyright (c) November 1991, MIT Media Laboratory.
 */
#import "DefaultHandler.h"
#import <defaults/defaults.h>
#import <appkit/Application.h>

extern id NXApp;

@implementation DefaultHandler

#define appname [NXApp appName]

char DefaultFont[256] = "Courier";
char DefaultFontSize[32] = "14.";

static NXDefaultsVector Defaults = {
    {"Font",  DefaultFont},
    {"FontSize", DefaultFontSize },
    {NULL}
};

char *
deflt(char *s){
    return (char *)NXGetDefaultValue(appname,s);
}

+ loadDefaults {
    char *s;
    s = deflt("Font"); if (s && *s) strcpy(DefaultFont,s);
    s = deflt("FontSize"); if (s && *s) strcpy(DefaultFontSize,s);
    return self;
}

+ initialize {
    NXRegisterDefaults(appname, Defaults);
    [self loadDefaults];
    return self;
}

- writeDefaults:sender {
    NXWriteDefaults(appname, Defaults);
    return self;
}

- free {
    [self writeDefaults:self];
    [super free];
    return self;
}
@end
