/*	LDPlayer.h
	15 February 1993
	Eric Celeste / AppTech / 5 Exeter Street / Belmont, MA 02178
	efc@mit.edu
	See .m file for details. Please send me any improvements.
	This class is designed to be subclassed.
*/
#import <appkit/appkit.h>
#import "SerialPort.h"

@interface LDPlayer:Object
{
	char problem[1000];
	id port;
	id delegate;
	BOOL allOK;
}

////////////////////////////////////////////// Housekeeping Methods
- initDevice:(const char *)device baud:(int)rate;
- free;
////////////////////////////////////////////// Delegation Methods
- setDelegate:anObject;
- delegate;
////////////////////////////////////////////// Error Reporting Methods
- reportProblem:(const char *)string;
- (const char *)problemString;
////////////////////////////////////////////// Override these Control Methods
- searchForChapter:(int)chapter;
- searchForFrame:(int)frame;
- still;
- halt;
- eject;
- playForward;
- playBack;
- fastForward;
- fastBack;
- slowForward;
- slowBack;
- scanForward;
- scanBack;
- frameForward;
- frameBack;
- playFrom:(int)inFrame to:(int)outFrame repeating:(int)times;
- motor:(BOOL)on;
- index:(BOOL)on;
- channelOne:(BOOL)on;
- channelTwo:(BOOL)on;
- mute:(BOOL)on;
- noiseReduction:(BOOL)on;
- clearAll;
////////////////////////////////////////////// Inquiry Methods
- (int)currentFrame;
@end
