#include <strings.h>

char *CommandHelp[] = {
    "Title search: \"Rowing\" finds all items beginning with \"Rowing...\"\n\
\"Rowing for the hell of it\" finds that book.  Punctuation, upper/lower case, and \"the\", \"an\", \"a\" at the start of a title, will be ignored.",
    "Author search: \"lastname firstname\" as in, \"king stephen\".  Some items have more than one author, or an organization as the author (\"Sierra Club\").",
    "Call number: assigned by libraries to cluster works on similar topics.  Length roughly indicates depth in the topical hierarchy; e.g., \"Z124\" is about printing, and \"Z124.C\" is about the chronology of printing.",
    "ISBN: enter the international standard book number, e.g., \"0-226-13791-0\"",
    "ISSN: enter the international standard serial number, e.g., \"0010-9898\" (and include the hyphen)",
    "LCCN: enter the library of congress card number (8 digits).",
    "OCLC: enter the OCLC, RLIN, or WLN number (8 digits).",
    "Reference number: includes CODEN, Original Study #, Standard Film #, Publisher\"s # for Music, Standard Recording #, Standard Technical Report #, Stock #.  Use spaces and punctuation.",
0
};

char *CommandC = "TACINLOR";

int queryType = 0;

#define TitleQ  0
#define AuthorQ 1
#define CallQ   2
#define ISBNQ   3
#define ISSNQ   4
#define LCCNQ   5
#define OCLCQ   6
#define RefQ    7

void
setFormat(s) char *s; {
    if (!s) return;
    if (strcmp(s,"title")==0)  queryType = TitleQ;  else
    if (strcmp(s,"author")==0) queryType = AuthorQ; else
    if (strcmp(s,"call #")==0) queryType = CallQ;   else
    if (strcmp(s,"ISBN")==0)   queryType = ISBNQ;   else
    if (strcmp(s,"ISSN")==0)   queryType = ISSNQ;   else
    if (strcmp(s,"LCCN")==0)   queryType = LCCNQ;   else
    if (strcmp(s,"OCLC")==0)   queryType = OCLCQ;   else
    if (strcmp(s,"ref #")==0)  queryType = RefQ;    else
    queryType = TitleQ;
}

#define Case break; case

char *skipsp(), *strippunct(), *stripnondigit();
extern strtolower(), stripnl(), sprintf();

char *
fixTitle(s) char *s; {
    strtolower(s);
    if (strncmp(s,"the ",4)==0) s = skipsp(s+4); else
    if (strncmp(s,"an ",3)==0)  s = skipsp(s+3); else
    if (strncmp(s,"a ",2)==0)   s = skipsp(s+2);
    return s;
}

char *
cmdHelpText(){
    return CommandHelp[queryType];
}

char *
fixQuery(s) char *s; {
    static char t[1024];
    sprintf(t,"%c=",CommandC[queryType]);
    stripnl(s);
    s=skipsp(s);
    switch(queryType){
    Case TitleQ:  strcat(t,fixTitle(s));
    Case AuthorQ: strcat(t,s);
    Case CallQ:   strcat(t,s);   
    Case ISBNQ:   strcat(t,stripnondigit(s));
    Case ISSNQ:   strcat(t,s);
    Case LCCNQ:   strcat(t,s);
    Case OCLCQ:   strcat(t,s);
    Case RefQ:    strcat(t,s);
    }
    return t;
}

