/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/

#import <objc/Object.h>
#import <appkit/Menu.h>
#import <appkit/MenuCell.h>
#import <objc/List.h>
#import "IArticleD.h"
#import "IMMEditor.h"

@interface IAppDelegate:Object
{
    id		oSaveMenuCell;
    id          oRecursiveSaveMenuCell;
    id          oSaveAsMenuCell;
    id		oPostMenuCell;
    id          oRecursivePostMenuCell;
    id		oPrintMenuCell;
    id          oFindMenuCell;
    id          oEditMenuCell;
    id		oRedisplayMenuCell;
    id          oEditorReMenuCell;
    id		oEditorGetReMenuCell;
    id          oCloseMenuCell;
    Menu	*sendSubmenu;
    IMMEditor	*editor;
    int         previousContext;
    int         myContext;
    id          oFindText;
    id          oFindCase;
    id		iHelpPanel;
    id		iInfoPanel;
}

- init;

- appDidInit:sender;

- appWillTerminate:sender;

- sendArticle:sender;

- saveArticle:sender;

- postArticle:(const char *)articleBuffer length:(int)length;

- sendArticleFrom:sender toIOClass:(Class)ioClass;

- printArticle:sender;

- getArticleWithMessageID:sender;

- closeAllEditorWindows:sender;

- openEditor:sender;

- openHelpPanel:sender;

- editorDidBecomeKey:sender;

- editorDidResignKey:sender;

- getReferenceListOfArticle:sender;

- setOEditorReMenuCell:editorReMenuCell;

- (int)requestForPost:(char *) newsgroups sourceWindow:(int)wnum;

- setPreviousContext:(int)context;

- (int)previousContext;

- setMyContext:(int)context;
  
@end

