#import "IOrderedListD.h"
#import <objc/hashtable.h>
//#import "IMMEditor.h"
#import "IExternalD.h"
#import <appkit/NXImage.h>
//#import "IMMEditor.h"

#define AA_DISK "local-file"

// Every article has an IExternalD object.  An IExternalD object is used to
// reference articles in other articles.  The external also maintains the
// reference counts.
//
// An article also may or may not have a editor/viewer.  I.e., an article
// may be created without an editor/viewer or an article may be detached
// from its editor viewer.
//
// There are now three lists to maintain:
//
//    1) The lists of all objects except externals (IArticleD)
//    2) The lists of external objects             (externals)
//    3) The lists of graphic objects only         (objects)
//

@interface IArticleD:IOrderedListD
{
    id editor;
    IExternalD *external;
    int objectCount;               // count of objects
    List *externals;               // list of external objects
    List *objects;                 // list of media objects
}

+ (NXAtom)fileExtension;

+ (NXAtom)pasteboardType;

+ editorWillBeFreed:editor;
  
- (IExternalD *)external;
  
- setExternal:(IExternalD *)theExternal;

- openEditor;

- editor;
  
- setEditor:theEditor;

- editorWillClose:sender;
  
- recursiveSaveToDomain:(NXAtom)domain;

- referenceAllObjects;
  
- unreferenceAllObjects;

- setObjectCount:(int)count;

- (int)objectCount;

- (List *)externalsList;

- (List *)objectsList;

@end


