#import "IOrderedListD.h"
#import <objc/hashtable.h>
#import <appkit/NXImage.h>
//#import "IMMEditor.h"

struct artaddr {                    // address of article
    struct artaddr *aa_next;        // NULL if last
    NXAtom aa_domain;               // e.g., local disk, usenet news, ftp
    int aa_status;                  // e.g., dirty
    char aa_name[1];                // e.g., path, message id, path@host
};

#define AS_DIRTY_MASK (1 << 1)

@interface IExternalD:Object
{
    struct artaddr *addrlist;       // article may exists in serveral places
    struct artaddr *curaddr;        // current load address
    const char *curkey;             // current key for current domain
    id object;                      // Non-nil, if object is loaded
    id editor;                      // Non-nil, if object has viewer
    int size;
    int refCount;                   // article may be multiply referenced
}

+ setIcon:(NXImage *)theIcon;

+ (NXAtom)fileExtension;

+ (NXAtom)pasteboardType;

+ (NXImage *)icon;

+ externalExistsWithDomain:(NXAtom)domain andPath:(const char *)path;
  
- initWithDomain:(NXAtom)domain andPath:(const char *)path;

- setDomain:(NXAtom)domain andPath:(const char *)path;
  
- (const char *)key;

- (const char *)keyForDomain:(NXAtom)domain isDirty:(BOOL *)dirtyFlag;
  
- (BOOL)hasDomain:(NXAtom)domain andPath:(const char *)path;
  
- (NXAtom)currentDomain;

- (const char *)currentPath;

- (NXImage *)image;

- setReferenceCount:(int)newCount;

- (int)referenceCount;

- (int)incrementReferenceCount;

- (int)decrementReferenceCount;

- (unsigned int)size;

- object;
  
- setObject:theObject;

- objectExists;
  
- performDoubleClickAction:sender;

- performDoubleClickAction2:sender;

- markAsDirty;
  
@end

