// IGraphicImage.h
// By K.Lue
// ISR Multimedia Application Group
//
//
// Original source code from NeXT, ImageText
//

#import <objc/Object.h>
#import <appkit/graphics.h>
#import <dpsclient/event.h>
#import <streams/streams.h>
#import "IMediaD.h"
#import <appkit/Pasteboard.h>
#import "INewsBaseText.h"
#import <sys/param.h>

@interface IGraphicImage:Object
{
    id			image;
    INewsBaseText	*text;
    id			mediaObject;	// link to media data object
    NXPoint     	origin;
    BOOL        	highlighted;
    BOOL		imageResizingEnabled;
    BOOL		isActiveEmbeddedView;
}

+ setList:aList;
+ setCounter:(int *)aCounter;

- initFromFile:(const char *)pathName forView:(View *)view
    withIcon:(NXImage *)icon;
- initFromPasteboard:(Pasteboard *)pasteboard forView:view;
- calcCellSize:(NXSize *)theSize;
- highlight:(const NXRect *)cellFrame inView:controlView lit:(BOOL)flag;
- drawSelf:(const NXRect *)cellFrame inView:controlView;
- trackMouse:(NXEvent *)theEvent inRect:(const NXRect *)cellFrame
  ofView:controlView;
- readRichText:(NXStream *)stream forView:view;
- writeRichText:(NXStream *)stream forView:view;
- setIsActiveEmbeddedView:(BOOL)flag;
- free;
- mediaObject;
- (INewsBaseText *)view;
- getOrigin:(NXPoint *)anOrigin;
  
@end
