#import <appkit/Text.h>
#import <appkit/Form.h>
#import <appkit/Button.h>
#import <appkit/ClientInputManager.h>
#import "IArticleD.h"

struct mediaObjectDescriptor {
    int magic;
    char key[256];
    char type[16];
    int size;
};

#define MEDIA_OBJECT_DESCRIPTOR_MAGIC 920314

@interface INewsBaseText:Text
{
    IArticleD   	*article;
    int			size;
    BOOL                isMultimedia;
    BOOL        	isEditable;
    List		*embeddedViewControllers;
    BOOL        	needsSaving;
    Form		*articleSizeField;
    Button              *plainMultimediaButton;
    const char 		*selectionFileName;
    BOOL                draggedIconBelongsToMe;
#ifdef KANJI
    ClientInputManager	*inputManager;
#endif /* KANJI */
    BOOL                textIsFreeing;
}

- (int)iconEntered:(int)windowNum at:(double)x :(double)y
    iconWindow:(int)iconWindowNum iconX:(double)iconX iconY:(double)iconY
    iconWidth:(double)iconWidth iconHeight:(double)iconHeight
    pathList:(const char *)pathList;

- (int)iconReleasedAt:(double)x :(double)y ok:(int *)flag;

- (int)iconExitedAt:(double)x :(double)y;

- setArticle:(IArticleD *)anArticle;

- (IArticleD *)article;

- setIsMultimedia:(BOOL)flag;

- (BOOL)isMultimedia;

- setIsEditable:(BOOL)flag;

- (BOOL)isEditable;

- addEmbeddedViewController:controller;

- removeEmbeddedViewController:controller;

- (List *)embeddedViewControllers;

- (BOOL)hasEmbeddedView;

- setNeedsSaving:(BOOL)flag;

- (BOOL)needsSaving;

- setArticleSize:(int)newSize;

- (int)addToArticleSize:(int)increment;

- displaySize;

- displaySize:dummy;

- setArticleSizeField:(Form *)aForm;

- setPlainMultimediaButton:(Button *)aButton;

- drainEventQueue;

- setSelectionFileName:(const char *)fileName;

- setOwnerOfDraggedIconToMe:(BOOL)flag;

- setTextIsFreeing;

- (BOOL)textIsFreeing;

- find:(const char *)string forward:(BOOL)dirFlag ignoreCase:(BOOL)caseFlag;
  
- (const char *)selection;
  
@end
