/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/
/* ITextD.m */

#import "IKeyedObject.h"
#import <stdio.h>

enum MemoryType {MALLOC, VM_ALLOCATE};

@interface ITextD:IKeyedObject
{
    char		*text;	// memory allocated by vm_allocate()
    int			size;
    int			maxSize;
}

- setTextData:(char *)data size:(int)length maxSize:(int)maxLength;
//
// data should have been allocated by vm_allocate() and will be owned by the 
// receiving object.
//

//- kanjiCodeConvert:(char *)conv_option;
///*
// *  convert kanji code acording to option
// *	conv_option:	jis_to_euc: convert jis kanji code to euc code
// *			euc_to_jis: convert euc to jis
// */

- (BOOL)readFromFile:(const char *)pathName;

- (BOOL)readFromStream:(NXStream *)stream;

- (BOOL)readFromTarStream:(NXStream *)stream;

- (void)writeToStream:(NXStream *)stream;

- (void)writeToTarStream:(NXStream *)stream;

- writeRichTextStreamTo:ktextObj;
/*
 *  copy text data to text object
 *  ITextD will give the text data stream to Text obj.
 *	ktextObj:	text obj. id.
 *	return:		self
 */

- writeTextStreamTo:ktextObj;
/*
 *  copy text data to text object
 *  ITextD will give the text data stream to Text obj.
 *  this method is same as "-writeRichTextStreamTo" but for data is plain text
 *	ktextObj:	text obj. id.
 *	return:		self
 */

- (char *)textData;

- (unsigned int)size;

- (int)countLine;

- (int)width;

@end
