#import <stddef.h>
#import <objc/objc.h>
//
//  TO ADD A NEW MEDIA TYPE TO NEWSBASE DO THE FOLLOWING:
//
//	1. select an RTF control word. e.g. "MMtiff".
//	2. select a file extension to be used for the data files. e.g. "tiff"
//	3. select a pasteboard type to be used for the selection pasteboard.
//         e.g. NXTIFFPboardType.
//	4. create a subclass of IMediaD
//		e.g., ITiffD.h ITiffD.m
//		Please see IMediaD for details of implementing this subclass.
//	5. add an entry for your new media type to the table below
//	6. recompile and relink NewsBase with your new class

const char *mediaClassNameTable[] = {
    "ITextD",	// not a true media class but useful here for I/O handling
    "InfoD",	// not a true media class but useful here for I/O handling
    "ITiffD",
    "IEpsD",
    "IGifD",
    "ISndD",
    "IBinaryD",
    "IVdrD",
    "IJfifD",
    "IArticleD",
    "ILocalFileD",
    "INewsD",
    NULL
};

// Although ITextD and InfoD are not media classes their input/output methods
// are compatible with media classes and it is useful to have this table used
// for specifying input/output methods for all data objects.  IArticleD is
// also not a true media class but also supports compatible methods for
// input/output.

Class MediaClassTable[sizeof(mediaClassNameTable)/sizeof(const char *)];

//
//  TO ADD A NEW IO CLASS TO NEWSBASE DO THE FOLLOWING:
//
//	1. TO BE DEFINED!
//      5. add an entry for your new IO class to the table below
//      6. recompile and relink NewsBase with your new class

char *ioBaseClassNameTable[] = {
    "IDiskBase",
    "INewsBase",
    NULL
};

const char *externalClassNameTable[] = {
    "ILocalFileD",
    "INewsD",
    NULL,
    "IFtp"
};

Class ExternalModuleTable[sizeof(externalClassNameTable) /
     sizeof(const char *)];
     


