/*
 *      You may freely copy, distribute and reuse the code
 *      in this example.  Scott Anguish disclaims any warranty of
 *      any kind, expressed or implied, as to its fitness
 *      for any particular use.
 *		Please keep this notice intact
 *      Written by: Scott Anguish  sanguish@digifix.com
 */

#import <objc/Object.h>
#import <appkit/appkit.h>
#import <libc.h>					  /* MAXPATHLEN */
#import <objc/List.h>

@interface MMCell:Cell
{
	id MMView;
	char attachmentName[MAXPATHLEN+1];
	char attachmentPath[MAXPATHLEN+1];
	int attachmentSize;
	char *attachmentData;
	id	theImage;
	BOOL	displayContents;
	BOOL uuencoded;
}


- free;
- initFromFilename:(const char *)filename;
- imageFromAttachment;
- imageFromFilename:(const char *)filename;

- calcCellSize:(NXSize *)theSize;
- highlight:(const NXRect *)cellFrame inView:controlView lit:(BOOL)flag;

 
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

- writeRichText:(NXStream *)stream forView:view;
- readPrivate:(NXStream *)stream name:(char *)name;
- readRichText:(NXStream *)stream forView:view;

 - (BOOL)trackMouse:(NXEvent *)theEvent 
	inRect:(const NXRect *)cellFrame 
	ofView:controlView;
- drawInside: (const NXRect *)cellFrame inView:controlView;
- uudecodeAttachment;
- removeData;

@end
