/*
 *      You may freely copy, distribute and reuse the code
 *      in this example.  Scott Anguish disclaims any warranty of
 *      any kind, expressed or implied, as to its fitness
 *      for any particular use.
 *		Please keep this notice intact
 *      Written by: Scott Anguish  sanguish@digifix.com
 */

#import <objc/Object.h>
#import <appkit/appkit.h>
#import <libc.h>					  /* MAXPATHLEN */
#import <objc/List.h>
#define NGHEADER	"-- NewsGrazer, a NeXTstep(tm) news reader, posting --"

#import "MMGraphicCell.h"
#import "MMFolderCell.h"
#import "MMDocumentCell.h"

@interface MMText:Text
{
	char *	iconPathList;
	id	privateListener;

	BOOL	showFrom;
	BOOL	showDate;
	BOOL	showNewsgroups;
	BOOL	showSubject;
	BOOL	showMessageID;
	BOOL	showPath;
	BOOL	showFollowupTo;
	BOOL	showExpires;
	BOOL	showReplyTo;
	BOOL	showSender;
	BOOL	showReferences;
	BOOL	showControl;
	BOOL	showDistribution;
	BOOL	showKeywords;
	BOOL	showSummary;
	BOOL	showApproved;
	BOOL	showLines;
	BOOL	showXref;
	BOOL	showOrganization;

	char *contentsFrom;
	char *contentsDate;
	char *contentsNewsgroups;
	char *contentsSubject;
	char *contentsMessageID;
	char *contentsPath;
	char *contentsFollowupTo;
	char *contentsExpires;
	char *contentsReplyTo;
	char *contentsSender;
	char *contentsReferences;
	char *contentsControl;
	char *contentsDistribution;
	char *contentsKeywords;
	char *contentsSummary;
	char *contentsApproved;
	char *contentsLines;
	char *contentsXref;
	char *contentsOrganization;

}

- initFrame:(const NXRect *)frameRect;
- free;
- saveFileName:(char *)aFile;
- openFileName:(char *)aFile;
- openFileName:(char *)aFile ignoreHeader:(BOOL)ignoreHeader;
- readFromMemory:(char *)data length:(int)theSize;
- (int)iconEntered:(int)windowNum at:(double)x :(double)y
    iconWindow:(int)iconWindowNum iconX:(double)iconX iconY:(double)iconY
    iconWidth:(double)iconWidth iconHeight:(double)iconHeight
    pathList:(char *)pathList;
- (int)iconReleasedAt:(double)x :(double)y ok:(int *)flag;
- delayIconReleasedAt:sender;
- becomeFirstResponder;
- appendRichFile:(char *)aFile;
- appendBoldWord:(char *)aString;
- (BOOL)isHeaderVisible:(const char*)header;
@end
