/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/
/* INewsBase initializes the NewsBase Browser */

    /*
     * The main objects in the NewsBase Browser module are:
     *     INewsBase initializes the module.
     *     NewsGroupTree holds the newsgroups in a tree structure.
     *     INewsGroupTreeControl initializes and maintains the NewsGroupTree.
     *     IDataGroupBrowser browses the newsgroup branches of the
     *         NewsGroupTree.
     *     IItemHeaderBrowser browses the headers of articles in a particular
     *         newsgroup.
     *     IMmEdit views a particular article.
     */

#import <objc/Object.h>
#import <objc/zone.h>
#import <dpsclient/event.h>
#import "IOrderedListD.h"

@interface INewsBase:Object
{
    NXZone	*newsbaseZone;

    id		oNewsReader;
    id		oNewsGroupNXBrowser;
    id		oArticleNXBrowser;
    id		oBrowserSplitView;
    id          iNntpIO;
    id		oOpenNewsBasePanel;
    id		oNntpServerNameField;
    id		oGroupSelectionButton;
    char	iNntpHost[128];
    BOOL	iAllNewsFlag;
    id		oGetArticleNumWindow;
    id		oGetArticleNumField;
    id		oPercentageView;
    id		oArticleNumOKButton;
    id		oArticleNumCancelButton;
    id		oSplitView;
    id		oNewsfolderDock;		// connected to ScrollView
    id		oNewsfolderDockMatrix;		// IFolderDockMatrix
    id		oNewsfolderScroll;		// ScrollView
    id		oNewsfolderScrollMatrix;	// IFolderScrollMatrix
    id		oNewsfolderScrollDocView;	// docView of ScrollView
    id		oNewsgroupView;
}

+ (char *)label;

- init;
- _setUpInterfaceWindow;
- (char *)label;
- show:sender;
- terminateProc;
- (BOOL)postArticle:(const char *)data length:(int)length;
- (BOOL)sendArticle:(const char *)messageId;
- newsGroupTreeControl;

- toggleNewsGroupBrowser:sender;
- toggleArticleBrowser:sender;
- setArticleBrowserMode;
- setReadFlagToAll:sender;

/* article marking as read from view control panel */
- markAllArticleAsRead:sender;
- markAllArticleOfCell:sender;

/* newsgroup unsubscribe from view control panel */
- unSubscribeGroup:sender;
- unSubscribeGroupOfCell:sender;

/* reconnect to nntp server */
- getNewArticles:sender;

- _nodeForSelectedCellInBrowser:kbrowser;
- (int)openNewsBasePanel;
- cancelConnect:sender;
- okConnect:sender;
- windowDidBecomeKey:sender;
- windowDidResignKey:sender;
- windowWillClose:sender;

- _saveWindowInfoToDefaultDB;
- _readWindowInfoFromDefaultDBandSetupViews;

/* delegate method for NXSplitView */
- splitView:sender resizeSubviews:(const NXSize *)oldSize;
- splitView:sender getMinY:(NXCoord *)minY maxY:(NXCoord *)maxY
						ofSubviewAt:(int)offset;

@end
