/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/
/* INewsRc */

#import <objc/Object.h>
#import <objc/objc.h>
#import <sys/param.h>

typedef  enum  {Subscribe, UnSubscribe, NotExist} NewsStat;
#define		LINE_BUF_MAXLEN		4088

@interface INewsRc:Object
{
    NXStream	*iFileStream;
    char	iLineBuf[LINE_BUF_MAXLEN];
    char	iNewsRcFileName[MAXPATHLEN];
    NXZone	*istringTableZone;
    id		istringTable;
}

- initFile:(const char *)krcfile;
/*
 *  init and set filename of ".newsrc"
 *	rcfile: newsrc file name. if "", use $HOME/.newsrc
 *	return:	self
 */
- readRcfile;
- (void)saveToRcfileFrom:knewsGroupTreeRoot;
- (NewsStat)isSubscribe:(char *)newsgroupName;
- setGroupInfo:kgroupInfo;


//- readGroupInfo:sender;
/* read and write groupInfo 
   this method will be called from each node of ITreeNodeD
 */

- (char *)_getLineGroup:(char *)kgroup;
- (void)_writeToTableGroupInfo:kgroupInfo;
- (void)_readRcfileAndSetGroupInfo:kgroupInfo;
/*  set subscribe/nosubscribe and read article data("0-11,13,15-20...")
 *  if name of news group is not, set subscribe and "0-(first-1)"
 *	kgroupInfo: id of groupInfo
 */

- free;

@end
