/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/

#import "INewsGroupTreeControl.h"
#import "ITreeNodeD.h"
#import "IUifNode.h"

typedef	  enum {Flat, Tree, BySubject, ByKeyword} BrowserMode;

#define	LISTCOL0TITLE		"- sort by Article number -"
#define	BROWSERCOL0TITLE	"- sort by References -"
#define	SUBJECTCOL0TITLE	"- sort by Subject -"
#define	KEYWORDCOL0TITLE	"- sort by Keyword -"

#define		UNREADMARK	"unreadMark"

@interface INntpIO:INewsGroupTreeControl
{
    id 		iArticleReferenceTreeRoot;
    id 		iArticleHashTable;
    id		iArticleDB;
    BrowserMode		iNewsGroupMode;
    BrowserMode		iArticleMode;
    ReadFlag	irFlag;
    int		iBoundaryForTwo;		// mark for # of Lines
    int		iBoundaryForThree;
}

- initServer:(char *)nntpHost allNews:(BOOL)allNewsFlag
			newsGroupMode:(BrowserMode)g_mode
			articleMode:(BrowserMode)a_mode;

/* method for IO module */
- subDirectoryOf:dataGroupDirNode;
- itemHeadersOf:dataGroupNode;
- itemOf:itemNode;
- (BOOL)toggleActive:node;

/* change data tree structure */
- _subDirectoryOf:node;
- _flatDirectoryOf:node;
- _itemHeadersOf:node;
- _itemTreeHeadersOf:node;
- _itemSubTreeHeadersOf:node;
- (BrowserMode)toggleNewsGroupMode:sender;
- (BrowserMode)toggleArticleMode:sender;
- setArticleMode:(BrowserMode)articleMode;
- setReadFlag:(ReadFlag)rflag;

- getArticleMarkFor:(int)linenum;

- _makeArticleTree;
- (void)_addArticleToTree;
//- (void)makeRefKey:articleItem :(char **)referencesListPtr :(int *)length;
- (char *)findOriginalArticle:articleItem;

/* return browsermode */
- (BrowserMode)newsGroupMode;
- (BrowserMode)articleMode;

/* methods for BySubject mode */
- (IOrderedListD *)_subjectHeadersOf:(IUifNode *)subjectNode;
- (IOrderedListD *)_keywordHeadersOf:(IUifNode *)newsgroupNode;
- _itemHeadersOfSubject:(IUifNode *)subjectNode;

@end
