/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/
#import <appkit/NXBrowser.h>

//typedef	enum {TreeMode, FlatMode} BrowserMode;
/*
   To create a tree browser window create an instance of ITreeBrowser.
   This object will then load the browser interface.  Multiple browser
   windows are allowed.  
*/

@interface ITreeBrowser:NXBrowser
{
    id		iIOmodule;
    id		iDataGroupUIF;
    id		iItemRepUIF;
    id		iItemUIF;
    id		iRootListnode;
    id		iAuxAgent;
    SEL		iAuxAction;
}

- initFrame:(NXRect *)frameRect;

/* set UIF env. */
- (void)setIOmodule:io_module;
- iOmodule;
- (void)setDataGroupUIF:uif_module;
- (void)setItemRepUIF:uif_module;
- (void)setItemUIF:uif_module;
- setRootListnode:node;

- (int)browser:sender fillMatrix:matrix inColumn:(int)column;
- (void)leafPreHandler:sender;
- (void)leafHandler:sender;
- (void)togglePreHandler:sender;
- (void)toggleHandler:sender;

// for aux agent
// auxAgent is a agent that is called when mouse click is occuered in 
// this NXBrowser
// now it is used for displaying newsgorup folder above newsgroup
// browser.
// do nothing without setting iAuxAgent by "-setAuxAgent".
- setAuxAgent:auxAgent;
- auxAgent;
- setAuxAction:(SEL)auxAction;
- (SEL)auxAction;

/* method that may be overridden to customize browser cell image. */
/* if the node should not be loaded, return NULL */
- (void)loadCell:cell fromNode:childNode;
/* action of directory */
- directoryHandler:node;
@end
