/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/

#import <appkit/appkit.h>
#import <defaults/defaults.h>
#import <streams/streams.h>
#import <string.h>

#import "IHelp.h"
#import "Localization.h"

@implementation IHelp

- init
{
    [super init];
    LoadLocalNib("Help.nib",self,NO,[self zone]);
    return self;
}

- openHelpPanel:sender
{
    [oHelpPanel makeKeyAndOrderFront:self];
    return self;
}

- setOHelpScrollView:anObject
{
    oHelpScrollView = anObject;
    [self loadTextFile:"Help.doc"];
    return self;
}

- loadFile:sender
{
    [self loadTextFile:[[sender selectedCell] title]];
    return self;
}

- loadTextFile:(const char *)file
{
    id		textObj;
    NXStream	*fileStream;

    if ((fileStream = LocalMapFile(file, NX_READONLY)) != NULL) {
	textObj = [oHelpScrollView docView];
	[textObj readRichText:fileStream];
	NXCloseMemory(fileStream, NX_FREEBUFFER);
    }
    return self;
}

@end
