/*$Copyright:
 * Copyright (C) 1992.5.22. Recruit Co.,Ltd. 
 * Institute for Supercomputing Research
 * All rights reserved.
 * NewsBase  by ISR, Kazuto MIYAI, Gary ARAKAKI, Katsunori SUZUKI, Kok-meng Lue
 *
 * You may freely copy, distribute and reuse the code in this program under 
 * following conditions.
 * - to include this notice in the source code, if it is to be distributed 
 *   with source code.
 * - to add the file named "COPYING" within the code, which shall include 
 *   GNU GENERAL PUBLIC LICENSE(*).
 * - to display an acknowledgement in binary code as follows: "This product
 *   includes software developed by Recruit Co.,Ltd., ISR."
 * - to display a notice which shall state that the users may freely copy,
 *   distribute and reuse the code in this program under GNU GENERAL PUBLIC
 *   LICENSE(*)
 * - to indicate the way to access the copy of GNU GENERAL PUBLIC LICENSE(*)
 *
 *   (*)GNU GENERAL PUBLIC LICENSE is stored in the file named COPYING
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
$*/
/* InfoD.h */

#import <objc/HashTable.h>

@interface InfoD:HashTable
{
    const char *key;
    NXZone *zone;
}
- initWithKey:(const char *)key strCapacity:(int)kstr_num
                          intCapacity:(int)kint_num;
- initWithKey:(const char *)key;

- addInfo:(char *)kvalue key:(char *)key;
- addInfoString:(const char *)kvalue key:(const char *)key;
/*
 *  add data to class
 *	kvalue: value of field( miyai@isr.recruit.co.jp, fj.sys.next... )
 *	key:	field name( e.g. From, Data, Newsgroups.... )
 */

- addInfoInt:(int)kvalue key:(char *)key;

- (void *)infoForKey:(const char *)key;
/*
 *  return contents of element specified by the key of "key"
 *	key:	field name
 *	return:	istrCount
 */

- setHeaderInfo:(char *)kheader;

- (BOOL)readFromStream:(NXStream *)stream;

- (BOOL)readFromTarStream:(NXStream *)stream;

- (BOOL)readFromFile:(const char *)pathName;

- (void)writeToStream:(NXStream *)stream;

- (void)writeToTarStream:(NXStream *)stream;

@end
