//----------------------------------------------------------------------------------------------------
//
//	MailComposer
//
//	Inherits From:		Object
//
//	Declared In:		MailComposer.h
//
//	Class Description
//
//		An instance of this class uses an instance of MailSpeaker
//		to remotely access a compose window in Mail.app.
//
// 		Note: Methods with 'remote' as part of their name
//		operate directly on the current compose window.
//
//	Disclaimer
//
//		You may freely copy, distribute and reuse this software and its
//		associated documentation. I disclaim any warranty of any kind, 
//		expressed or implied, as to its fitness for any particular use.
//
//----------------------------------------------------------------------------------------------------
#import <appkit/appkit.h>


@interface MailComposer : Object
{
	id		mailSpeaker;
	STR		to;
	STR		subject;
	STR		cc;
	STR		body;
}

//---------------------------------------------------------------------------------------------------------
//	Accessor Methods
//---------------------------------------------------------------------------------------------------------
- (STR) to;
- (STR) subject;
- (STR) cc;
- (STR) body;

- to: (STR) aString;
- subject: (STR) aString;
- cc: (STR) aString;
- body: (STR) aString;


//---------------------------------------------------------------------------------------------------------
//	Action Methods
//---------------------------------------------------------------------------------------------------------
- takeToStringValueFrom: sender;
- takeSubjectStringValueFrom: sender;
- takeCcStringValueFrom: sender;
- takeBodyStringValueFrom: sender;

- takeRemoteToStringValueFrom: sender;
- takeRemoteSubjectStringValueFrom: sender;
- takeRemoteCcStringValueFrom: sender;
- takeRemoteBodyStringValueFrom: sender;

- remoteOpen: sender;
- remoteTo: sender;
- remoteSubject: sender;
- remoteCc: sender;
- remoteBody: sender;
- remoteCompose: sender;
- remoteDeliver: sender;
- remoteComposeAndDeliver: sender;


@end
