/* TurboTextField.m
 *
 *   TurboTextField is a subclass of TextField which installs
 * the TurboTFCell class as it's Cell class.  It also overrides
 * textDidGetKeys:isEmpty: in order to support "length watching"
 * and the ability to restore the previous text after a paste has
 * failed because it is too long.
 * 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 *
 * Written by:  Sharon Zakhour 
 * Created:  Oct/91
 */

#import "TurboTFCell.h"

@interface TurboTextField:TextField
{
	int		maxLength;
	BOOL	autoJump;
	BOOL	acceptReturn;
}


- textDidGetKeys:sender isEmpty:(BOOL)flag;

- setMaxLength: (int)length;
- setAutoJump: (BOOL)flag forLength: (int)length;
- setAcceptsReturn: (BOOL) flag;
- setCustomFilter: (NXTextFilterFunc)aFilter;

@end
