#ifndef STATE_H
#define STATE_H

typedef enum { Plain, Pattern, Status, Goto, FlushS, Pause, CmdS } SType;

typedef struct String {
    char *s;
    struct String *next;
} String;

typedef struct MenuItem {
    char *send, *get, *label;
    struct MenuItem *next;
} MenuItem;

typedef struct {
    int type;
    char *name;
    char *first, *last, *label;
    String *l;
    MenuItem *m;
} State;

extern State *state(char *s);
extern void ReadState(char *s);
extern void setState(char *s);
extern void execState(State *s, char *t);
extern void runState(char *s);
extern int numItem(char *s);
extern void setMenu(char *s);
extern MenuItem *curMenuItem(int n);
extern char *getLabel(MenuItem *m);
extern char *getSend(MenuItem *m);
extern char *getGet(MenuItem *m);
extern char *curMenuFirst(void);
extern char *curMenuLast(void);
extern char *getReport(char *buf);
extern MenuItem *menuFor(char *label, char *name);
extern void fetchReport(char *label, char *buf);

#endif
