/***********************************************************************\
Controller for Convert PICT which converts graphics from PICT to eps formats.
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

/*
====================================================================
	This is $Revision: 1.10 $ of this file
	It was last modified by $Author: death $ on $Date: 93/04/04 23:30:18 $
Note that this file was created while using the New Century Schoolbook Roman typeface.  You may find that some things line up strangely if you don't use that family.

History:
	93.07.18	djb	Added instance variable for the current pict opcode conversion type, and
				the prototype for the method to reset it.

$Log:	PictController.h,v $
 * Revision 1.10  93/04/04  23:30:18  death
 * Sun Apr  4 23:30:17 PDT 1993
 * 
 * Revision 1.9  93/01/09  21:07:16  death
 * Sat Jan  9 21:07:16 PST 1993
 * 
 * Revision 1.8  93/01/01  11:51:22  death
 * Fri Jan  1 11:51:22 PST 1993
 * 
 * Revision 1.7  92/12/31  15:33:50  death
 * Thu Dec 31 15:33:50 PST 1992
 * 
 * Revision 1.6  92/12/05  23:06:19  death
 * Sat Dec  5 23:06:18 PST 1992
 * 
 ====================================================================
 */
#import "ConvertController.h"
#import "PictConverter.h"

#define	PACKIMAGE	"PackImages"
#define	USECLUTS		"WriteCLUTs"
#define	VERBOSEPS		"VerbosePS"
#define	CONVERTCHARS	"ConvertAllFamilies"
//
//	Define the default name, values and button tag #'s for the pict comment conversion
//
#define	CONVERTPICC	"PicCommentConversion"
#define		CONVERTALLPICC	"Convert All"
#define		DISCARDALLPICC	"Discard All"
#define		PICCCONVERTTAG	1
#define		PICCDELETETAG	2

@interface	PictController:ConvertController
{
	id	ConvertCommand;

	id	CompressButton;
	id	ColorTableButton;
	id	PSCodeSetButton;
	id	ConvertAllCharsButton;
	id	PicCommentItem;
	
	Boolean	PackImage;
	Boolean	FoldInCLUTs;
	Boolean	UseVerbosePS;
	Boolean	ConvertAllChars;
	PicCommentOpType	CommentOperation; // type comes from the PictConverter.
}


- init;
- ConvertFrom: sourceFile To: destinationFile;
- displayPreferences: sender;
- ChangePacking: sender;
- ChangeCLUTuse: sender;
- ChangePSCodeSet: sender;
- ChangeCharConversion: sender;
- ChangeCommentProcessing: sender;
- openSourceFile: (roCString) theFile;
- openDestFile: (roCString) theFile;
@end