/***********************************************************************\
Controller class for Convert RTF which converts between Mac and NeXT rtf formats.
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

/*
====================================================================
	This is $Revision: 1.8 $ of this file
	It was last modified by $Author: death $ on $Date: 93/04/04 23:28:25 $
Note that this file was created while using the New Century Schoolbook Roman typeface.  You may find that some things line up strangely if you don't use that family.
$Log:	rtfController.h,v $
 * Revision 1.8  93/04/04  23:28:25  death
 * Sun Apr  4 23:28:25 PDT 1993
 * 
 * Revision 1.7  93/02/21  12:00:02  death
 * Sun Feb 21 12:00:02 PST 1993
 * 
 * Revision 1.6  93/01/10  08:27:27  death
 * Sun Jan 10 08:27:27 PST 1993
 * 
 * Revision 1.5  93/01/02  23:41:35  death
 * Sat Jan  2 23:41:35 PST 1993
 * 
 * Revision 1.4  93/01/02  13:39:05  death
 * Sat Jan  2 13:39:05 PST 1993
 * 
 * Revision 1.3  92/12/25  16:26:48  death
 * Fri Dec 25 16:26:48 PST 1992
 * 
 * Revision 1.2  92/12/21  07:01:15  death
 * Mon Dec 21 07:01:14 PST 1992
 * 
 * Revision 1.1  92/12/19  08:19:09  death
 * Sat Dec 19 08:19:08 PST 1992
 * 
 * 
 ====================================================================
 */
#import "ConvertController.h"
//
//	Defines for names of preferences in the defaults database
//
#define	CONVERTTYPE			"ConvertAsMacRTF"
#define	REMOVEUNDERLINE	"RemoveFirstUnderline"
#define	CONVERTTEXT			"ConvertAllFonts"
#define	CONVERTQUOTES		"LeaveQuotesUnaltered"
#define	CONVERTPICTS			"ConvertMacPictures"
#define	DELETEPICTS			"DeletePictures"

#import "rtfConverter.h"	// For the convert type...

@interface	rtfController:ConvertController
{

	id	destFileHolder;

	id	MacConvertCommand;
	id	NeXTConvertCommand;

	id	MacSourceButton;
	id	RemoveUnderlineButton;
	id	ConvertAllFontsButton;
	id	ConvertSingleQuotesButton;
	id	ConvertPictButton;
	id	DeletePictDataButton;
	
	Boolean	convertMacRTF;
	Boolean	StripFirstUL0;
	GuiConvertChoices	ConvertAllFonts;
	Boolean	ConvertSingleQuotes;
	Boolean	MenuOpen;
	Boolean	DeletePictData;
	Boolean	ConvertPictData;
}


- init;
- free;
- appWillTerminate: sender;
- PrepareForNeXTConversion: sender;
- PrepareForMacConversion: sender;
- ConvertFrom: sourceFile To: destinationFile;
- displayPreferences: sender;
- ChangeConvertSource: sender;
- SetUnderlineRemoval: sender;
- SetFontConversion: sender;
- SetSingleQuoteChange: sender;
- SetPictDataDeletion: sender;
- SetPictConversion: sender;
- openDestFile: (roCString) theFile;
- openSourceFile: (roCString) theFile;

- MakeDestAnRTFD;
@end