/***********************************************************************\
rtf file class for Convert RTF which converts between Mac and NeXT rtf formats.
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

/*
====================================================================
This is the interface file for the rtfFile class.  Full documentation for this class can be found in the rtfFile.rtf file.  I will not duplicate all that fine information here.
	This is $Revision: 1.9 $ of this file
	It was last modified by $Author: death $ on $Date: 93/04/04 23:28:31 $
Note that this file was created while using the New Century Schoolbook Roman typeface.  You may find that some things line up strangely if you don't use that family.
 *$Log:	rtfFile.h,v $
 * Revision 1.9  93/04/04  23:28:31  death
 * Sun Apr  4 23:28:31 PDT 1993
 * 
 * Revision 1.8  93/02/21  12:00:10  death
 * Sun Feb 21 12:00:09 PST 1993
 * 
 * Revision 1.7  93/01/10  08:27:30  death
 * Sun Jan 10 08:27:30 PST 1993
 * 
 * Revision 1.6  93/01/02  23:41:39  death
 * Sat Jan  2 23:41:39 PST 1993
 * 
 * Revision 1.5  93/01/02  13:39:08  death
 * Sat Jan  2 13:39:07 PST 1993
 * 
 * Revision 1.4  92/12/25  16:26:59  death
 * Fri Dec 25 16:26:58 PST 1992
 * 
 * Revision 1.3  92/12/21  07:01:25  death
 * Mon Dec 21 07:01:23 PST 1992
 * 
 * Revision 1.2  92/12/19  08:19:15  death
 * Sat Dec 19 08:19:15 PST 1992
 * 
 * Revision 1.1  92/12/13  10:01:34  death
 * Sun Dec 13 10:01:34 PST 1992
 * 
 * 
====================================================================
 */

//
// Import our parent class' definition
//
#import "TextFile.h"
#import "common.h"
#import "rtfToken.h"
//
//	Different hints (suggestsions) that can be made to this object
//
typedef enum HintName
{
	NoHint,
	WordsArePictures,
	WordsAreNotPictures
}
HintName;
//
//	Define our interface. 
//
@interface rtfFile:TextFile
{
	Boolean			QueueHasBegin;
	PositiveInteger	TotalLength;
	Instance			thequeue;
	Boolean			foundRTF;
	HintName		PictureHint;
	PositiveInteger	textOutputLength;	// 93.02.21  Added for bug fix
}
- initAndUse:(roCString) pathname;
- free;
- CloseAndSave;
- GetToken;
- GetNextControlToken;
- GetOpenBraceToken;
- GetCloseBraceToken;
- GetControlToken;
- GetWordToken;
- GetFamilyNameToken;
- WriteToken: theToken;
- FlushQueue: (Integer) instruction;
- FlushPartially: (Integer) instruction;
- (TokenType) Write: (PositiveInteger)  numTokens  TokensAs: (Integer) instruction;
- (Boolean) ClearThroughLastBegin;
- Hint: (HintName) theHint;
- WriteNeXTGraphicAt: (PositiveInteger) loc
			WithName: (CString) fileName
			Width: (Integer) theWidth
			Height: (Integer) theHeight;
@end

#define	ERR_NOTOKENFOUND	1034
#define	ERR_BADCHAR			1039
#define	ERR_NOBEGIN			1050

#define	PRETTYPRINT			1
#define	ASONELINE				2
#define	MAXLINELENGTH		72
