/***********************************************************************\
Token class for Convert RTF which converts between Mac and NeXT rtf formats.
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

#import "ResultObject.h"

//
//	These define the different types of tokens we can read from an RTF file
//
typedef enum
{
	tokenNoToken,
	tokenBeginGroup,
	tokenEndGroup,
	tokenControlSymbol,
	tokenControlWord,
	tokenWord
}
TokenType;


@interface rtfToken:ResultObject
{
	TokenType	type;			// the type of this token
	CString		name;			// the name of the token.
	Boolean		hasParameter;	// True if the token has a parameter
	Integer		parameter;		// the parameter value for the token.
}


- initTokenOfType: (TokenType) theType;
- free;
- SetTokenName: (CString) theName; 
- SetTokenValue: (Integer) theValue;
- (TokenType)  GetType;
- (CString)  GetName;
- (Boolean) HasValue;
- (Integer)  GetValue;
- (PositiveInteger)  GetLength;
@end

