/***********************************************************************
Controller class for Convert TEXT which converts between Mac and NeXT text.
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
***********************************************************************/

#import "ConvertController.h"
//
//
//	93.07.05	djb	Added conversion type enum for 1.1
//
typedef	enum
{
	MacToNeXT = 0,
	NeXTToMac = 1,
	CRLFToNeXT = 2,
	NeXTToCRLF = 3
}
ConversionTypes;

@interface CharController:ConvertController
{
	Instance	myManager;
	Boolean	UseCurlyQuotes;
	Boolean	UseIMv1;
	ConversionTypes	DefaultConversion;	// Conversion to use if user hasn't explicitly specified
	id	UseCurlyQuotesButton;
	id	UseIMv1Button;
	id	DefaultConversionButton;
	id	theConverter;
	ConversionTypes	CurrentConversion;	// the conversion that should be used at this moment.
	id	MacConvertCommand;
	id	NextConvertCommand;
	id	CRLFConvertCommand;
	id	NeXT2CRLFConvertCommand;
	id	ConvertCommands;
}
- init;

- displayPreferences: sender;
-SetUseCurlyQuotes: sender;
-SetIMV1: sender;
-SetDefaultConversion: sender;

- PrepareToConvertNeXT: sender;
- PrepareToConvertMac: sender;
- PrepareToConvertNeXTToCRLF:sender;
- PrepareToConvertCRLF:sender;
- ConvertFrom: sourceFile To: destinationFile; 
//
//	the following are used when pretending to be a converter, as well as controller.
//
- ReportTo: sender;
- (Boolean) isThisAGoodFile: Instance;

@end

