/***********************************************************************\
Common Abstract Converter class for Convert programs
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

#import "ResultObject.h"
#import "ConvertController.h"
//
//
//	This simple class has the simple purpose of serving as a base class for conversion
//	classes that interact with the ConvertController or it's subclasses.  Thus, it simply
//	provides two simple methods which the ConvertController (or subclasses) refer to.
//	This allows the convertcontroller to include this among its imports so it has
//	definitions of these methods to make the compiler happy.  It also serves to remind
//	me what minimum requirements I must have in a conversion class so it will talk with
//	the convertcontrollers (actually, one doesn't even need these, because the convert
//	controller checks before calling. but that's a technicality).
//
//
@interface AbstractConverter:ResultObject
{
	id	myManager;
}
- init;
- ReportTo: sender;
- (Boolean) isThisAGoodFile: Instance;
@end

