/***********************************************************************\
Common class for doing some rudimentarly interactions with ps files in all Convert programs
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

/*
====================================================================
This is the interface file for the PSFile class.  Full documentation for this class can be found in the PSFile.rtf file (someday).  I will not duplicate all that fine information here.
	This is $Revision: 1.4 $ of this file
	It was last modified by $Author: death $ on $Date: 93/04/04 23:44:51 $
Note that this file was created while using the New Century Schoolbook Roman typeface.  You may find that some things line up strangely if you don't use that family.
 *$Log:	PSFile.h,v $
 * Revision 1.4  93/04/04  23:44:51  death
 * Sun Apr  4 23:44:50 PDT 1993
 * 
 * Revision 1.3  93/01/10  15:08:34  death
 * Sun Jan 10 15:08:33 PST 1993
 * 
 * Revision 1.2  92/07/26  13:59:35  death
 * Updated PSFile used with font converter...
 * 
 * 
 *====================================================================
 */

//
// Import our parent class' definition
//
#import "TextFile.h"
#import "common.h"


@interface PSFile:TextFile
{
}


- WriteDSCComment: (CString) comment;
- WriteDSCCommentUsing: (CString) buffer WithFormat: (CString) format, ...;
- WriteComment: (CString) comment;
- WriteCommentUsing: (CString) buffer WithFormat: (CString) format, ...;

- WritePSLine: (CString) theLine;
- WritePSLineUsing: (CString) buffer WithFormat: (CString) format, ...;
- Write:  (PositiveInteger) num BytesOfHexDataFrom: (ByteString) buffer;
- Write:  (PositiveInteger) num InvertedBytesOfHexDataFrom: (ByteString) buffer;
- ForceNewLine;
- WriteByteAsHex: (Byte) theByte;

@end;