/***********************************************************************\
Common class displaying a circular progress indicator in all Convert programs
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

/*
	This is a simple view that implements a percent-complete indicator.  It looks and
	behaves just like the indicator on NeXT's Processes window, or the one in the
	Installer.app application.  The caller gives it a number that constitutes the 'goal', and
	then updates the view whenever it moves closer or further away from the goal.  The
	circle displayed on the screen reflects these changes.
	92.06.21	djb
*/

#import <appkit/View.h>
#import "common.h"
@interface ProgressIndicator:View
{
	Boolean	active;
	Real		numUnits;
	Real		CurrentValue;
}

- drawSelf:(const NXRect *)rects :(int)rectCount; 
- init;
- ActivateWithGoal: (Real) count;
- Deactivate;
- IncrementBy: (Real) units;
- SetTo: (Real) units;
@end
