/***********************************************************************\
Common class for accessing text files in all Convert programs
Copyright (C) 1993 David John Burrowes

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author, David John Burrowes, can be reached at:
	davidjohn@kira.net.netcom.com
	David John Burrowes
	1926 Ivy #10
	San Mateo, CA 94403-1367
\***********************************************************************/

/*
====================================================================
This is the interface file for the TextFile class.  Full documentation for this class can be found in the TextFile.rtf file.  I will not duplicate all that fine information here.
	This is $Revision: 1.3 $ of this file
	It was last modified by $Author: death $ on $Date: 93/04/04 23:45:28 $
Note that this file was created while using the New Century Schoolbook Roman typeface.  You may find that some things line up strangely if you don't use that family.
 *$Log:	TextFile.h,v $
 * Revision 1.3  93/04/04  23:45:28  death
 * Sun Apr  4 23:45:27 PDT 1993
 * 
 * Revision 1.2  93/01/10  15:08:56  death
 * Sun Jan 10 15:08:55 PST 1993
 * 
 * Revision 1.1  92/07/26  13:58:43  death
 * Initial revision
 * 
 * 
====================================================================
*/

//
// Import our parent class' definition
//
#import "File.h"
#import "common.h"
//
//	Define our interface.   Again, see the TextFile.rtf document for general info.
//
@interface TextFile:File
{
}
- WriteInteger: (Integer) theInt;
- WritePositiveInteger: (PositiveInteger) theInt;
- WriteReal: (Real) theReal;
- UnGetCharacter;
- (Character) GetCharacter;
- (Character) LookAtNextCharacter;
- (Integer) GetNumber;
- (Byte) GetHexByte;
- WriteText: (CString) theLine;
- WriteTextLine: (CString) theLine;
- WriteTextUsing: (CString) buffer WithFormat: (CString) format, ...;

- AppendFrom: sourceFile;

@end
#define	ERR_BADREAD	-4001	/*Arbitrary.  I need a better error code organization */
