/* Controller.h 
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 *
 * Written by: Mai Nguyen, NeXT Developer Support
 */

#import <objc/Object.h>
#import <objc/List.h>

@interface Controller:Object
{
  	id 	database;		/* The database to work from */
	
	id	theWindow;		/* the application main window	*/
  	id	addressView;	/* the scrollview that displays record information */
  	id	cellMatrix;		/* the matrix contained in the scrollview  */
	
  	id	recordList;		/* A DBRecordList instance to contain data records */
 	id	propertyList;	/* A DBPropertyList instance associated with the
  						 * record list.					 
						 */	 
 	int	recordCount;
	id authorEntity;	/* Authors entity used as a source for the 
						   record list */
	id authId;			/* Used as the key for record modifications		*/
	id infoPanel;		
	id SQLPanel;		/* Panel showing all SQL queries			  */
	id appender;		/* Appender object to append text			  */
}
- appDidInit:sender;
- initRecordList;
- getRecordList;
- getPropertyList;
- (int)getRecordCount;

- addRecords:sender;
- deleteRecords:sender;
- updateRecords:sender;

- showSQLPanel:sender;

- showInfoPanel:sender;

/* DBDatabase delegate method */
- (BOOL)db:aDb willEvaluateString:(const char*)aString usingBinder:aBinder;
@end
