/*
 * For legal stuff see the file COPYRIGHT
 */
#import <appkit/appkit.h>
#import "ClientInfo.h"
#import "ViewMgr.h"

@interface ClientInspector : Object
{
  id	panel;
  id	controller;
  id	addButton;
  id	deleteButton;
  id	modifyButton;
  id	browser;
  id	popUpButton;
  id	popUpList;
  id	clientMenuCell;
  id	sessionMenuCell;
  id	expenseMenuCell;
  id	viewsPanel;

  id	sessionView;
  id	expenseView;
  id	clientView;
  id	currentView;

  id	sessionMgr;
  id	expenseMgr;
  id	clientMgr;
  id	currentMgr;

  int	totalMins;

  id	previousSelection;	/* Obsolete? */
}

+ sharedInstance;
+ (void)updateButtons;

- display;
- (void)decacheView;
- (void)decacheBrowser;
- (void)selectClientAt:(int)row;

- addClient:(ClientInfo *)info;
- deleteSelectedClient;
- selectClient:(ClientInfo *)info;

- add:sender;
- modify:sender;
- delete:sender;
- undelete:sender;

- browserClick:sender;
- updatedInfo:info;

- (ClientInfo *)selectedClient;

- (void)performAdd;
- (void)performModify;
- (void)closeMonth;
- showHours:sender;
- showExpenses:sender;
- showClient:sender;
- setDocEdited:(BOOL)flag;
@end
