/*
 * Main controller for Stopwatch app.
 *
 * For legal stuff see the file COPYRIGHT
 */
#import <appkit/appkit.h>
#import "Invoice.h"
#import "SortList.h"

#define DIRMODE		0755
#define DELIMITER	'\t'	/* for import/export */

extern const char *currentTime();
extern const char *currentDate();
extern void freeAndCopy( char **ptr, const char *str );
extern int copyFile( const char *src, const char *dst );
extern void commafy( int value, char *result );
extern void commafyDouble( double value, char *result );

@interface Controller:Object
{
  id		description;
  id		elapsedTimeField;
  id		browser;
  id		startButton;
  id		startMenuItem;
  id		clientMenuItem;
  id		sessionMenuItem;
  id		expenseMenuItem;
  id		addMenuItem;
  id		modifyMenuItem;
  id		infoPanel;
  id		window;
  id		stopwatch;
  id		undeleteButton;
  id		deleteButton;
  SortList	*clientList;
  id		activeClient;
  id		appIconView;
  id		preferences;
  Invoice 	*invoice;
  char		*dirname;	/* the directory the archive is in */
  char		*filename;	/* the name of the archive */
  DPSTimedEntry	teNum;		/* timed-entry number */
  BOOL		didBackup;	/* set to YES after backup has been made */
}

- init;
- appDidInit:sender;

- clientList;

- inspect:sender;
- inspectSessions:sender;
- inspectExpenses:sender;
- inspectClients:sender;
- add:sender;
- modify:sender;
- delete:sender;
- undelete:sender;
- selectClient:sender;
- preferences:sender;
- startClock;
- stopClock;
- buttonHandler:sender;
- showElapsedTime;
- showInfo:sender;
- generateDetail:sender;
- browseClient:sender;
- import:sender;		/* import ascii log */
- export:sender;		/* generate ascii log */
- compactClients:sender;
- (int)saveClientInfo;
- closeMonth:sender;
- editTemplate:sender;
- saveAs:sender;
- (void)enableAdd:(BOOL)flag;
- (void)enableModify:(BOOL)flag;
- (void)enableUndelete:(BOOL)flag;
- (void)enableDelete:(BOOL)flag;
- (void)decacheBrowser;

@end
