/*
 * Manage the information regarding a single Expense record for
 * a single client.
 *
 * For legal stuff see the file COPYRIGHT
 */
#import "ColCellData.h"

@interface Expense : Object <ColCellData>
{
  char	*dateString;
  char	*description;
  float	amount;
}

- free;
- init:(const char *)date
       description:(const char *)desc
       amount:(const float)amt;

- read: (NXTypedStream *) stream;
- write:(NXTypedStream *) stream;

- setAmount:(float)value;
- setDateString:(const char *)str;
- setDescription:(const char *)desc;

- (float)amount;
- (const char *)dateString; 	/* mm/dd/yy */
- (const char *)description;

- (int)dateValue;

@end
