/*
 * Manage the information regarding a single working session for
 * a single client. ClientInfo maintains a list of these.
 *
 * For legal stuff see the file COPYRIGHT
 */
#import "ColCellData.h"

@interface Session : Object <ColCellData>
{
  int	minutes;
  char	*description;
  char	*startTimeString;
  char	*startDateString;
}

- free;
- init:(const char *)startDate
       time:(const char *)startTime
       duration:(int)elapsedMinutes
       description:(const char *)desc;

- read: (NXTypedStream *) stream;
- write:(NXTypedStream *) stream;

- setMinutes:(int)value;
- setStartDateString:(const char *)str;
- setStartTimeString:(const char *)str;
- setDescription:(const char *)desc;
- (int)minutes;
- (float)hours;
- (const char *)startDateString; 	/* mm/dd/yy */
- (const char *)startTimeString; 	/* hh:mm */
- (const char *)durationString;		/* hh:mm */
- (const char *)description;

- (int)dateValue;		/* for use in sort comparisons */
- (int)timeValue;
@end
