/*
 * For legal stuff see the file COPYRIGHT
 */
#import <appkit/appkit.h>
#import <objc/List.h>

@class ClientInspector;

@interface ViewMgr : Object
{
  List	*deletedItems;
  id	view;	
}

- (void)setView:(View *)obj;
- getDeletedItem;
- saveDeletedItem:item;
- (void)forgetDeletions;

/* Used to enable/disable the inspector's buttons */
- (BOOL)canAdd;
- (BOOL)canModify;
- (BOOL)canDelete;
- (BOOL)canUndelete;

/*
 * These methods return YES if they modified the data structure
 * (thus requiring a save to be performed) or NO if not.
 */
- (BOOL)mgrAdd:(ClientInspector *)inspector;
- (BOOL)mgrDelete:(ClientInspector *)inspector;
- (BOOL)mgrUndelete:(ClientInspector *)inspector;
- (BOOL)mgrModify:(ClientInspector *)inspector;
- (BOOL)mgrDoubleClick:(ClientInspector *)inspector;

/*
 * This method returns YES if there are unsaved edits
 */
- (BOOL)isEditing;

- mgrShow:(ClientInspector *)inspector;

@end
