// Controller.h

/*
 * Copyright 1991 RightBrain Software.  All rights reserved.
 *
 * No part of this code may be reproduced in any form, compiled
 * or source code, nor used for any purpose without the express
 * written permission of RightBrain Software.
 * 
 * Entered into the public domain 12/15/93 by RightBrain Software.
 *
 */

#import <objc/Object.h>
#import <dpsclient/dpsclient.h>
// #import "Defaults.h"

@interface Controller:Object
{
    id			fileNameTextField, filePathTextField,
    			pathTextField, iconView, textViewer, tiffViewer,
			noViewer, drawingView, emptyBox, appIconView,
			infoPanel, inspectorWindow, changedBox, clockView,
			calendarView, stringTable, dragPanel, scroller,
			helpPanel, prefPanel;
    int			currentImage, filePathLength;
    DPSTimedEntry	animationTimedEntry;
    char		*filePath;
    BOOL		multipleFiles;
    id			iconList;
    int			iconCount;
    unsigned int	myWindowNum;
    int			alreadyHaveIt;
    char		listFileName[2048];
    char		buff[2048];
    id			selected;
    id			defaults;
    id			fromWhich;	/* if drag starts inside window */
    
    const char		*nameEntering;
    float		widestName;
    int			textVisible;
    NXRect		oldPos;
    id			toggleTextMenu;
}

/* delegation methods */
-  appDidInit:sender;
- (char *)listFileName;
- stringTable;
- gimmeScroller;
- (float) widestName;
- launchAll:sender;
- selected;
- defaults;
- setSelected:which;
- toggleTextVisible:sender;
- displayDock:sender;
- fromWhich;
- setFrom:which;
- (int)iconEntered:(int)windowNum at:(double)x :(double)y
    iconWindow:(int)iconWindowNum iconX:(double)iconX iconY:(double)iconY
    iconWidth:(double)iconWidth iconHeight:(double)iconHeight
    pathList:(char *)pathList;
- updateIcon:sender;
- (int)iconReleasedAt:(double)x :(double)y ok:(int *)flag;

/* instance methods */
- init;
- cut:sender;
- clearList:sender;
- openList:sender;
- addList:sender;
- newList:sender;
- saveList:sender;
- saveAsList:sender;
- getFileInfo:sender;
- slideIconInScroller: theIcon toLocation:(float)toY;
- addFileToScroller: (char *)fname : (int)multiple : (int)winNum;
/* : (float)X : (float)Y : (float)W : (float)H; */
- setFileIconFor : theView : (char *)fname;
- moveIconInScroller: theIcon by:(float)dX:(float)dY;
- removeFileFromScroller: (const char *)fname;
- infoPanel;
- displayInfoPanel:sender;
- writeFileList: (const char *)fname;
- readFileList: (const char *)fname;

@end