// IconView.h

/*
 * Copyright 1991 RightBrain Software.  All rights reserved.
 *
 * No part of this code may be reproduced in any form, compiled
 * or source code, nor used for any purpose without the express
 * written permission of RightBrain Software.
 * 
 * Entered into the public domain 12/15/93 by RightBrain Software.
 *
 */

#import <sys/param.h>
#import <appkit/View.h>

@interface IconView:View
{
    id    iconImage;
    id    scrollR;
    BOOL  multipleFiles, showFile;
    char  filename[MAXPATHLEN];
    char  appname[MAXPATHLEN];
    char  dirname[MAXPATHLEN];
    char  buff[MAXPATHLEN];
    float deltaX, deltaY;
    double scaleFactor;
    BOOL  hasIcon;
    int   autoLaunch;
    int   isApplication;
    int   isBogus;
    id    myCheckBox;
    id	  myWideBox;
    id    myLabelText;
    id    myDirText;
    id	  stringTable;
}

#define MISSING_FILE -1

/* instance methods */
- initFrame:(NXRect *)frameRect;
- (NXRect *)bounds;
- setAppOrFile:(int)ilk;
- (BOOL)acceptsFirstMouse;
- (BOOL)hasIcon;
- (const char *)filename;
- (const char *)appname;
- (const char *)dirname;
- (int)autoLaunch;
- tellName:sender;
- setFilename:(const char *)name multipleSelected:(BOOL)multipleSelected;
- toggleCheckBox:sender;
- setMyCheckBox:theBox;
- setMyWideBox:theBox;
- myCheckBox;
- myWideBox;
- setMyLabelText:theBox;
- myLabelText;
- setMyDirText:theBox;
- myDirText;
- takeIconFromWindow:(int)windowNumber :(float)x :(float)y :(float)width
  :(float)height;
- takeIconFromData : (char *)data : (int)length;
- takeIconFromTIFF : (char *)fname;
- clear;
- openSelf:sender;
- openSelfIfAutoLaunch:sender;
- highlightSelf:sender;
- mouseDown:(NXEvent *)theEvent;
- drawSelf:(NXRect *)rects :(int)rectCount;

@end
