
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus
	
	Class: ActivatorBarView.h
	
	Description:
	
	The ActivatorBarView is installed as the contentView in each ActivatorBar.  It is responsible for drawing the view, and for handling mouseDown:'s that occur within the view/window.  When a mouseDown: is received, the view tells the window -- an ActivatorBar -- that the view/window was hit via the barHit: message.  It would be just as easy to have the window trap these events directly in sendEvent:, but it works this way, too.
	
	Original Author: Jeremy Slade
	
	Revision History:
		Created
			V.101	JGS Tue Feb  2 18:47:52 GMT-0700 1993

*/


#ifndef ActivatorBarView_h
#define ActivatorBarView_h

#define ActivatorBarView_VERSION	(101)


#import <appkit/View.h>


@interface ActivatorBarView : View
{
	NXColor fillColor;
	NXColor borderColor;
}

+ initialize;
- initFrame:(const NXRect *)rect;
- setColor:(NXColor)color;
- setBorderColor:(NXColor)color;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- mouseDown:(NXEvent *)event;

@end


#endif // ActivatorBarView_h
