
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus

	File: CustomApp.h

	Description:
	
	This class is the subclass of Application used in Locus.  Currently, it has a single main purpose (besides that of the main Application class): it intercepts Command-key events and sends the to the Key Window first, whereas the normal behavior is to simply send them to the Windows in the App's windowList in the order.  Since the Menus come before regular windows in most applications, command-keys are usually handled by the Menus first.  For locus this won't work because the group selector pop-up list in the Folder window needs to be able to handle them first, which allows any key equivalent to be used.
	CustomApp also provides some support for debugging, by overriding the -appName method to give a different name when DEBUGGING is turned on.
	
	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Sat Mar 27 19:09:26 GMT-0700 1993

*/

#ifndef CustomApp_h
#define CustomApp_h

#define CustomApp_VERSION		(101)


#import <appkit/Application.h>


@interface CustomApp : Application
{
}

// Creating, Initializing
+ initialize;

// Events
- sendEvent:(NXEvent *)theEvent;

// Debugging support
- (const char *)appName;

@end


#endif // CustomApp_h
