
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus

	File: Dragging.h

	Description:
	
	This file defines some stuff used to support icon dragging.  At this point, in simply defines a protocol called DragDelegate, which is adopted by any classes the handle the details of performing a drag operation, beyond the NXDragging... protocol stuff.  The only class that currently does this is the FolderController.
	When an icon of the proper type is dragged onto a window/view that is registered as a dragging destination, the destination calls the setDragDest: method of the protocol, which lets the FolderController know where the icon was dragged to.  All of the dragging session is then handled by the FolderController, via messages forwarded from the DragDest.
	
	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Mon Feb  8 23:38:54 GMT-0700 1993

*/

#ifndef Dragging_h
#define Dragging_h

#define Dragging_VERSION 	(101)


#import <appkit/drag.h>


@protocol DragDelegate
	// NXDraggingDestination -- an informal protocol

// Sutff unique to DragDelegate Protocol
- setDragDest:aView;
- dragDest;

// The NXDraggingDestination Protocol
- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (NXDragOperation)draggingUpdated:(id <NXDraggingInfo>)sender;
- draggingExited:(id <NXDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NXDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;
- concludeDragOperation:(id <NXDraggingInfo>)sender;

@end


#endif // Dragging_h
