
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

/*
	Project: Locus

	File: DynamicItems.h

	Description:

	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Wed Apr 14 21:45:45 PDT 1993

*/

#ifndef DynamicItems_h
#define DynamicItems_h

#define DynamicItems_VERSION		(101)


#import "Group.h"


@interface Group ( DynamicItems )

// DynamicItemSpecs
- dynamicItemSpecs;
- dynamicItemSpecMatching:(const char *)itemSpec;
- addDynamicItemSpec:(const char *)itemSpec;
- removeDynamicItemSpec:(const char *)itemSpec;
- enableDynamicItemSpec:(const char *)itemSpec;
- disableDynamicItemSpec:(const char *)itemSpec;

// Updating DynamicItems
- setUpdateInterval:(float)interval;
- (float)updateInterval;
- startDynamicUpdate;
- stopDynamicUpdate;
- updateDynamicItems:sender;

// Working with DynamicItems
- addDynamicItem:item;
- removeDynamicItems;
- (int)countDynamicItems;

@end



#endif // DynamicItems_h
