
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

/*
	Project: Locus

	File: ErrorReporting.h

	Description:
	The Category of Object defines some standard methods for debugging output and error reporting.
	
	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Mon Feb  1 22:47:50 GMT-0700 1993

*/



#ifndef ErrorReporting_h
#define ErrorReporting_h

#define ErrorReporting_VERSION	(101)


#import <objc/Object.h>


@interface Object ( ErrorReporting )

+ debug:(unsigned)level :(const char *)fmt, ...;
- debug:(unsigned)level :(const char *)fmt, ...;
+ setDebugLevel:(unsigned)level;
- setDebugLevel:(unsigned)level;
+ (unsigned)debugLevel;
- (unsigned)debugLevel;

+ errMsg:(const char *)fmt, ...;
- errMsg:(const char *)fmt, ...;

@end
 

#endif ErrorReporting_h
