
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus
	
	Class: FolderInsPane
	
	Description:
	
		This is the ispector pane for Folders.  It contains a browser listing the groups within the target folder, but doesn't do much at this point.  One planned feature is to have the browser used to reorder the groups, rather than having the groups always sorted.
	
	Original Author: Jeremy Slade
	
	Revision History:
		Created
			V.101	JGS Thu Dec 17 21:58:31 MST 1992
			
*/


#ifndef FolderInsPane_h
#define FolderInsPane_h

#define FolderInsPane_VERSION (101)


#import "InspectorPane.h"


@interface FolderInsPane : InspectorPane
{
	id	browser;	// Browser containing list of groups
	id	countField;	// Field displaying number of groups
	id	inspectButton; // Inspect the currently selected group
}

// Creating, initializing
+ initialize;
- initContent:(const NXRect *)contentRect
	style:(int)aStyle
	backing:(int)bufferingType
	buttonMask:(int)mask
	defer:(BOOL)flag;
- awakeFromNib;
- free;

// Folder Inspector stuff
- inspect:anObject;
- showCurrent:sender;
- groupSelected:sender;
- inspectSelectedGroup:sender;

// Browser delegate methods
- (int)browser:sender fillMatrix:matrix inColumn:(int)col;

@end

#endif // FolderInsPane_h
