
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus
	
	Class: FolderViewer
	
	Description:
	
	FolderViewer is the Panel subclass used to display a Folder.  Each Folder owns its own viewer and manages it itself.
	
	
	Original Author: Jeremy Slade
	
	Revision History:
		Created
			V.101	JGS Wed Feb  3 23:17:39 GMT-0700 1993

*/

#ifndef FolderViewer_h
#define FolderViewer_h

#define FolderViewer_VERSION	(101)

#import <appkit/Panel.h>


@interface FolderViewer : Panel
{
	id	groupMenu;
	id	groupMenuCover;
	id	widePopupController;
	id	browser;
}

// Creating, initializing instances
+ initialize;
- initContent:(const NXRect *)rect
	style:(int)aStyle
	backing:(int)bufferingType
	buttonMask:(int)mask
	defer:(BOOL)flag;
- awakeFromNib;
- free;

// Subviews
- groupMenu;
- groupMenuCover;
- browser;

// Setting the title
- setTitleAsFilename:(const char *)aString;

// Misc
- updateInspector:sender;
- becomeKeyWindow;
- becomeMainWindow;
- resignKeyWindow;
- resignMainWindow;
- miniaturize:sender;
- keyDown:(NXEvent *)event;
- (BOOL)commandKey:(NXEvent *)event;

@end

#endif // FolderViewer_h
