
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus
	
	Class: InfoPanel
	
	Description: See InfoPanel.h

	Original Author: Jeremy Slade
	
	Revision History:
		Created
			V.101	JGS Mon Feb  8 22:20:06 GMT-0700 1993

*/

#import "InfoPanel.h"

#import "Globals.h"


@implementation InfoPanel


+ initialize
{
	[self setVersion:InfoPanel_VERSION];
	return ( self );
}



- runInfoPanel:sender
/*
	Does nothing except order the panel to the front, for now.  This can be used to start some animation sequnce, etc.
*/
{	
	// Set version number
	[[versionField cell] setStringValue:[Object projectVersionString]];
	
	[self orderFront:sender];

	if ( [delegate respondsTo:@selector(infoPanelDidRun:)] ) 
		[delegate perform:@selector(infoPanelDidRun:) with:self
			afterDelay:0 cancelPrevious:YES];
	return ( self );
}



- (BOOL)canBecomeKeyWindow
{
		return ( NO );
}



- (BOOL)canBecomeMainWindow
{
	return ( NO );
}



@end
