
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

/*
	Project: Locus
	
	Class: Inspector
	
	Description:
	[ FULL DESCRIPTION ]
	
	Original Author: Jeremy Slade
	
	Revision History:
		Created
			V.101	JGS Mon Feb  8 22:28:42 GMT-0700 1993
			
*/


#ifndef Inspector_h
#define Inspector_h

#define Inspector_VERSION 	(101)


#import <objc/Object.h>


// Inspector modes
#define INSPECT_NONE		0
#define INSPECT_ITEM		1
#define INSPECT_GROUP		2
#define INSPECT_FOLDER	3

// Strings for each ispector mode
extern char *inspectorTitles[];


@interface Inspector : Object
{
	id	target;	// The object being inspected
	
	// General Inspector stuff
	id	panel;
	id	paneView;	// SwapView for different Panes
	id	currentPane;
	id	modeMenu;	// Inspector mode selector PupUpList
	id	modeCover;	// Cover button for modeMenu -- need this to set its title
	int previousMode;	// last mode before set to INSPECT_NONE
	
	// Different panes
	id	noInspectorPane;
	id	folderPane;
	id	groupPane;
	id	itemPane;
	id	selectionPane;
	
}

// Creating and initializing
+ initialize;
- init;
- awakeFromNib;
- free;

// Showing the inspector and setting the mode
- showInspector:sender;
- panel;
- setFolderMode:sender;
- setGroupMode:sender;
- setItemMode:sender;
- setInspectorMode:(int)aMode;
- (int)inspectorMode;
- (BOOL)canInspect:anObject;
- inspect:anObject;
- inspecting;
- update;

// Selecting the Group Name field
- selectGroupName:sender;

// SwapView delegate methods
- swapPaneFor:sender;

// Window delegate methods
- windowDidMove:sender;
- windowWillClose:sender;

@end

#endif // Inspector_h
