
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

#import "InspectorPane.h"

#import "Globals.h"


@implementation InspectorPane


+ initialize
{
	[self setVersion:InspectorPane_VERSION];
	return ( self );
}



- initContent:(const NXRect *)contentRect
	style:(int)aStyle
	backing:(int)bufferingType
	buttonMask:(int)mask
	defer:(BOOL)flag
{
	[super initContent:contentRect
		style:aStyle
		backing:bufferingType
		buttonMask:mask
		defer:flag];
	
	target = nil;
	
	return ( self );
}



- free
{
	return ( [super free] );
}



- inspect:anObject
/* set the object being inspected */
{
	if ( anObject != target ) {
		target = anObject;
	}
	return ( self );
}



- (BOOL)canInspect:anObject
/* Intended to be overridden by subclasses */
{
	return ( NO );
}



- inspecting
/* Returns the object currently being inspected */
{
	return ( target );
}



- showCurrent:sender
/* Update the display with the current attribute of the target */
{
	return ( self );	// Subclasses must implement
}



@end
