
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

/*
	Project: Locus
	
	Class: ItemInsPane
	
	Description:
	[ FULL DESCRIPTION ]
	
	Original Author: Jeremy Slade
	
	Revision History:
		Created
			V.101	JGS Mon Feb  8 22:43:24 GMT-0700 1993
			
*/


#ifndef ItemInsPane_h
#define ItemInsPane_h

#define ItemInsPane_VERSION		(101)


#import "InspectorPane.h"


@interface ItemInsPane : InspectorPane
{
	// General Item stuff
	id	pathField;
	id	groupLaunchSwitch;
	id	autoLaunchSwitch;
	id	swapView;
	
	// File-type Items
	id	fileTypePane;
	id	specificAppSwitch;
	id	specificAppField;
	
	// Folder-type Items
	id	folderTypePane;
	id	createBrowserSwitch;
	id	rootedAtField;
	
	// App-type Items
	id	appTypePane;
	id	hideIconSwitch;
}

// Creating, Initializing
+ initialize;
- initContent:(const NXRect *)contentRect
	style:(int)aStyle
	backing:(int)bufferingType
	buttonMask:(int)mask
	defer:(BOOL)flag;
- awakeFromNib;
- free;

// General Item stuff
- (BOOL)canInspect:anObject;
- showCurrent:sender;
- swapPaneFor:sender;
- changeItemPath:sender;
- changeItemGroupLaunch:sender;
- changeItemAutoLaunch:sender;

// File-type Items
- changeUseSpecificApp:sender;
- changeSpecificApp:sender;

// App-type Items
- changeHideIcon:sender;

// Folder-type Items
- changeCreateBrowser:sender;
- changeRootedAt:sender;

// Text Delegate Methods
- textDidChange:sender;
- textDidEnd:sender endChar:(unsigned short)endChar;

@end

#endif // ItemInsPane_h
