
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

/*
	Project: Locus

	File: SelectionInsPane.h

	Description:
		Inspector Pane of multiple items
		
	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Fri Mar  5 22:22:55 GMT-0700 1993

*/

#ifndef SelectionInsPane_h
#define SelectionInsPane_h

#define SelectionInsPane_VERSION		(101)


#import "InspectorPane.h"

@interface SelectionInsPane : InspectorPane
{
	id	countField;
	id	groupLaunchSwitch;
	id	autoLaunchSwitch;
}

// Creating, Initializing
+ initialize;
- initContent:(const NXRect *)contentRect
	style:(int)aStyle
	backing:(int)bufferingType
	buttonMask:(int)mask
	defer:(BOOL)flag;
- awakeFromNib;
- free;

// Inspecting...
- (BOOL)canInspect:anObject;
- showCurrent:sender;
- changeSelectionGroupLaunch:sender;
- changeSelectionAutoLaunch:sender;

@end

#endif // SelectionInsPane_h
