
/*
	Copyright 1993  Jeremy Slade.  All rights reserved.
*/

/*
	Project: Locus

	File: SelectionInsPane.m

	Description:

	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Fri Mar  5 22:28:03 GMT-0700 1993

*/

#import "SelectionInsPane.h"

#import "Globals.h"
#import "ItemCell.h"
#import "ItemList.h"

#import <objc/List.h>


//// FIX: This must be made to work with tri-state buttons

@implementation SelectionInsPane : InspectorPane


// -------------------------------------------------------------------------
//   Creating, initializing
// -------------------------------------------------------------------------


+ initialize
{
	[self setVersion:SelectionInsPane_VERSION];
	return ( self );
}



- initContent:(const NXRect *)contentRect
	style:(int)aStyle
	backing:(int)bufferingType
	buttonMask:(int)mask
	defer:(BOOL)flag
{
	[super initContent:contentRect
		style:aStyle
		backing:bufferingType
		buttonMask:mask
		defer:flag];
	
	return ( self );
}



- awakeFromNib
/*
	Perform final initializations
*/
{
	return ( self );
}



- free
{
	return ( [super free] );
}



// -------------------------------------------------------------------------
//   Inspecting...
// -------------------------------------------------------------------------


- (BOOL)canInspect:anObject
{
	return ( [anObject isKindOf:[ItemList class]] );
}



- showCurrent:sender
{
	[countField setIntValue:[target count]];
	
	[groupLaunchSwitch setEnabled:NO];
	[autoLaunchSwitch setEnabled:NO];
	
	return ( self );
}
	


- changeSelectionGroupLaunch:sender
{
	return ( self );
}



- changeSelectionAutoLaunch:sender
{
	return ( self );
}



@end
