
/*
	Copyright 1993  Jeremy Slade.

	You are free to use all or any parts of the Locus project
	however you wish, just give credit where credit is due.
	The author (Jeremy Slade) shall not be held responsible
	for any damages that result out of use or misuse of any
	part of this project.

*/

/*
	Project: Locus

	File: SwapView

	Description:
	
	This view handles swapping between different subviews, by swapping the subviews in and out of their panels.
	
	Original Author: Jeremy Slade

	Revision History:
		Created
			V.101	JGS	Sat Mar  6 20:27:59 GMT-0700 1993

*/

#ifndef SwapView_h
#define SwapView_h

#define SwapView_VERSION		(101)


#import <appkit/View.h>


@interface SwapView : View
{
	id	currentPane;
	id	replacementView;
	
	id	delegate;
}

// Creating, initializing
+ initialize;
- initFrame:(const NXRect *)frameRect;
- free;

// Setting the delegate, swapping the view
- setDelegate:anObject;
- delegate;
- swap:sender;
- swap;
- drawSelf:(const NXRect *)rects :(int)rectCount;

@end


@interface Object ( SwapViewDelegate )
- swapPaneFor:sender;
@end


#endif SwapView_h

