/* The Application interface for Emacs.

   For legal stuff see the file COPYRIGHT.  */

#import <appkit/appkit.h>
#import <appkit/Application.h>
#import "EtermView.h"

@interface EmacsApp : Application
{
  /* Current view.  */
  id currentView;
  /* Array of files to edit at startup time.  */
  char **files;
  /* Number of files to edit at startup time.  */
  int nfiles;
  /* The applications fontManager.  */
  id fontManager;
}

-appDidInit: sender;
-appDidUnhide: sender;
-terminate: sender;
-(BOOL) appAcceptsAnotherFile: sender;
-(BOOL) app: sender openFile: (const char *) path type: (const char *) type;
-currentView;
-fontManager;
-showFontPanel: sender;
-(BOOL) fontManager: sender willIncludeFont: (const char *) fontName;
@end
