#import <dpsclient/dpsclient.h>
#import <appkit/Application.h>
#import "gnuchess.h"

struct Preferences {
  int time_control_moves;
  int time_control_minutes;
  int opponent;
  int computer;
  int bothsides;
  int cheat;
  char *white_name;
  char *black_name;
};

@interface Chess : Application
{
  id clockWindow;
  id gameBoard;
  id levelSlider;
  id levelText;
  id boardWindow;
  id blackClock;
  id whiteClock;
  id blackClockText;
  id whiteClockText;
  id blackMeter;
  id whiteMeter;
  id blackName;
  id whiteName;
  id blackSideMatrix;
  id whiteSideMatrix;
  id infoPanel;
  id infoScroll;
  id setButton;
  id forceButton;
  id startButton;
  id board2D;
  id board3D;
   
  int undoCount;
  int hintCount;
  int forceCount;
  
  char *filename;
  
  int btime;
  int wtime;
  
  struct MoveInfo move_info;
  long start;
  
  struct Preferences pref;
  struct passwd *pwen;
  
  int finished;
  int currentRow, currentCol;
  NXColor white_color,black_color;
  id whitesample,blacksample;
}

#define WHITE_MATE 1
#define BLACK_MATE 2
#define OPPONENT_MATE 3
#define DRAW_GAME 4

- (int)finished;
- (int)bothsides;
- setFinished: (int)f;
- finishedAlert;
- storePosition: (int) row : (int) col;
- showPosition: sender;
- renderPreview;
- renderColors: sender;

- clockWindow;
- whiteClock;
- blackClock;
- whiteMeter;
- blackMeter;
- gameBoard;

- levelSliding: sender;
- setPreferences: sender;
- openGame: sender;
- saveGame: sender;
- newGame: sender;
- chooseSide: sender;
- hint: sender;
- undoMove: sender;

- (int)makeMoveFrom: (int)r1 : (int)c1 to: (int)r2 : (int)c2;
- setTitle;
- setTitleMessage: (char *)m;
- setWhiteName: (char *)wname blackName: (char *)bname;
- (int)whiteTime;
- (int)blackTime;
- updateClocks: (int)side;
- updateClocks: (int)side seconds: (int) seconds;

- selectMove: (int)side iop: (int)iop;
- selectMoveEnd;
@end
