#include "comment.header"

/* Generated by Interface Builder */

#import <appkit/Application.h>
#include "history.h"
#include "smartgo.h"
#include "igs.h"
#include "godict.h"

extern unsigned char p[19][19], l[19][19], ma[19][19], ml[19][19];
extern char special_characters[19][19];
extern int hist[19][19], currentMoveNumber;
extern int rd, lib, play, pass, handicap, whiteSide, blackSide, MAXX, MAXY;
extern int currentStone, opposingStone, blackCaptured, whiteCaptured;
extern int blackTerritory, whiteTerritory, SmartGoGameFlag, initialization;
extern float black_Score, white_Score;
extern int blackCapturedKoI, blackCapturedKoJ, whiteCapturedKoI, whiteCapturedKoJ;
extern int bothSides, neitherSide, blackPassed, whitePassed, manualScoring, manScoreTemp;
extern int typeOfScoring, AGAScoring;
extern int opn[9];                               // opening pattern flag
extern int gameType;
extern BOOL finished;
extern gameHistory gameMoves[500];
extern int lastMove;
extern node *SGgameMoves, *currentNode;
extern FILE *smartGoInputFile;
extern char *SGfile, *currentSGfilePosition;
extern char *IGSStatusText, IGSPasswordText[20], IGSLoginText[20];

#ifndef KOMI
#define KOMI 5.5
#endif

@interface GoApp:Application
{
  DPSTimedEntry timer;
  id  openReq;
  id  saveReq;
  id  gameWindow;
  id  MainGoView;
  id  handicapSlider;
  id  handicapText;
  id  BlackPlayer;
  id  WhitePlayer;
  id  prefPanel;
  id  savePrefsFlag;
  id  sizeSlider;
  id  sizeText;
  id  smartGoComments;
  id  smartGoPanel;
  id  smartGoNodeName;
  id  smartGoNodeNumber;
  id  smartgoVariants;
  id  stepForwardButton;
  id  stepBackwardButton;
  id  jumpForwardButton;
  id  jumpBackwardButton;
  id  scoringMethod;
  id  scoringType;
  id  AGAscoringMethodFlag;
  id  IGSAddress;
  id  IGSCommand;
  id  IGSSendButton;
  id  IGSStatus;
  id  IGSStatusPanel;
  id  IGSobserveNumber;
  id  IGSPanel;
  id  IGSLoginName;
  id  IGSPassword;
  id  IGSfont;
  id  IGSboldFont;
  id  observeSelPanel;
  id  observeScrollView;
  id  observeMatrix;
  id  observeBox;
  id  observeCell;
  id  versionString;
  id  transTypeMISC;
  id  transTypeNAME;
  id  transTypeCHAM;
  id  transTypeTECH;
  id  transTypePOLI;
  id  transTypeDIGI;
  id  transLangJP;
  id  transLangCH;
  id  transLangRK;
  id  transLangGB;
  id  transLangNL;
  id  transLangGE;
  id  transLangFR;
  id  transLangDG;
  id  transLangCP;
  id  translateWindow;
  id  translateTerm;
  id  translateResults;
  id  translateButton;
}

- appDidInit:app;
- showError: (const char *)errorMessage;
- UserPass:sender;
- stopGame:sender;
- startGame:sender;
- NewGame:sender;
- SetPreferences:sender;
- stepSmartGoFile:sender;
- stepBackSmartGoFile:sender;
- jumpSmartGoFile:sender;
- jumpBackSmartGoFile:sender;
- openNeXTGoFileRequest:sender;
- saveNeXTGoFileRequest:sender;
- openSmartGoFileRequest:sender;
- saveSmartGoFileRequest:sender;
- displayNewSGNode;
- AddSGComment:(char *)s;
- AddSGVariantName:(char *)s;
- SetSGNodeName:(char *)s;
- IGSSendCommand:sender;
- IGSConnect:sender;
- checkNetTraffic;
- SetIGSStatus:(char *)s;
- getGoView;

/*
  The following methods are related to the built-in dictionary
  */
- initTranslator:sender;
- performTranslate:sender;
- addTranslateResults:(char *)s;
- translateOutput:(GODICT *)d;

/*
  The following methods are the various commands for the Internet Go Server
  */

- IGSadjourn:sender;
- IGSbest:sender;
- IGSdecline:sender;
- IGSdecrease:sender;
- IGSdone:sender;
- IGSgames:sender;
- IGSincrease:sender;
- IGSobserve:sender;
- cellClicked:theCell;
- IGSplayers:sender;
- IGSquit:sender;
- IGSranks:sender;
- IGSrefresh:sender;
- IGSreset:sender;
- IGSresign:sender;
- IGSsave:sender;
- IGSstored:sender;
- IGSthist:sender;
- IGSuptime:sender;
- IGSwatching:sender;
- IGSwho:sender;

@end



