#include "comment.header"

#if 0
$Id: shared.h,v 4.9 1992/12/07 00:36:01 davids Exp $
#endif /* LINT */


#ifndef SHARED_H
#define SHARED_H

#ifndef BIT
#define BIT(n) (1L << (n))
#endif /* BIT */
#define MAX_BRD_SZ 25

typedef enum {
	UNKNOWN	=  0,
	BEEP	=  2, 	/* \7 telnet 		*/
	BOARD	=  3,	/* Board being drawn 	*/
	DOWN	=  4,	/* The server is going down */
	ERROR	=  5,	/* An error reported	*/
      	FIL	=  6,	/* File being sent	*/
	GAMES	=  7,	/* Games listing	*/
      	HELP	=  8,	/* Help file		*/
	INFO	=  9,	/* Generic info		*/
	LAST	= 10,	/* Last command		*/
      	KIBITZ	= 11,	/* Kibitz strings	*/
	LOAD	= 12,	/* Loading a game	*/
	LOOK_M	= 13,	/* Look 		*/
      	MESSAGE	= 14,	/* Message lising	*/
      	MOVE	= 15,	/* Move #:(B) A1	*/
	OBSERVE	= 16,	/* Observe report	*/
      	PROMPT	=  1,	/* A Prompt (never)	*/
	REFRESH	= 17,	/* Refresh of a board	*/
      	SAVED	= 18,	/* Stored command	*/
      	SAY	= 19,	/* Say string		*/
      	SCORE	= 20,	/* Score report		*/
      	SHOUT	= 21,	/* Shout string		*/
      	SHOW 	= 29,	/* Shout string		*/
      	STATUS	= 22,	/* Current Game status	*/
	STORED	= 23,	/* Stored games		*/
      	TELL	= 24,	/* Tell string		*/
	THIST	= 25,	/* Thist report		*/
	TIM	= 26,	/* times command	*/
	TRANS	= 30,	/* Translation info	<=== last value */
	WHO	= 27,	/* who command		*/
	UNDO	= 28,	/* Undo report		*/
} MessageType;

#define LOGGEDON WAITING
typedef enum {
	LOGON		= 0,
	PASSWORD	= 1,
	PASSWD_NEW	= 2,
	PASSWD_CONFIRM	= 3, 
	REGISTER	= 4, 
	WAITING		= 5,
	PLAYING		= 6,
	SCORING		= 7,
	OBSERVING	= 8
} State;

typedef enum {
	Unkn_t = 0,
	Game_t,
	Help_t,
	Hand_t,
	Addr_t,
	Char_t,
	Decr_t,
	Defs_t,
	Incr_t,
	Best_t,
	DOT_t,
	AcRe_t,
	Adjo_t,
	Addt_t,
	All_t,
	AMai_t,
	Bug_t,
	Conn_t,
	Cron_t,
	Decl_t,
	Dele_t,
	Done_t,
	DpyR_t,
	Dump_t,
	Exit_t,
	Full_t,
	Info_t,
	Kibi_t,
	Kill_t,
	Komi_t,
	Last_t,
	Load_t,
	Lock_t,
	Look_t,
	Mail_t,
	Matc_t,
	Mess_t,
	Move_t,
	Obse_t,
	Pass_t,
	Play_t,
	PlMv_t,
	PSMa_t,
	Quit_t,
	Rank_t,
	Rati_t,
	Rnks_t,
	Refr_t,
	Reha_t,
	Remo_t,
	Rese_t,
	Resi_t,
	Save_t,
	Say_t,
	Sgf_t,
	Shou_t,
	Show_t,
	Shut_t,
	Spy_t,
	Stus_t,
	Stat_t,
	Stor_t,
	Supe_t,
	Tell_t,
	This_t,
	TIC_t,
	Time_t,
	Togg_t,
	Tran_t,
	Undo_t,
	Upti_t,
	Watc_t,
	Who_t,
	Xsho_t,
	GmRe_t,
	AskM_t,
	InBy_t,
	CnSn_t,
	NAgr_t
} CommandToken;

typedef struct {
	char *str;
	CommandToken tok;
	char NeedArg;
	char SuperCommand;
} SearchComm;

#define NUM_RANKS num_ranks
#define NUM_SPECIAL 2

/*
 * verticies
 */
#define TOP 0
#define MID 1
#define BOT 2


extern int verts[3][MAX_BRD_SZ+1];
extern int num_ranks;
extern char *ranks[];
extern char *prompts[];

#endif /* SHARED_H */

