// DefaultManager.h
// Part of Risk by Mike Ferris

#import <objc/Object.h>
#import <appkit/color.h>

@interface DefaultManager:Object
{
	id	theMapView;
	id  theControlPanel;
	
	id	prefPanel;
	
    id	borderRegularWell;
    id	borderSelectedWell;
    id	borderWidthSlider;
    id	borderWidthTextField;
    id	borderWidthLineView;
    id	setButton;
    id	revertButton;
	id  statusShowSetsCheckbox;
}

- init;

- showPrefPanel:sender;

- revertAction:sender;
- setAction:sender;

- borderWidthAction:sender;
- borderColorAction:sender;
- statusCardSetsAction:sender;

- (float)borderWidth;
- (NXColor)borderRegularColor;
- (NXColor)borderSelectedColor;

// for status view
- (BOOL)statusShowSets;

// for GameSetup preferences
- (const char *)playerColors;
- (const char *)playerNames;
- (const char *)setupOptions;
- setPlayerColors:(char *)colorStr;
- setPlayerNames:(char *)nameStr;
- setSetupOptions:(char *)optionStr;

@end
