//  GameSetup.h
// Part of Risk by Mike Ferris

#import <objc/Object.h>
#import <appkit/color.h>

#define S_NOTPLAYING	0
#define S_HUMAN			1
#define S_COMPUTER		2

#define C_CONST			0
#define C_BYONES		1
#define C_BYFIVES		2

#define CO_PLAYERCHOICE		0
#define CO_RANDOM			1

#define A_BYONES			0
#define A_BYTHREES			1
#define A_BYFIVES			2

#ifndef FR_ONE_ONE_N
	#define FR_NIL				-1
	#define FR_ONE_ONE_N		0
	#define FR_ONE_MANY_N		1
	#define FR_MANY_MANY_N		2
	#define FR_MANY_MANY_C		3
#endif FR_ONE_ONE_N

@interface GameSetup:Object
{
	id	riskController;
    id	setupPanel;
	id	theMover;
	id	theMapView;
	id	theCardManager;
	id	theDefaultManager;

    id	nameForm;
    id	well1;
    id	well2;
    id	well3;
    id	well4;
    id	well5;
    id	well6;
    id	radio1;
    id	radio2;
    id	radio3;
    id	radio4;
    id	radio5;
    id	radio6;
	id	popup1;
	id	popup2;
	id	popup3;
	id	popup4;
	id	popup5;
	id	popup6;

    id	cardRadio;
	id	countryRadio;
	id	armyRadio;
	id	fortifyRadio;
	id armiesTextField;
	
	id aboutMatrix;
	id aboutPanel;
	id aboutIconButton;
	id aboutNameField;
	id aboutScroll;
	
	// current setup
	char *names[6];
	int strategies[6];
	id  computerPlayers[6];
	NXColor colors[6];
	int cardRedemption;
	int countryDistribution;
	int initialArmyPlacement;
	int fortifyRule;
	BOOL compPlayersExist;
	
	BOOL newGame;
}

+ initialize;

- appDidInit:sender;

- free;

- newGame:sender;
- changeSettings:sender;
- doneSetupAction:sender;

- setCurrentFromPanel:sender;
- revertToCurrent:sender;
- defaultSetup:sender;
- writeDefaults;

- (int)numberOfPlayers;
- (NXColor)colorOfPlayer:(int)playerNum;
- (int)strategyOfPlayer:(int)playerNum;
- (const char *)nameOfPlayer:(int)playerNum;
- (int)armiesForCardSet:(int)cardSetNum;
- (int)countryDistribution;
- (int)initialArmyPlacement;
- (int)initialPlaceArmiesForPlayer:(int)p;
- (int)fortifyRule;
- computerPlayerForPlayer:(int)p;

- playerConquered:(int)loser;

- strategyPopupAction:sender;
- computeInitialArmies:sender;

- aboutAction:sender;
- aboutStopAction:sender;

- initCPMenus;

@end
