// LanguageApp.h
//
// by Mike Ferris
// Based loosely on a class of the same name by R Dunbar Poor

#import "LanguageApp.h"

@implementation Application (Language)

- (const char *)applicationDirectory
{
  return [[NXBundle mainBundle] directory];
}

- (const char *)applicationFile:(const char *)fileName
{
  return [self applicationFile:fileName type:(const char *)nil];
}

- (const char *)applicationFile:(const char *)fileName 
			type:(const char *)fileExt;
{
  char pathname[MAXPATHLEN + 1];
  if (fileExt) {
    sprintf(pathname,"%s/%s.%s",[self applicationDirectory],fileName,fileExt);
  } else {
    sprintf(pathname,"%s/%s",[self applicationDirectory],fileName);
  }
  return NXUniqueString(pathname);
}

@end
