//  MapView.h
// Part of Risk by Mike Ferris

#import <appkit/View.h>

@interface MapView:View
{
	// outlets to other key objects
    id	riskController;
    id	theGameSetup;
    id	theMover;
	id	theDefaultManager;
	id	boardBackingImage;
	id	countryNameTextField;
	
	// our internal variables
	id	countryList;
	id  selectedCountry;
	
	id	southAmerica;
	id	northAmerica;
	id	europe;
	id	africa;
	id	asia;
	id	australia;
}

+ initialize;

- initFrame:(NXRect *)frm;
- free;

- appDidInit:sender;
- displayCountry:country;
- drawSelf:(NXRect *)rects :(int)rectCount;
- mouseDown:(NXEvent *)e;
- setSelectedCountry:country;
- (BOOL)doesPlayerWin:(int)pNum;
- (BOOL)playerOccupiesCountries:(int)pNum;
- (BOOL)countriesAreUnoccupied;
- makeAllCountriesUnoccupied;
- (int)numCountriesForPlayer:(int)p;
- (int)armiesForPlayer:(int)p;
- makeContinentLists;
- populateGlobe;
- countryList;
- northAmerica;
- southAmerica;
- europe;
- africa;
- asia;
- australia;

- theDefaultManager;

@end
