// CountryData.h

#define shapeSize(shape) (sizeof(shape)/sizeof(NXCoord))
#define neighborsSize(neighbors) (sizeof(neighbors)/sizeof(int))


// ID Numbers
	// South America
	#define ID_argentina 0
	#define ID_peru 1
	#define ID_venezuela 2
	#define ID_brazil 3

	// North America
	#define ID_centralAmerica 4
	#define ID_westernUS 5
	#define ID_easternUS 6
	#define ID_alberta 7
	#define ID_northwest 8
	#define ID_ontario 9
	#define ID_alaska 10
	#define ID_quebec 11
	#define ID_greenland 12

	// Europe
	#define ID_iceland 13
	#define ID_britain 14
	#define ID_westernEurope 15
	#define ID_southernEurope 16
	#define ID_northernEurope 17
	#define ID_ukraine 18
	#define ID_scandanavia 19

	// Africa
	#define ID_southAfrica 20
	#define ID_congo 21
	#define ID_northAfrica 22
	#define ID_eastAfrica 23
	#define ID_egypt 24
	#define ID_madagascar 25

	// Asia
	#define ID_middleEast 26
	#define ID_india 27
	#define ID_siam 28
	#define ID_china 29
	#define ID_afghanistan 30
	#define ID_ural 31
	#define ID_siberia 32
	#define ID_mongolia 33
	#define ID_irkutsk 34
	#define ID_yakutsk 35
	#define ID_kamchatka 36
	#define ID_japan 37

	// Australia
	#define ID_westernAustralia 38
	#define ID_easternAustralia 39
	#define ID_newGuinea 40
	#define ID_indonesia 41

// Names
	// South America
	#define NM_argentina "Argentina"
	#define NM_peru "Peru"
	#define NM_venezuela "Venezuela"
	#define NM_brazil "Brazil"

	// North America
	#define NM_centralAmerica "Central America"
	#define NM_westernUS "Western United States"
	#define NM_easternUS "Eastern United States"
	#define NM_alberta "Alberta"
	#define NM_northwest "Northwest Territory"
	#define NM_ontario "Ontario"
	#define NM_alaska "Alaska"
	#define NM_quebec "Quebec"
	#define NM_greenland "Greenland"

	// Europe
	#define NM_iceland "Iceland"
	#define NM_britain "Great Britain"
	#define NM_westernEurope "Western Europe"
	#define NM_southernEurope "Southern Europe"
	#define NM_northernEurope "Northern Europe"
	#define NM_ukraine "Ukraine"
	#define NM_scandanavia "Scandinavia"

	// Africa
	#define NM_southAfrica "South Africa"
	#define NM_congo "Congo"
	#define NM_northAfrica "North Africa"
	#define NM_eastAfrica "East Africa"
	#define NM_egypt "Egypt"
	#define NM_madagascar "Madagascar"

	// Asia
	#define NM_middleEast "Middle East"
	#define NM_india "India"
	#define NM_siam "Siam"
	#define NM_china "China"
	#define NM_afghanistan "Afghanistan"
	#define NM_ural "Ural"
	#define NM_siberia "Siberia"
	#define NM_mongolia "Mongolia"
	#define NM_irkutsk "Irkutsk"
	#define NM_yakutsk "Yakutsk"
	#define NM_kamchatka "Kamchatka"
	#define NM_japan "Japan"

	// Australia
	#define NM_westernAustralia "Western Australia"
	#define NM_easternAustralia "Eastern Australia"
	#define NM_newGuinea "New Guinea"
	#define NM_indonesia "Indonesia"
	
// Neighbors
	// South America
	int NE_argentina[2] = {1, 3};
	int NE_peru[3] = {0, 2, 3};
	int NE_venezuela[3] = {1, 3, 4};
	int NE_brazil[4] = {0, 1, 2, 22};
	
	// North America
	int NE_centralAmerica[3] = {2, 5, 6};
	int NE_westernUS[4] = {4, 6, 7, 9};
	int NE_easternUS[4] = {4, 5, 9, 11};
	int NE_alberta[4] = {5, 8, 9, 10};
	int NE_northwest[4] = {7, 9, 10, 12};
	int NE_ontario[6] = {5, 6, 7, 8, 11, 12};
	int NE_alaska[3] = {7, 8, 36};
	int NE_quebec[3] = {6, 9, 12};
	int NE_greenland[4] = {8, 9, 11, 13};
	
	// Europe
	int NE_iceland[3] = {12, 14, 19};
	int NE_britain[3] = {13, 15, 17};
	int NE_westernEurope[4] = {14, 16, 17, 22};
	int NE_southernEurope[6] = {15, 17, 18, 22, 24, 26};
	int NE_northernEurope[5] = {14, 15, 16, 18, 19};
	int NE_ukraine[6] = {16, 17, 19, 26, 30, 31};
	int NE_scandanavia[3] = {13, 17, 18};
	
	// Africa
	int NE_southAfrica[3] = {21, 23, 25};
	int NE_congo[3] = {20, 22, 23};
	int NE_northAfrica[6] = {3, 15, 16, 21, 23, 24};
	int NE_eastAfrica[6] = {20, 21, 22, 24, 25, 26};
	int NE_egypt[4] = {16, 22, 23, 26};
	int NE_madagascar[2] = {20, 23};
	
	// Asia
	int NE_middleEast[6] = {16, 18, 23, 24, 27, 30};
	int NE_india[4] = {26, 28, 29, 30};
	int NE_siam[3] = {27, 29, 41};
	int NE_china[6] = {27, 28, 30, 31, 32, 33};
	int NE_afghanistan[5] = {18, 26, 27, 29, 31};
	int NE_ural[4] = {18, 29, 30, 32};
	int NE_siberia[5] = {29, 31, 33, 34, 35};
	int NE_mongolia[5] = {29, 32, 34, 36, 37};
	int NE_irkutsk[4] = {32, 33, 35, 36};
	int NE_yakutsk[3] = {32, 34, 36};
	int NE_kamchatka[5] = {10, 33, 34, 35, 37};
	int NE_japan[2] = {33, 36};

	// Australia
	int NE_westernAustralia[3] = {39, 40, 41};
	int NE_easternAustralia[2] = {38, 40};
	int NE_newGuinea[3] = {38, 39, 41};
	int NE_indonesia[3] = {28, 38, 40};

// Shapes
	// South America
	NXCoord SH_argentina[16] = {232.0, 13.0, 224.0, 12.0, 208.0, 45.0, 
								203.0, 79.0, 228.0, 82.0, 229.0, 69.0, 
								220.0, 41.0, 232.0, 13.0};
	NXCoord SH_peru[16] = {228.0, 82.0, 203.0, 79.0, 198.0, 106.0, 
						   177.0, 127.0, 176.0, 135.0, 200.0, 129.0, 
						   219.0, 108.0, 228.0, 82.0};
	NXCoord SH_venezuela[16] = {200.0, 129.0, 176.0, 135.0, 182.0, 164.0, 
								190.0, 166.0, 225.0, 163.0, 243.0, 152.0, 
								196.0, 144.0, 200.0, 129.0};
	NXCoord SH_brazil[18] = {229.0, 69.0, 228.0, 82.0, 219.0, 108.0, 
							 200.0, 129.0, 196.0, 144.0, 243.0, 152.0, 
							 275.0, 128.0, 263.0, 87.0, 229.0, 69.0};

	// North America
	NXCoord SH_centralAmerica[20] = {190.0, 166.0, 182.0, 164.0, 137.0, 195.0, 
									 115.0, 224.0, 114.0, 206.0, 108.0, 227.0, 
									 139.0, 224.0, 147.0, 218.0, 150.0, 203.0, 
									 190.0, 166.0};
	NXCoord SH_westernUS[18] = {139.0, 224.0, 108.0, 227.0, 89.0, 247.0, 
								87.0, 272.0, 93.0, 267.0, 136.0, 268.0, 
								156.0, 268.0, 157.0, 242.0, 139.0, 224.0};
	NXCoord SH_easternUS[28] = {147.0, 218.0, 139.0, 224.0, 157.0, 242.0, 
								156.0, 268.0, 178.0, 258.0, 194.0, 245.0, 
								206.0, 256.0, 222.0, 265.0, 224.0, 257.0, 
								199.0, 235.0, 197.0, 220.0, 201.0, 202.0, 
								189.0, 224.0, 147.0, 218.0};
	NXCoord SH_alberta[16] = {136.0, 268.0, 93.0, 267.0, 87.0, 272.0, 
							  87.0, 287.0, 82.0, 300.0, 82.0, 312.0, 
							  136.0, 310.0, 136.0, 310.0};
	NXCoord SH_northwest1[16] = {136.0, 310.0, 82.0, 312.0, 80.0, 354.0, 
								 110.0, 347.0, 126.0, 355.0, 143.0, 347.0, 
								 143.0, 310.0, 136.0, 310.0};
	NXCoord SH_northwest2[10] = {138.0, 363.0, 117.0, 363.0, 114.0, 378.0, 
								 136.0, 377.0, 138.0, 363.0};
	NXCoord SH_northwest3[10] = {103.0, 370.0, 92.0, 370.0, 91.0, 385.0, 
								 103.0, 385.0, 103.0, 370.0};
	NXCoord SH_ontario[22] = {206.0, 256.0, 194.0, 245.0, 178.0, 258.0, 
							  156.0, 268.0, 136.0, 268.0, 136.0, 310.0, 
							  143.0, 310.0, 156.0, 310.0, 188.0, 273.0, 
							  195.0, 256.0, 206.0, 256.0};
	NXCoord SH_alaska[24] = {87.0, 287.0, 73.0, 292.0, 66.0, 311.0, 
							 40.0, 309.0, 35.0, 295.0, 25.0, 291.0, 
							 34.0, 309.0, 41.0, 352.0, 80.0, 354.0, 
							 82.0, 312.0, 82.0, 300.0, 87.0, 287.0};
	NXCoord SH_quebec[24] = {224.0, 257.0, 222.0, 265.0, 206.0, 256.0, 
							  195.0, 256.0, 188.0, 273.0, 209.0, 320.0, 
							  225.0, 320.0, 237.0, 290.0, 247.0, 289.0, 
							  253.0, 280.0, 231.0, 271.0, 224.0, 257.0};
	NXCoord SH_greenland1[20] = {276.0, 306.0, 260.0, 331.0, 262.0, 344.0, 
								252.0, 351.0, 243.0, 385.0, 328.0, 385.0, 
								311.0, 363.0, 306.0, 341.0, 283.0, 332.0, 
								276.0, 306.0};
	NXCoord SH_greenland2[22] = {156.0, 310.0, 143.0, 310.0, 143.0, 347.0, 
							  154.0, 354.0, 149.0, 370.0, 157.0, 371.0, 
							  167.0, 348.0, 177.0, 355.0, 186.0, 353.0, 
							  185.0, 339.0, 156.0, 310.0};
	NXCoord SH_greenland3[14] = {231.0, 329.0, 202.0, 328.0, 193.0, 368.0, 
							  173.0, 370.0, 164.0, 378.0, 202.0, 381.0, 
							  231.0, 329.0};

	// Europe
	NXCoord SH_iceland[10] = {310.0, 315.0, 296.0, 316.0, 298.0, 324.0, 
							  307.0, 325.0, 310.0, 315.0};
	NXCoord SH_britain1[12] = {312.0, 268.0, 301.0, 266.0, 297.0, 281.0, 
							   300.0, 297.0, 304.0, 283.0, 312.0, 268.0};
	NXCoord SH_britain2[8] = {290.0, 266.0, 281.0, 273.0, 286.0, 280.0, 
							  290.0, 266.0};
	NXCoord SH_westernEurope[20] = {328.0, 229.0, 314.0, 216.0, 304.0, 224.0, 
									301.0, 238.0, 331.0, 239.0, 324.0, 259.0, 
									331.0, 264.0, 340.0, 246.0, 338.0, 235.0, 
									328.0, 229.0};
	NXCoord SH_southernEurope[30] = {328.0, 229.0, 338.0, 235.0, 340.0, 246.0, 
									 363.0, 255.0, 365.0, 246.0, 372.0, 242.0, 
									 371.0, 233.0, 359.0, 228.0, 361.0, 217.0, 
									 344.0, 231.0, 347.0, 217.0, 342.0, 211.0, 
									 344.0, 220.0, 334.0, 227.0, 328.0, 229.0};
	NXCoord SH_northernEurope[14] = {363.0, 255.0, 340.0, 246.0, 331.0, 264.0, 
									 337.0, 282.0, 341.0, 271.0, 359.0, 276.0, 
									 363.0, 255.0};
	NXCoord SH_ukraine[44] = {372.0, 242.0, 365.0, 246.0, 363.0, 255.0, 
							  359.0, 276.0, 379.0, 294.0, 374.0, 303.0, 
							  367.0, 343.0, 374.0, 356.0, 388.0, 342.0, 
							  385.0, 333.0, 375.0, 337.0, 385.0, 316.0, 
							  393.0, 321.0, 401.0, 338.0, 452.0, 349.0, 
							  456.0, 295.0, 454.0, 267.0, 438.0, 266.0, 
							  433.0, 236.0, 410.0, 236.0, 401.0, 250.0, 
							  372.0, 242.0};
	NXCoord SH_scandanavia[30] = {374.0, 303.0, 365.0, 300.0, 358.0, 316.0, 
								  363.0, 328.0, 356.0, 335.0, 348.0, 328.0, 
								  353.0, 292.0, 347.0, 288.0, 340.0, 302.0, 
								  332.0, 295.0, 326.0, 311.0, 354.0, 358.0, 
								  374.0, 356.0, 367.0, 343.0, 374.0, 303.0};

	// Africa
	NXCoord SH_southAfrica[12] = {367.0, 48.0, 349.0, 46.0, 345.0, 94.0, 
								  367.0, 92.0, 382.0, 94.0, 367.0, 48.0};
	NXCoord SH_congo[10] = {367.0, 92.0, 345.0, 94.0, 336.0, 117.0, 
							374.0, 125.0, 367.0, 92.0};
	NXCoord SH_northAfrica[18] = {374.0, 125.0, 336.0, 117.0, 329.0, 141.0, 
								  295.0, 145.0, 289.0, 176.0, 316.0, 206.0, 
								  332.0, 199.0, 356.0, 173.0, 374.0, 125.0};
	NXCoord SH_eastAfrica[20] = {382.0, 94.0, 367.0, 92.0, 374.0, 125.0, 
								 356.0, 173.0, 395.0, 169.0, 415.0, 143.0, 
								 421.0, 142.0, 420.0, 131.0, 391.0, 117.0, 
								 382.0, 94.0};
	NXCoord SH_egypt[10] = {395.0, 169.0, 356.0, 173.0, 332.0, 199.0, 
							380.0, 200.0, 395.0, 169.0};
	NXCoord SH_madagascar[10] = {392.0, 57.0, 390.0, 78.0, 404.0, 97.0, 
								 410.0, 88.0, 392.0, 57.0};

	// Asia
	NXCoord SH_middleEast[28] = {451.0, 186.0, 436.0, 161.0, 418.0, 154.0, 
								 388.0, 205.0, 397.0, 216.0, 381.0, 217.0, 
								 380.0, 230.0, 410.0, 236.0, 433.0, 236.0, 
								 452.0, 236.0, 456.0, 204.0, 422.0, 214.0, 
								 426.0, 196.0, 451.0, 186.0};
	NXCoord SH_india[16] = {456.0, 204.0, 452.0, 236.0, 481.0, 236.0, 
							515.0, 195.0, 503.0, 179.0, 498.0, 163.0, 
							478.0, 203.0, 456.0, 204.0};
	NXCoord SH_siam[26] = {515.0, 195.0, 537.0, 202.0, 548.0, 193.0, 
						   539.0, 189.0, 549.0, 174.0, 550.0, 165.0, 
						   538.0, 165.0, 528.0, 177.0, 529.0, 159.0, 
						   540.0, 150.0, 525.0, 158.0, 523.0, 185.0, 
						   515.0, 195.0};
	NXCoord SH_china[24] = {548.0, 193.0, 537.0, 202.0, 515.0, 195.0, 
							481.0, 236.0, 494.0, 274.0, 501.0, 277.0, 
							509.0, 281.0, 539.0, 248.0, 570.0, 237.0, 
							567.0, 222.0, 575.0, 206.0, 548.0, 193.0};
	NXCoord SH_afghanistan[16] = {481.0, 236.0, 452.0, 236.0, 433.0, 236.0, 
								  438.0, 266.0, 454.0, 267.0, 456.0, 295.0, 
								  494.0, 274.0, 481.0, 236.0};
	NXCoord SH_ural[24] = {501.0, 277.0, 494.0, 274.0, 456.0, 295.0, 
						   452.0, 349.0, 460.0, 364.0, 455.0, 374.0, 
						   461.0, 377.0, 466.0, 366.0, 463.0, 344.0, 
						   471.0, 357.0, 479.0, 352.0, 501.0, 277.0};
	NXCoord SH_siberia[28] = {509.0, 281.0, 501.0, 277.0, 479.0, 352.0, 
							  476.0, 371.0, 485.0, 374.0, 487.0, 358.0, 
							  507.0, 385.0, 542.0, 385.0, 534.0, 372.0, 
							  547.0, 373.0, 527.0, 330.0, 511.0, 309.0, 
							  514.0, 283.0, 509.0, 281.0};
	NXCoord SH_mongolia[22] = {570.0, 237.0, 539.0, 248.0, 509.0, 281.0, 
							   514.0, 283.0, 558.0, 274.0, 583.0, 253.0, 
							   584.0, 240.0, 592.0, 225.0, 587.0, 222.0, 
							   578.0, 239.0, 570.0, 237.0};
	NXCoord SH_irkutsk[20] = {583.0, 253.0, 558.0, 274.0, 514.0, 283.0, 
							  511.0, 309.0, 527.0, 330.0, 546.0, 334.0, 
							  568.0, 311.0, 572.0, 278.0, 588.0, 263.0, 
							  583.0, 253.0};
	NXCoord SH_yakutsk[20] = {568.0, 311.0, 546.0, 334.0, 527.0, 330.0, 
							  547.0, 373.0, 579.0, 371.0, 592.0, 355.0, 
							  634.0, 354.0, 641.0, 338.0, 636.0, 321.0, 
							  568.0, 311.0};
	NXCoord SH_kamchatka[34] = {584.0, 240.0, 583.0, 253.0, 588.0, 263.0, 
								572.0, 278.0, 568.0, 311.0, 636.0, 321.0, 
								641.0, 338.0, 634.0, 354.0, 633.0, 365.0, 
								651.0, 364.0, 667.0, 351.0, 665.0, 326.0, 
								644.0, 308.0, 579.0, 292.0, 594.0, 271.0, 
								598.0, 253.0, 584.0, 240.0};
	NXCoord SH_japan[18] = {601.0, 198.0, 603.0, 211.0, 635.0, 240.0, 
							634.0, 258.0, 626.0, 267.0, 633.0, 278.0, 
							644.0, 265.0, 640.0, 226.0, 601.0, 198.0};

	// Australia
	NXCoord SH_westernAustralia[16] = {631.0, 20.0, 624.0, 27.0, 566.0, 31.0, 
									   557.0, 68.0, 592.0, 90.0, 595.0, 66.0, 
									   630.0, 48.0, 631.0, 20.0};
	NXCoord SH_easternAustralia[24] = {631.0, 20.0, 630.0, 48.0, 595.0, 66.0, 
									   592.0, 90.0, 613.0, 92.0, 615.0, 84.0, 
									   639.0, 77.0, 639.0, 95.0, 670.0, 61.0, 
									   671.0, 38.0, 644.0, 12.0, 631.0, 20.0};
	NXCoord SH_newGuinea[10] = {662.0, 112.0, 631.0, 113.0, 613.0, 123.0, 
								667.0, 118.0, 662.0, 112.0};
	NXCoord SH_indonesia1[10] = {600.0, 130.0, 593.0, 123.0, 578.0, 134.0, 
								 589.0, 140.0, 600.0, 130.0};
	NXCoord SH_indonesia2[8] = {586.0, 110.0, 573.0, 111.0, 551.0, 140.0, 
								586.0, 110.0};
	NXCoord SH_indonesia3[8] = {602.0, 145.0, 592.0, 162.0, 599.0, 161.0, 
								602.0, 145.0};

// Army Number Display Points
	// South America
	#define AX_argentina 203.0
	#define AY_argentina 42.0
	#define AX_peru 189.0
	#define AY_peru 92.0
	#define AX_venezuela 184.0
	#define AY_venezuela 146.0
	#define AX_brazil 229.0
	#define AY_brazil 107.0
	
	// North America
	#define AX_centralAmerica 136.0
	#define AY_centralAmerica 186.0
	#define AX_westernUS 111.0
	#define AY_westernUS 237.0
	#define AX_easternUS 162.0
	#define AY_easternUS 229.0
	#define AX_alberta 99.0
	#define AY_alberta 280.0
	#define AX_northwest 99.0
	#define AY_northwest 321.0
	#define AX_ontario 143.0
	#define AY_ontario 273.0
	#define AX_alaska 48.0
	#define AY_alaska 321.0
	#define AX_quebec 204.0
	#define AY_quebec 278.0
	#define AX_greenland 268.0
	#define AY_greenland 354.0
	
	// Europe
	#define AX_iceland 291.0
	#define AY_iceland 303.0
	#define AX_britain 281.0
	#define AY_britain 256.0
	#define AX_westernEurope 300.0
	#define AY_westernEurope 219.0
	#define AX_southernEurope 342.0
	#define AY_southernEurope 226.0
	#define AX_northernEurope 333.0
	#define AY_northernEurope 254.0
	#define AX_ukraine 399.0
	#define AY_ukraine 279.0
	#define AX_scandanavia 331.0
	#define AY_scandanavia 315.0
	
	// Africa
	#define AX_southAfrica 349.0
	#define AY_southAfrica 63.0
	#define AX_congo 341.0
	#define AY_congo 98.0
	#define AX_northAfrica 311.0
	#define AY_northAfrica 156.0
	#define AX_eastAfrica 376.0
	#define AY_eastAfrica 135.0
	#define AX_egypt 355.0
	#define AY_egypt 176.0
	#define AX_madagascar 396.0
	#define AY_madagascar 65.0
	
	// Asia
	#define AX_middleEast 396.0
	#define AY_middleEast 193.0
	#define AX_india 461.0
	#define AY_india 208.0
	#define AX_siam 536.0
	#define AY_siam 168.0
	#define AX_china 512.0
	#define AY_china 221.0
	#define AX_afghanistan 451.0
	#define AY_afghanistan 245.0
	#define AX_ural 459.0
	#define AY_ural 305.0
	#define AX_siberia 493.0
	#define AY_siberia 335.0
	#define AX_mongolia 540.0
	#define AY_mongolia 249.0
	#define AX_irkutsk 529.0
	#define AY_irkutsk 292.0
	#define AX_yakutsk 569.0
	#define AY_yakutsk 329.0
	#define AX_kamchatka 645.0
	#define AY_kamchatka 317.0
	#define AX_japan 622.0
	#define AY_japan 222.0
	
	// Australia
	#define AX_westernAustralia 574.0
	#define AY_westernAustralia 41.0
	#define AX_easternAustralia 634.0
	#define AY_easternAustralia 49.0
	#define AX_newGuinea 634.0
	#define AY_newGuinea 116.0
	#define AX_indonesia 565.0
	#define AY_indonesia 124.0
	