/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
|----------------------------------------------------------------------------
|
|    Klondike:GameModule
|
|    Klondike game controller.
|
|
|  CREDITS
|
|    Gary Ritchie<gary@uaneuro.uah.ualberta.ca>
|        -- conversion to dynamic loading, minor tweaking
|
|    Michael McCulloch<michael@hsv.tybrin.com>
|        -- preferences, artwork
|
|    Blake Stone<bstone@acs.ucalgary.ca>
|        -- original concept and implementation
|
|----------------------------------------------------------------------------
\---------------------------------------------------------------------------*/


#import <appkit/appkit.h>
#import "../Solitaire/GameModule.h"

@interface Klondike:GameModule
{
    id drawPileView;
    id discardPileView;
    
    id gamePileView1;
    id gamePileView2;
    id gamePileView3;
    id gamePileView4;
    id gamePileView5;
    id gamePileView6;
    id gamePileView7;

    id suitPileView1;
    id suitPileView2;
    id suitPileView3;
    id suitPileView4;
    
    id recycleCardPile;
    
    id suitPileDelegate;
    id drawPileDelegate;
    id gamePileDelegate;
    id discardPileDelegate;

    id prevDeck;
}

- setupGame:(BOOL)redeal;

@end
