/* indent:4  tabsize:8  font:fixed-width */

/*--------------------------------------------------------------------------
|- -------------------------------------------------------------------------
|
|	GameCardPileDelegate : Object
|
|	An instance of this class acts as a delegate for messages from 
|	theGame piles in the Pyramid solitaire game.  The game piles are 
|	the piles making up the pyramid.
| --------------------------------------------------------------------------
\--------------------------------------------------------------------------*/

#import <appkit/appkit.h>

@interface GameCardPileDelegate:Object
{
    id discardCardPileViewL;	/* left pile containing cards adding to 13 */
    id discardCardPileViewR;	/* right pile containing cards adding to 13 */
}


/*----------------------------------------------------------------------------
|
|	Delegation setting methods.
|
\---------------------------------------------------------------------------*/

- setDiscardLeft:left discardRight:right;

/*----------------------------------------------------------------------------
|
|	CardPileView delegation methods
|
\---------------------------------------------------------------------------*/

- (BOOL)draggedPile:aCardPile from:gameCardPileView;
- removedPile:aCardPile from:aCardPileView;

- (BOOL)canAcceptPile:aCardPile from:sender in:gameCardPileView;
- acceptPile:aCardPile in:gameCardPileView;
- doubleClickedCard:aCard in:aCardPileView;

@end
