/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
|----------------------------------------------------------------------------
|
|    Pyramid:GameModule
|
|    Pyramid solitaire module.
|
|    CREDITS
|
|    Gary Ritchie<gary@uaneuro.uah.ualberta.ca>
|        -- design, implementation, documentation
|
|----------------------------------------------------------------------------
\---------------------------------------------------------------------------*/


#import <appkit/appkit.h>
#import "../Solitaire/GameModule.h"

@interface Pyramid:GameModule
{
    id gameDelegate;
    id wasteDelegate;
    id stockDelegate;
    id discardDelegate;
    
    id stockCardPileView;	/* stock pile */
    id wasteCardPileView;	/* waste pile */
    id discardCardPileViewL;	/* left pile holding matching pairs */
    id discardCardPileViewR;	/* right pile holding matching pairs */
    
    id gamePileGroupView;	/* a group of the following 28 pileViews */    
    id gamePileView1;		/* pyramid piles, starting at the top point */
    id gamePileView2;
    id gamePileView3;
    id gamePileView4;
    id gamePileView5;
    id gamePileView6;
    id gamePileView7;
    id gamePileView8;
    id gamePileView9;
    id gamePileView10;
    id gamePileView11;
    id gamePileView12;
    id gamePileView13;
    id gamePileView14;
    id gamePileView15;
    id gamePileView16;
    id gamePileView17;
    id gamePileView18;
    id gamePileView19;
    id gamePileView20;
    id gamePileView21;
    id gamePileView22;
    id gamePileView23;
    id gamePileView24;
    id gamePileView25;
    id gamePileView26;
    id gamePileView27;
    id gamePileView28;

    id prevDeck;		// for implementing "restart game" option
    id gameCardPiles[28];       // array'd references to above 28 views

    int dealCount;              // number of passes through the stock pile
                                // "1" indicates we are on the first pass
    BOOL gameInProgress;        // TRUE unless user has won/lost game
    BOOL pyramidEmpty;
}


- setupGame:(BOOL)redeal;

- (int)dealCount;
- setDealCount:(int)count;
- incDealCount;
- determineScore;

@end
