/* indent:4  tabsize:8  font:fixed-width */

/*--------------------------------------------------------------------------
|---------------------------------------------------------------------------
|
|	StockCardPileDelegate : Object
|
|	An instance of this class acts as a delegate for messages from the 
|	Stock Pile in the Pyramid solitaire game.
| --------------------------------------------------------------------------
\--------------------------------------------------------------------------*/

#import <appkit/appkit.h>

@interface StockCardPileDelegate:Object
{
    id discardCardPileViewL;	/* left pile containing cards that add to 13 */
    id discardCardPileViewR;	/* right pile containing cards adding to 13 */
    id wasteCardPileView;	/* the wastepile */
    id alertPanel;
}

/*----------------------------------------------------------------------------
|
|	Delegate-setting methods
|
\---------------------------------------------------------------------------*/

- setDiscardLeft:left discardRight:right waste:waste;

/*----------------------------------------------------------------------------
|
|	CardPileView delegation methods
|
\---------------------------------------------------------------------------*/

- clickedCard:aCard in:stockCardPileView;
- (BOOL)canAcceptPile:aCardPile from:sender in:stockCardPileView;

@end
