/* indent:4  tabsize:8  font:fixed-width */

/*--------------------------------------------------------------------------
|---------------------------------------------------------------------------
|
|	WasteCardPileDelegate : Object
|
|	An instance of this class acts as a delegate for messages from the
|	Waste Pile in the Pyramid solitaire game.
| --------------------------------------------------------------------------
\--------------------------------------------------------------------------*/

#import <appkit/appkit.h>

@interface WasteCardPileDelegate:Object
{
    id discardCardPileViewL;	/* the left discard pile */
    id discardCardPileViewR;	/* the right discard pile */
}

/*----------------------------------------------------------------------------
|
|	Delegation setting methods.
|
\---------------------------------------------------------------------------*/

- setDiscardLeft:left discardRight:right;


/*----------------------------------------------------------------------------
|
|	CardPileView delegation methods
|
\---------------------------------------------------------------------------*/

- (BOOL)canAcceptPile:aCardPile from:sender in:wasteCardPileView;
- acceptPile:aCardPile in:wasteCardPileView;
- (BOOL)draggedPile:aCardPile from:wasteCardPileView;
- doubleClickedCard:aCard in:aCardPileView;


@end
