/* indent:4  tabsize:8  font:fixed-width */

#import "GamePref.h"

@implementation GamePref


/*---------------------------------------------------------------------------
|
|    - setGameName:(const char *)name
|
|    returns: (id) self
|
|----------------------------------------------------------------------------
|
|    Set the name used to register preferences.
|			
\---------------------------------------------------------------------------*/
- setGameName:(const char *)name
{
    char buffer[256];
    
    sprintf(buffer, "Solitaire%s", name);
    gameName = NXCopyStringBufferFromZone(buffer, [self zone]);
    [self registerPrefs];
    return self;
}

/*---------------------------------------------------------------------------
|
|    - registerPrefs
|
|    returns: (id) self
|
|----------------------------------------------------------------------------
|
|    Register the preferences for this game.  Override this if the game
|    has preferences to register.
|			
\---------------------------------------------------------------------------*/

- registerPrefs
{
    const NXDefaultsVector gameDefaults =
    {
        {NULL, NULL}
    };

    NXRegisterDefaults(gameName, gameDefaults);

    return self;
}


@end
