/* indent:4  tabsize:8  font:fixed-width */

/*----------------------------------------------------------------------------
|-----------------------------------------------------------------------------
|
|    Preferences : Object
|
|-----------------------------------------------------------------------------
\----------------------------------------------------------------------------*/


#import <appkit/appkit.h>
#import "CardSet.subproj/cardset.h"


@interface Preferences:Object
{
    id	backgroundColorWell;
    id	cardBackMatrix;
    id	cardSizeMatrix;
    id  preDrawSwitch;
    id	cardBackImage;
    id	sCardBackImage;
    id	preferencesPanel;
    id	statusPanel;
    id	messageField;
	 
    NXColor backgroundColor;
    CardSize cardSize;
    CardBack cardBack;
    BOOL preDrawCards;
    char *imageFileName;
    BOOL foundFile;
}

- init;
- defaults:sender;
- saveColor:sender;
- saveCardSize:sender;
- saveCardBack:sender;
- savePreDrawState:sender;
- setNewImage:sender;
- showPreferences:sender;
- (CardSize)returnCardSize;
- (CardSize)returnCardBack;
- (NXColor)returnBackgroundColor;
- returnImageForSize:(CardSize)aSize;
- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (NXDragOperation)draggingUpdated:(id <NXDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NXDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;
- concludeDragOperation:(id <NXDraggingInfo>)sender;

@end
