
#import <appkit/Application.h>

@interface TetApp:Application
{
    id tetrisView;				  // The view where the action takes place.
    id level;
    id levelLeft;
    id levelRight;
    id pauseButton;
    id pauseDisplay;
    id scoreKeeper;
    id showNext;
    id startButton;
    id tetrisWindow;				  // The Main window
	 id controlBox;
	 id controlWindow;			  // The control panel's window
	 id colorSwitch;				  // Color Switch id on Control Panel
	 id randomField;				  // Number of random rows field on Control Panel
	 id randomSlider;
    BOOL started;
    BOOL paused;
	 BOOL gameInColor, colorOff;
	 int numRandomRows;
	 id showNextSwitch;
}

+ new;

- setLevelLeft:anObject;
- setLevelRight:anObject;
- setTetrisWindow:anObject;

- appDidInit:sender;
- resignActiveApp;

- start:sender;
- pause:sender;

- gameOver;
- (BOOL) isGameColor;

- levelLeft:sender;
- levelRight:sender;
- adjustColor:sender;

- terminate:sender;
- windowWillMiniaturize:sender toMiniwindow:miniwindow;

// Private methods
- updateRight:(int) theLevel;
- updateLeft:(int) theLevel;
- setRandomRows:sender;

@end
