
#import "Piece.h"
#import "Minimatrix.h"

#define TETRIS_COLUMNS	10
#define TETRIS_ROWS	25
// There four different ways to view a piece: up, down, left, right

#define MIN_LEVEL	0
#define MAX_LEVEL	9

@interface TetMatrix:Minimatrix
{
    BOOL pieceVisible;
    BOOL active;
    id thePiece;					  // The current piece; a Piece Object 
    id scoreKeeper;
    id anmBitmap;
    id showNext;					  // The next piece object: NextMatrix.m
	 id aCheater;
	 id controlBox;				  // The box containing all of the controls
    float level;
    DPSTimedEntry timedEntryNum;
    BOOL gameRunning;
	 BOOL colorWindow;			  // canStoreColor?
    double teDelay;				  // Determines how fast a piece will fall.
	 float anm_gameover_delta;	  // The # pixels to move "Game Over" at a time
	 id randomFields;
}

- initFrame:(const NXRect *)frameRect;
- setupRandomFill:(int)max;
- (BOOL)acceptsFirstResponder;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- keyDown:(NXEvent *)theEvent;

- removeFilledRows;

- setPieceVisible:(BOOL)flag;
- setScoreKeeper:keeper;
- newGame:(int)theLevel;
- pause:sender;
- continue:sender;
- stop:sender;

- startTimedEntry;
- stopTimedEntry;

- free;

@end
