
#import <appkit/appkit.h>

/*  pCD_Types defines ov_Tags, is_Tags, ppag_Tags, and iwd_Tags (the
 *  values of which must match Tags in nib files), and ovImageArray.
*/
#import "pCD_Types.h"


@interface Controller:Object
{
	// for "internal" ids (those which are not IB-connected)
#	define intr_id id
	intr_id overviewId;		// id of active overview

	id	ov_10x2_Id;		// wide overview
	id	ov_6x7_Id;		// standard overview
	id	ov_2x12_Id;		// thin (and tall) overview
	enum	ov_Tags overviewLayoutTag;

	SavePanel *sp;
	id	saveAccessory;
	id	saveMatrix;
	int	saveTo;
	PrintPanel *pp;
	id	printAccessory;
	id	printMatrix;
	int	printWhich;
	int	printPagination;
	char	*volumeDir;
	id	photoWindow;
	intr_id	infoPanel;
	id	pCD_Reader;
	id	readStatusPanel;
	id	readStatusField;
	id	prefsPanel;
	id	prefsResolutionMatrix;
	id	prefsSizeMatrix;
	id	prefsLayoutMatrix;
	id	prefsPaginationMatrix;
	id	prefsSharpenSwitch;
	id	prefsNGammaSwitch;
	enum is_Tags	globImageSize;
	int	globImageResolution;
	BOOL	globSharpenImage;
	BOOL	globNextGamma;

	int	pasteCounter;		// so Pastes get unique window titles
	
	// array of ids matching all the overview images.
	int	ovImageCount;
	ovImageArray	ovImageIds;
	int	overviewReadMax;	// max to read into ovImageIds

}

- readOverview;
- saveTo:sender;
- printSel:sender;
- changeSaveType:sender;
- changePrintType:sender;
- (BOOL)shouldRunPrintPanel:aView;
- loadOverviewNib:(enum ov_Tags)overviewTag andSave:(BOOL)saveDefault;
- openPCD:sender;
- (int)nextPasteCounter;

// actions that cause windows to appear
- showInfoPanel:sender;
- showPrefsPanel:sender;
- showOverviewWindow:sender;
- showImage:(int)pictNumber atSize:(enum is_Tags)imageSizeWanted
			     atRes:(int)imageResolutionWanted;

// preference panel actions
- setPrefImageResolution:sender;
- setPrefImageSize:sender;
- setPrefNextGamma:sender;
- setPrefOverviewLayout:sender;
- setPrefPagination:sender;
- setPrefSharpen:sender;

@end
