/* hpcdtoppm (Hadmut's pcdtoppm) v0.4
*  Copyright (c) 1992, 1993 by Hadmut Danisch (danisch@ira.uka.de).
*  Permission to use and distribute this software and its
*  documentation for noncommercial use and without fee is hereby granted,
*  provided that the above copyright notice appear in all copies and that
*  both that copyright notice and this permission notice appear in
*  supporting documentation. It is not allowed to sell this software in 
*  any way. This software is not public domain.
*/



/* define OWN_WRITE either here or by compiler-option if you don't want to use
   the pbmplus-routines for writing */
/* #define OWN_WRITE */



/* define DEBUG for some debugging informations */
/* #define DEBUG */


/* define DO_DECL_EXT for external declaration of system and library calls */
#define DO_DECL_EXT
#ifdef __NeXT__		/* not needed on NeXTSTEP */
#   undef DO_DECL_EXT
#endif


/* define FASTHUFF for faster Huffman decoding with tables.
** this makes a little speedup, but needs about 768 KByte memory
*/
#define FASTHUFF



#ifdef OWN_WRITE
/* If the own routines are used, this is the size of the buffer in bytes.
   You can shrink if needed. */
#define own_BUsize 50000

/* The header for the ppm-files */
#define PPM_Header "P6\n%ld %ld\n255\n"
#define PGM_Header "P5\n%ld %ld\n255\n"


#endif



/* fopen Parameters, for some systems (MS-DOS :-( ) you need "wb" and "rb" */
#define W_OP "w"
#define R_OP "r"




/*
** Data Types
** Important: sBYTE must be a signed byte type !
** If your compiler doesn't understand "signed", remove it.
*/

#ifndef sBYTE
typedef   signed char sBYTE;
#endif

typedef unsigned char uBYTE;
typedef unsigned long dim;
typedef          long sdim;



/* Default taken when no size parameter given,
** C_DEFAULT depends on your taste and video-hardware,
*/

#define S_DEFAULT S_Base16
#define O_DEFAULT O_PPM
#define C_DEFAULT C_LINEAR
#define T_DEFAULT T_AUTO


/* Background and orientation for contact sheet */
#define CONTLUM neutrLum
#define CONTCH1 neutrCh1
#define CONTCH2 neutrCh2
#define CONTORI T_LEFT



/* Maximum Black value of frame for cutting of the
** frame. If MAX_BLACK is n, a frame is detected, when
** all Luma values are within [ 0 .. (n-1) ]
*/
#define MAX_BLACK 1

/* Default Postscript paper size
** (German DIN A 4 )
*/
#define DEF_PAPER_LEFT    50.0
#define DEF_PAPER_BOTTOM  50.0
#define DEF_PAPER_WIDTH  500.0
#define DEF_PAPER_HEIGHT 750.0




/* External Declarations */
#ifdef DO_DECL_EXT

extern int fprintf();
extern int fclose();
extern char *malloc();
extern int fseek();
extern int fread();
extern int fwrite();
extern int sscanf();    
extern int fputs();

#endif







