#import <appkit/Application.h>


@interface ContourPlotApp:Application
{
    id contourView;
    id commentText;
    id versionField;
    id openPanel;

    id nlevelField;			// # of contour levels field
    id xgStepField;
    id ygStepField;			// y grid spacing field
    id nxField;				// original data X num points field
    id nyField;
    id nxInterpField;			// Field for X number of points to interpolate to
    id nyInterpField;			// Field for Y number of points to interpolate to
    id xminField;
    id xmaxField;
    id yminField;
    id ymaxField;

    id tickSwitch;
    id gridSwitch;
    id axisSwitch;

    id brightCWell;
    id darkCWell;
    id bgCWell;
    id lineCWell;		/* line color */

    int nxInterp;			// X number of points to interpolate to
    int nyInterp;			// Y number of points to interpolate to

    // Actual data
    int		nx, ny;			// # of X Y points of loaded data
    float	xmin, xmax;
    float	ymin, ymax;
    float	*zdata;			// 2-d grid data
    float	xgstep, ygstep;		// grid increment
}

- appDidInit:sender;
- openSample:sender;
- viewSampleFile:sender;
- open:sender;
- openFile:(const char *)fileName;
- setDataToContourView;

- setNcontourLevels:sender;
- setLineWidth:sender;
- setGridSpacing:sender;
- setNInterpolation:sender;

- clearAction:sender;
- drawAction:sender;
- colorWellsAction:sender;
- useColorAction:sender;
- setGridMesh:sender;
- setTickMark:sender;
- setAxis:sender;
- flipYAction:sender;

- windowDidResize:sender;

@end
