
/* $Id: FunctionObject.h,v 1.1.1.1 1993/03/18 03:33:12 davis Exp $ */

#import "SubObject.h"

#define FUNCTION_NOSTYLE	99
#define	FUNCTION_LINES		0
#define FUNCTION_POINTS		1
#define FUNCTION_LINESPOINTS	2
#define FUNCTION_DOTS		3
#define FUNCTION_IMPULSES	4
#define FUNCTION_ERRORBARS	5
#define FUNCTION_BOXES		6
#define FUNCTION_BOXERRORBARS	7

#define POINTS_NOSTYLE		0
#define LINE_NOSTYLE		0

@interface FunctionObject:SubObject
{
    BOOL	isDataFile;	/* Is stringValue path of a data file?	*/
    char	*title;		/* Optional key title			*/
    int		style;		/* Optional style			*/
    int		pointsStyle;	/* Kind of points (if style has points)	*/
    int		lineStyle;	/* Kind of line (if style has points)	*/
}

+ (BOOL) isAcceptableStringValue:(const char *)aString;
+ (BOOL) isAcceptableDataFile:(const char *)aString;

- initFromString:(const char *)aString;
- free;

- setDataFile:(BOOL)cond;
- (BOOL)isDataFile;

- setTitle: (const char *)aString;
- (const char *)title;

- setStyle: (int)anInt;
- (int)style;
- (const char *)styleString;

- setPointsStyle: (int)anInt;
- (int)pointsStyle;

- setLineStyle: (int)anInt;
- (int)lineStyle;

- (BOOL)isAttachment;

@end
