
/* $Id: Gnuplot.h,v 1.1.1.1 1993/03/18 03:33:22 davis Exp $ */

#import <objc/Object.h>

@interface Gnuplot:Object
{
    NXZone *zone;		/* Our zone				*/

    id infoPanel;		/* Info Panel				*/
    id revisionTextField;	/* In infoPanel. Auto-updated by RCS	*/
    id copyingPanel;		/* Copyright Panel			*/
    id inspector;		/* Inspector Panel			*/
    id preferences;		/* Preferences object			*/

    id stringSet;		/* Localization string table		*/

    id docList;			/* List of documents currently open	*/
    id currentDoc;		/* Doc with most recent main window	*/
    int numUntitled;		/* # of Untitled docs created since launch */

    BOOL isPoweringOff;		/* Is user powering off or logging out?	*/
}

#define DOCUMENT_TYPE	"gnuplot"



/** Class methods for handling app-wide preferences **/

+ setConstantUpdate:(int)updateType;
+ setHalvePlot:(BOOL)condition;
+ setAddDataToCurrentEnabled:(BOOL) aBool;
+ setAddDataToNewEnabled:(BOOL) aBool;


- init;

- stringSet;				/* Returns the app's string set	*/



/** Target/Action **/

- showInfoPanel:sender;
- showCopyingPanel:sender;
- showPreferencesPanel:sender;
- showInspectorPane:sender;
- new:sender;
- open:sender;
- saveAll:sender;

- updateApp;			/* Updates panels that reflect current doc */



/** Interacting With Documents **/

- docDidClose:sender;
- isDocOpen: (const char *) fullPath;
- (int)numberNew;			/* Returns numUntitled		*/
- setCurrentDoc:aDoc;



/** Menu Auto-Update Methods **/

- (BOOL)menuItemUpdate:menuCell;
- (BOOL)validateCommand:menuCell;



/** Application delegate **/

- (int)app:sender openFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;



/** 
 ** Services.  These messages are sent when a user chooses one of our 
 ** items from the services menu.
 **/

- plotData:pb userData:(const char *)userData error:(char **)errorMessage;


 @end
