
/* $Id: Inspector.h,v 1.1.1.1 1993/03/18 03:33:47 davis Exp $ */

#import <objc/List.h>
#import <objc/Object.h>
#import <objc/hashtable.h>		/* NXAtom */

#define NO_INSPECTOR		0
#define GENERAL_INSPECTOR	1
#define DATA_INSPECTOR		2
#define AXES_INSPECTOR		3
#define THREED_INSPECTOR	4

@interface Inspector:Object
{
    id	window;				/* The multi-inspector panel	*/
    int	windowWidth;

    id	noPane;				/* The panes and their views	*/
    id	noView;
    id	generalPane;
    id	generalView;
    id	dataPane;
    id	dataView;
    id	axesPane;
    id	axesView;
    id	threeDPane;
    id	threeDView;

    id	currentPane;			/* One of the above panes	*/
    id	currentView;

    id	buttonMatrix;

    id	status;				/* Current status		*/
    id	gnuplotPlot;			/* Current plot			*/

    id	stringSet;			/* Inspector's string table	*/


    id	plotButton;

}

- init;

- window;			/* Returns the inspector window		*/

/* 
 *  Services.  (These work because we're the delegate of the inspector 
 *  window.)
 */
- validRequestorForSendType:(NXAtom)sendType andReturnType:(NXAtom)returnType;
- (BOOL)writeSelectionToPasteboard:pboard types:(NXAtom *)types;

- update;			/* Update the current pane		*/

- doPlot:sender;		/* Tell GnuplotPlot to replot		*/

- windowDidUpdate:sender;	/* Make interface match current settings*/

- selectPane:(int)aPane;

- showNoPane:sender;		/* Target/Action			*/
- showGeneralPane:sender;
- showDataPane:sender;
- showAxesPane:sender;
- showThreeDPane:sender;

@end
