
static char RCSId[]="$Id: StatusTics.m,v 1.1.1.1 1993/03/18 03:35:42 davis Exp $";


#import "StatusTics.h"

@implementation Status (Tics)


- setTicsIn:(BOOL) cond
{
    if (s_tics_in != cond) {
	s_tics_in = cond;
	[self reportSettingsChange:self];
    }
    return self;
}


- (BOOL) ticsIn
{
    return s_tics_in;
}



- setTicsCoord:(int)coord isOn:(BOOL)isOn
{
    if (s_ticsCoord[coord] != isOn) {
	s_ticsCoord[coord] = isOn;
	[self reportSettingsChange:self];
    }
    return self;
}


- (BOOL) ticsCoord:(int)coord
{
    return s_ticsCoord[coord];
}



- setTicTypeCoord:(int)coord to:(int)anInt
{
    if (s_ticTypeCoord[coord] != anInt) {
	s_ticTypeCoord[coord] = anInt;
	[self reportSettingsChange:self];
    }
    return self;
}



- (int)ticTypeCoord:(int)coord
{
    return s_ticTypeCoord[coord];
}



- setTicStartCoord:(int)coord to:(double)aDouble
{
    if (s_ticSeriesCoord[coord].start != aDouble) {
	s_ticSeriesCoord[coord].start = aDouble;
	[self reportSettingsChange:self];
    }
    return self;
}


- (double)ticStartCoord:(int)coord
{
    return s_ticSeriesCoord[coord].start;
}



- setTicEndCoord:(int)coord to:(double)aDouble
{
    if (s_ticSeriesCoord[coord].end != aDouble) {
	s_ticSeriesCoord[coord].end = aDouble;
	[self reportSettingsChange:self];
    }
    return self;
}


- (double)ticEndCoord:(int)coord
{
    return s_ticSeriesCoord[coord].end;
}



- setTicIncrementCoord:(int)coord to:(double)aDouble
{
    if (s_ticSeriesCoord[coord].incr != aDouble) {
	s_ticSeriesCoord[coord].incr = aDouble;
	[self reportSettingsChange:self];
    }
    return self;
}


- (double)ticIncrementCoord:(int)coord
{
    return s_ticSeriesCoord[coord].incr;
}



- (DoubleValueSortedList *)ticDefsCoord:(int)coord
{
    return ticDefs[coord];
}



// Shuts up compiler

- (const char *) rcsid
{
    return RCSId;
}

@end
