/*
** proj.h
** header file for proj.c
**
** for project : MapMaker  
** using NeXTStep and mach Unix.
** CPSC 414 Assignment No. 4 Project
**  
** Programmed by Bradley Head and Thomas Burkholder 
** December 1990
*/

#import <stdio.h>
#import <math.h>
#import "pointdata.h"

#define  PI 3.14159
#define toRADS 0.0174532

/*
*   TypeDefinitions
*/

typedef  enum {ORTHO, ECKERT ,SINUSOIDAL, MERCATOR, STEREO, MOLLWEIDE, CYLINDER,NONE} Projtype;

typedef struct ProjParam { 
	float radius;
	float lon0;
	float phi1;
	float phi2;
	Projtype proj;
	} ProjParam; 

/* 
**   Function Prototypes
*/
 int Cylindrical(Point *posn, ProjParam *init, Point *pp);
 int EckertIV(Point *posn, ProjParam *init, Point *pp);
 int Mercator(Point *posn, ProjParam *init, Point *pp);
 int Mollweide(Point *posn, ProjParam *init, Point *pp);
 int Ortho(Point *posn, ProjParam *init, Point *pp);
 int Sinusoidal(Point *posn, ProjParam *init, Point *pp);
 int Stereo(Point *posn, ProjParam *init, Point *pp);
 
void ComputePoints(int (*proj)(Point *posn, ProjParam *init, Point *pp), ProjParam *init,PointList *inlist,PointList *outlist);

 int convertPoints(PointList *pin, PointList *pout, int gridon, ProjParam *init);
 void DoGrid(PointList *gridlist);
 void DoFrame(PointList *framelist);
  



 








