/*	ModelController.m - Interface to selecting model
 *	Copyright (C) 1993 Corona Design, Inc. All rights reserved.
 *
 *	Abstract
 *		Encapsulates the user interface for selecting a scene model.
 *
 *	RCS path: 
 *		$Source: /Users/pkron/Projects/voxel/Pyramid/RCS/ModelController.m,v $
 *	Modified: $Date: 93/09/15 12:35:08 $ by $Author: pkron $
 *	Current State: $State: Exp $ locked by $Locker:  $
 */

#import		"ModelController.h"
#import		"standard.h"

#import		"Kitchen.h"
#import		"Pyramid.h"
#import		"Tesselmeer.h"
#import		"SpatialView.h"


@implementation	ModelController

								// determine model from radio button
- selectModel: sender;
	{
	id		model;
	const char	*modelClassName;
	
	modelClassName = [[sender selectedCell] title];
	if ( strcmp( modelClassName, "Tesselmeer") EQ 0 )
		model = [[Tesselmeer alloc] init];
	else if ( strcmp( modelClassName, "Kitchen") EQ 0 )
		model = [[Kitchen alloc] init];
	else
		model = [[Pyramid alloc] init];
	
	[view useModel: model];
	return( self);
	}
	

@end

#ifdef	_LOG
/*
 *	$Log:	ModelController.m,v $
Revision 1.1  93/09/15  12:35:08  pkron
Created.

 */
#endif		
