/*	SpatialView.h - Display 3D image
 *	Copyright (C) 1993 Corona Design, Inc. All rights reserved.
 *
 *	Abstract
 *		Manages the dynamic display of a 3D scene.
 *
 *	RCS path: 
 *		$Source: /Users/pkron/Projects/voxel/Pyramid/RCS/SpatialView.h,v $
 *	Modified: $Date: 93/09/15 12:35:15 $ by $Author: pkron $
 *	Current State: $State: Exp $ locked by $Locker:  $
 */

#import <appkit/appkit.h>
#import	"standard.h"
#import	"perspect.h"

@interface SpatialView: View
	{
	id		showVanishingPoints;
	id		showMoon;
	id		transformController;
	id		model;

	NXRect	clip;
	MATRIX	transform;
	POINT	moon;
	}

- changePerspective:  sender;

- drawMoon: (NXRect *)moonClip;
- useModel: anObject;

@end

								// basic protocol for models
@interface	SpatialModel : Object
	{
	}
	
- drawModel: (MATRIX)transform : (NXRect *)clip;
- drawVanishingPoints: (MATRIX)transform : (NXRect *)clip;


@end

#ifdef	_LOG
/*
 *	$Log:	SpatialView.h,v $
 * Revision 1.1  93/09/15  12:35:15  pkron
 * Created.
 * 
 */
#endif		
