/*

File CrosswordSquare.h

Crossword squares are the elements of a crossword matrix.  Each square is either transparent, in which case it appears as black, or contains a letter.  A square with a letter may be drawn using any color combination.  A square can also display a clue number in its upper left hand corner.

*/

#import <appkit/Cell.h>
#import <appkit/color.h>


/*   */


#define	EMPTY	-1

typedef struct {
					NXColor		background;
					NXColor		text;
	} squareColor;


/*   */


@interface CrosswordSquare:Cell
{
	BOOL			opaque;
	char			letter;
	int				number;
	squareColor		color;
	id				data;
}

- (BOOL) isOpaque;
- (char) getLetter;
- (int) getNumber;
- (squareColor) getColor;
- (id) getData;
- setLetter: (char) theLetter;
- setNumber: (int) theNumber;
- setColor: (squareColor) theColor;
- setData: (id) theData;
- init;
- write: (NXTypedStream *) stream;
- read: (NXTypedStream *) stream;
- (BOOL) startTrackingAt: (NXPoint *) point  inView: (id) matrix;
- paint: (id) matrix;
- drawInside: (const NXRect *) frame  inView: (id) matrix;

@end