/*

File DepthFirstSearch.h

This search is a standard depth first one.  At each step, the variable with the highest efficiency is selected and filled.  The search backtracks when a variable has no remaining values.

It is the responsibility of the variables to implement any special heuristics like backjumping and leapfrogging.

*/

#import <objc/Object.h>


/*   */


@interface DepthFirstSearch:Object
{
	id		variables;
	id		last;
	BOOL	ok;
	int		next;
	int		count;
}

- (BOOL) startSearch: (id) theVariables;
- (BOOL) continue;
- (BOOL) step;
- (BOOL) done;
- (BOOL) fill: (id) variable;
- findBest;

@end


/*   */


@interface Variable:Object
{
}

- (float) efficiency;
- (BOOL) fillNext;
- erase;
- hilight;
- unhilight;

@end