/*

File Notifier.h

A notifier alerts other objects when its status either changes or will change.  An object typically responds to the notification message by updating information that depends on the notifying object.

Objects that register for notification must respond to the update:message: method.  The first argument to this method is the object sending the notification.  The second is an integer that identifies the message.

*/

#import <objc/Object.h>


/*   */


	//	 standard general purpose messages

#define DIDCHANGE		0
#define WILLFREE		1


/*   */


@interface Notifier:Object
{
	id		receivers;
}

- init;
- free;
- signup: (id) object;
- unsignup: (id) object;
- notify: (int) message;

@end


/*   */


@interface Receiver:Object
{
}

- update: (id) object  message: (int) theMessage;

@end