/*

File PlainSquare.h

Squares are the variables that guide the search.  This file implements simple squares for plain depth first search.

*/

#import <objc/Object.h>

#import "CrosswordSquare.h"
#import "Dictionary.h"


/*   */


#define HILIGHT		1 << 0


/*   */


typedef struct {
					id		word;
					int		i;
	} wordPosition;


/*   */


@interface PlainSquare:Object
{
	id					puzzle;
	id					words;
	CrosswordSquare		* cell;
	float				efficiency;
	int					count [LETTERS];
	char				letter;
	int					tried;
	int					status;
}

- (float) efficiency;
- initPuzzle: (id) thePuzzle  cell: (id) theCell;
- free;
- addToWord: (id) word  at: (int) i;
- startOver;
- setStatus: (int) flag;
- clearStatus: (int) flag;
- hilight;
- unhilight;
- adjustColor;
- (BOOL) fillNext;
- erase;
- clear;
- show;
- (char) chooseLetter;
- setLetter: (char) theLetter;
- update;

@end