/*

File Puzzle.h

The puzzle object links a crossword matrix to a dictionary and a search.  The puzzle has various inspectable parameters that the user can set to control the type of search.

*/

#import <objc/Object.h>

#import "Crossword.h"
#import "Inspector.h"
#import "Dictionary.h"


/*   */


#define MAXLENGTH		150


/*   */


@interface Puzzle:Object
{
	char			filename [MAXLENGTH];
	id				window;
	Crossword		* crossword;
	Inspector		* inspector;
	Dictionary		* dictionary;
	id				search;
	id				state;
	BOOL			canContinue;
}

- getCrossword;
- getInspector;
- getDictionary;
- getState;
- (BOOL) canContinue;
- free;
- newSearch: sender;
- continue: sender;
- step: sender;

@end