/*

File WinDelegate.h

The window delegate file categorizes the puzzle methods that relate to the crossword window.  These methods save a puzzle to a file, as well as handling details of resizing and inspecting.

*/

#import "Puzzle.h"
#import <dpsclient/dpsclient.h>


/*   */


@interface Puzzle (WinDelegate)

- (BOOL) save: sender;
- (BOOL) saveAs: sender;
- (BOOL) saveTo: sender;
- (BOOL) writePuzzle: (const char *) file;
- readPuzzle: (const char *) file;
- new;
- number: sender;
- use: sender;
- updateTitle;
- changePuzzle: (id) newPuzzle;
- update: sender;
- windowWillResize: (id) theWindow  toSize: (NXSize *) size;
- windowDidResize: sender;
- windowDidClose: sender;
- windowDidBecomeMain: sender;
- windowDidResignMain: sender;

@end