
/* Controller for envelope-printing service provider */

#import <objc/Object.h>

@interface Controller:Object
{
    id  MyListener;
    id	BigText;	/* TextField for business envelopes */
    id	BigWindow;	/* Window for business envelopes */
    id	PrefPanel;	/* Preferences panel */
    id	SmallText;	/* TextField for personal envelopes */
    id	SmallWindow;	/* Window for small envelopes */
    id	CapsSwitch;	/* Check Box for folding addresses to upper case */
    id  ReturnAddr;	/* TextField for return address */
    id	PrintText;	/* TextField for print command to use */
    id	SizeSel;	/* Radio buttons to select default envelope size */
}

- appDidInit:sender;
- addressEnvelope:(id)pbid userData:(const char *)udata error:(char **)errmsg;
- ShowBig:sender;
	/* Copy text to large window.
	   Close small window.
	   Show large window. */
- PrintBig:sender;
	/* Send large window's text to printer.
	   Close large window.  */
- CloseBig:sender;
- DefaultDefaults:sender;
	/* Set factory defaults. */
- SaveDefaults:sender;
	/* Store defaults in defaults database. */
- ShowSmall:sender;
	/* Copy text to small window.
	   Close large window.
	   Show small window. */
- PrintSmall:sender;
	/* Send small window's text to printer.
	   Close small window. */
- CloseSmall:sender;
- RevertDefaults:sender;
	/* Load defaults from defaults database. */

@end
