// -------------------------------------------------------------------------------------
// GifImageRep.h
// -------------------------------------------------------------------------------------

#import <appkit/NXCustomImageRep.h>
#import <appkit/graphics.h>

// -------------------------------------------------------------------------------------

@interface GifImageRep : NXCustomImageRep
{

	FILE			*imageStream;						// image stream
	long int		imagePos;							// image position in stream
	long int		imageNextPos;						// position of end of image
	int				loadError;							// loading error flag

	u_int			pixWide;							// pixel width
	u_int			pixHigh;							// pixel height
	u_long			rasterSize;							// width * height
	u_int			rasterTop;							// top raster row
	float			aspectRatio;						// aspect ratio

	BOOL			isGlobalMap;						// Is there a global color map?
	int				colorMapCount;						// Number of global colors
	u_char			colorMap[256][3];					// RGB values for global color map

	u_char			*imageRaster;						// raster buffer
  
}

// -------------------------------------------------------------------------------------

+ (BOOL)validImageFile:(const char*)filename;
+ (BOOL)validImageType:(FILE*)fd;
- initFromFile:(const char*)filename;

@end