// -------------------------------------------------------------------------------------
// ImagePortfolio.h
// -------------------------------------------------------------------------------------
#import <appkit/Application.h>
#import "objectThreadPerform.h"
#import "FileUtils.h"

// -------------------------------------------------------------------------------------
#define	docEXTENSION		"portfolio"
#define	dotDocEXTENSION		"." docEXTENSION
#define	listALLOC(N)		[[[List alloc] initCount:N] empty]

// -------------------------------------------------------------------------------------
@interface ImagePortfolio : Application
{

	// application specific vars
	char				*lastPath;				// last saved/openned file path

	// info panel version number text field
	id				versionNum;				// version number

	// panels
	id				infoPanel;				// info panel
	id				helpPanel;				// help panel
	id				prefPanel;				// preferences panel
  
	// font outlets var ids
	id				fontName;				// preference: font name
	id				fontSize;				// preference: font point size
	id				prefCellWidth;			// preference: cell width
	id				prefCellHeight;			// preference: cell height
	id				prefCellRows;			// preference: cell matrix rows
	id				prefCellColumns;		// preference: cell matrix columns

	// real appIcon local window number
	int				appIconWinNum;			// local(global([appIcon windowNum]))
	
}
  
// -------------------------------------------------------------------------------------
- setLastPathNoCopy:(char*)path;
- setLastPath:(char*)path;
- (const char*)lastPath;

/* special event handler */
- dispatchEvents;

/* button/menu actions */
- showPreferences:sender;
- printKeyWindow:sender;

@end
