//
// Overview.h
// Copyright (c) 1988, 1989, 1990 by Jiro Nakamura 
// All rights reserved
//
// Handles the Overview window for Cassandra
// This shows the current time, shows some month calendars (which can
// show any month the user wants), and lists the whole queue (except
// invisible ones).
//
// RCS Information
// Revision Number->	$Revision: 3.3 $
// Last Revised->	$Date: 90/12/03 01:56:23 $
//

#import <appkit/Window.h>
#import <appkit/Text.h>
#import <appkit/PopUpList.h>
#import <dpsclient/dpsclient.h>  // For DPSTimedEntry, used below

@interface Overview:Window
{
	BOOL showSeconds, militaryTime;		// Do we show seconds
						// and use military time?
	int lowPriority;	// Lowest priority for display
	int monthNow;		// What Overview thinks the current month
	int yearNow;		// and year are
	Text *eventText;	// docView of the scrolling area
	
	int	priorityCutOff;
	
	id global;		// IB variables. Accessor to Global object
	id eventScroll;		// Scrolling area

	id dateForm;		// The data area
	id lastMonthText;	// The Text view for the previous month
	id nextMonthText;	// The Text view for the next month
	id thisMonthText;	// The Text view for this month
	
	PopUpList	*viewPopUp;
	id	viewPopUpButton;
}

+ new;				// Create ourself and set default values
- free;				// Free ourself and all objects created
- open: sender;			// Display ourself and set up screen

- windowDidUpdate:sender;	// Update ourselve
- windowWillResize: (id) sender toSize: (NXSize *) size;	// Window
				// is resizing, check constraints

- defaultsDidChange: sender;	// Our display defaults changed, check
				// to see if we need to update our display
- queueDidChange: sender;	// The queue changed. Update the display

- viewPopUpChanged:sender;

- timeUpdate:sender;		// Updates the time  display
- listUpdate: sender;		// Updates the queue display
- monthUpdate: sender;		// Updates the months

- monthRedraw;			// Redraw the months
- monthPrevious: sender;	// Advance the months one
- monthNext: sender;		// Go back one month
@end
