//
// WeekWindow.h
// Copyright (c) 1989, 1990, 1991 by Jiro Nakamura 
// All rights reserved
//
// Handles the Week window
//
// RCS Information
// Revision Number->	$Revision: 1.1 $
// Last Revised->	$Date: 90/10/27 17:36:41 $
//

#import <appkit/Window.h>
#import <appkit/PopUpList.h>
#import <sys/time.h>		

@interface WeekWindow:Window
{
	int     hour, minute;
	struct tm thisWeek;
	
	BOOL militaryTime;
	BOOL miniaturized;
	
	int	priorityCutOff;
	
	PopUpList	*viewPopUp;
	id	viewPopUpButton;
	
	id	weekTextField;
	id	tuesdayScroll;
	id	sundayScroll;
	id	thursdayScroll;
	id	fridayScroll;
	id	wednesdayScroll;
	id	saturdayScroll;
	id	mondayScroll;

	Text	*sundayView;
	Text	*mondayView;
	Text	*tuesdayView;
	Text	*wednesdayView;
	Text	*thursdayView;
	Text	*fridayView;
	Text	*saturdayView;
	
	id global;		// Set by IB. Accessor to Global object
}

- open:sender;			// Open and display today window
- close;			// close window
- save;				// Save window (null method)
- update;			// Update window
- (int) updateView: (id) dayView on: (struct tm *) thisDay fromEvent: (int) en;

- defaultsDidChange: sender;
- windowDidMiniaturize: sender;
- windowDidDeminiaturize: sender;
- windowWillResize: (id) sender toSize: (NXSize *) size;


- weekBefore:sender;
- weekAfter:sender;
- weekNow: sender;
- viewPopUpChanged:sender;
@end
