#import <stdio.h>
#import <appkit/Application.h>  	// for NXHomeDirectory()
#import <appkit/defaults.h>		// for NXWriteDefault() 
#import <stdlib.h> 			// for atoi() 
#import <strings.h>
#import <sys/file.h>

#import "Event.h"

#define PROGNAME		"Cassandra"
#define DIRECTORY	"/.cassandra/"
#define DEFAULTDIRECTORY		"Directory"
#define DEFAULTNOTEPADFILE		"NotepadFile"
#define DEFAULTEVENTFILE		"EventFile"
#define DEFAULTEVENTLOGFILE		"EventLogFile"
#define F_OK    0/* test for presence of file */
#define X_OK    1/* test for execute (search) permission */

#define	OLD_EVENTFILE		"/.cassandra"
#define OLD_EVENTLOGFILE	"/.cassandra.log"
#define	OLD_NOTEPADFILE		"/.cassandra.ntpd"

#define	EVENTFILE	"events"
#define EVENTLOGFILE	"logfile"
#define	NOTEPADFILE	"notepad"

void
main()
{
	int count;
	char tmp[256], tmp2[256];
	char eventFile[128];
	char eventLogFile[128];
	char notepadFile[128];
	char eventFileNew[128];
	char eventLogFileNew[128];
	char notepadFileNew[128];
	const char *str;
	char directory[128];
	Event *infile, *outfile;

	
	printf(	"Cassandra Convert Program. From version prior to 1.5 to 1.5\n"
	"   -- by Jiro Nakamura (July 19,1990) --\n\n");

	printf("Reading old defaults: %s %s %s\n", DEFAULTNOTEPADFILE,
			 DEFAULTEVENTLOGFILE, DEFAULTEVENTFILE);
			 
	str = NXGetDefaultValue(PROGNAME, DEFAULTEVENTFILE);
	if( str == NULL)
		{
		strcpy(eventFile, NXHomeDirectory());
		strcat(eventFile, OLD_EVENTFILE);
		NXWriteDefault( PROGNAME, DEFAULTEVENTFILE, eventFile);
		}
	else
		strcpy(eventFile, str);

	str = NXGetDefaultValue(PROGNAME, DEFAULTEVENTLOGFILE);
	if( str == NULL)
		{
		strcpy(eventLogFile, NXHomeDirectory());
		strcat(eventLogFile, OLD_EVENTLOGFILE);
		NXWriteDefault( PROGNAME, DEFAULTEVENTLOGFILE, eventLogFile);
		}
	else
		strcpy(eventLogFile, str);

	/* Get the default notepadFile */
	str = NXGetDefaultValue(PROGNAME, DEFAULTNOTEPADFILE);
	if( str == NULL)
		{
		strcpy(notepadFile, NXHomeDirectory());
		strcat(notepadFile, OLD_NOTEPADFILE);
		NXWriteDefault( PROGNAME, DEFAULTNOTEPADFILE, notepadFile);
		}
	else
		strcpy(notepadFile, str);

	str = NXGetDefaultValue(PROGNAME, DEFAULTDIRECTORY);
	if( str == NULL)
		{
		strcpy(directory, (char *) NXHomeDirectory());
		strcat(directory, DIRECTORY);
		NXWriteDefault( PROGNAME, DEFAULTDIRECTORY, directory);
		}
	else
		strcpy(directory, str);

	sprintf( eventFileNew, "%s%s", directory, 		EVENTFILE);
	sprintf( eventLogFileNew, "%s%s", directory, 	EVENTLOGFILE);
	sprintf( notepadFileNew, "%s%s", directory, 	NOTEPADFILE);
		strcpy(tmp, directory);
		
	if( *(tmp+ strlen(tmp)-1) == '/')
		* (tmp+ strlen(tmp) -1) = '\0';

	printf("Creating new Cassandra directory <%s>\n", tmp);
		
	if( access( tmp, X_OK) == -1)	// If it doesn't exist
		{
		if( mkdir(tmp, 0700) == -1)		
			{
			fprintf(stderr, "I couldn't create a working directory <%s>",
				tmp);
			exit(1);
			}
		}

	printf("Renaming %s to %s....\n",eventFile, eventFileNew);
	rename( eventFile, eventFileNew);
	printf("Renaming %s to %s....\n",eventLogFile, eventLogFileNew);
	rename( eventLogFile, eventLogFileNew);
	
	for( count = 1; count < 1000; count++)
		{
		sprintf(tmp, "%s.%d", notepadFile, count);
		sprintf(tmp2, "%s.%d", notepadFileNew, count);
		if( access( tmp, F_OK) == -1)
			break;
		printf("Renaming %s to %s....\n",tmp, tmp2);
		rename( tmp, tmp2);
		}
			
	printf("Removing old defaults: %s %s %s\n", DEFAULTNOTEPADFILE,
			  DEFAULTEVENTFILE, DEFAULTEVENTLOGFILE);
	
	NXRemoveDefault( PROGNAME, DEFAULTNOTEPADFILE);
	NXRemoveDefault( PROGNAME, DEFAULTEVENTFILE);
	NXRemoveDefault( PROGNAME, DEFAULTEVENTLOGFILE);
			 
	printf("\nFinished.\n\n");
	return;
}

