//
// misc.h    definitions of procedures in misc.m
//
// Misc - Miscellaneous I/O routines package
//
// Support functions for Cassandra
// Copyright (c) 1988, 1989, 1990 by Jiro Nakamura
//
// RCS Information
// Revision Number->	$Revision: 1.7 $
// Last Revised->	$Date: 91/11/01 17:24:15 $
//


// Procedure: 		FILE *fileOpen( char* filename, char *mode, 
//				char *message)
// Arguments:		char * filename 	-> name of file to be opened
//			char * mode		-> mode using fopen() 
//							(e.g. "r", "a+")
//			char * message	-> message to be shown if fopen() fails
// Description: 	Opens file <filename> with mode <mode> using the 
//			standard io function fopen(). 
//			If an error occurs while trying to open it,
//			fileOpen tries to create the file with creat() mode 
//			0600. If that fails too, <message> is dispayed as an
//			error message using the function NXAlertPanel() 
//			and the functions aborts the program with exit()
// Return Value: 	FILE pointer to the open file.
FILE *fileOpen( char * filename, char * mode, char *message);

// Procedure: 		FILE * fileSeek(FILE *source, int here, char *message)
// Arguments: 		FILE *source, int here
// Description:		This procedure will do an fseek on FILE <source>,
//			the place seeked to is usually a record from a 
//			database, with <here> as the
//  			record number and the global value FILE_LEN being 
//			the record length.
// Return Value:	NULL if a correctable error occured, 
//			<source> if successful
FILE *fileSeek(FILE *source, int here, char *message);


