/* Program: MOTD - 'Motto of the day' window
 *
 * By: Christopher Lane (lane@sumex-aim.stanford.edu)
 *     Symbolic Systems Resources Group
 *     Knowledge Systems Laboratory
 *     Stanford University
 *
 * Contributors:
 *
 *    Izumi Ohzawa (izumi@violet.berkeley.edu)
 *    Group in Neurobiology/School of Optometry
 *    University of California, Berkeley
 *
 *    Steve Hayman (sahayman@cs.indiana.edu)
 *    Computer Science Department Workstation Manager
 *
 * Date:  5 November 1992
 *
 * Copyright: 1989, 1990, 1991 & 1992 by The Leland Stanford Junior University.
 * This program may be distributed without restriction for non-commercial use.
 */

#import <c.h>
#import <libc.h>

#import <appkit/appkit.h>

#define MAILDIR "/usr/spool/mail/"

typedef enum { NONE, OLD, NEW } MailLevel;
typedef enum { LT = -1, EQ, GT } Comparison;

@interface MOTD:Application
{
	id window;
	id docView;
	id quitButton;
	id holdButton;
	id cancelButton;
	id mailPanel;
	id mailTitle;
	id mailText;
	
	int wait, uid;
	NXBundle *bundle;
	MailLevel maillevel;
	const char *file, *name;
	DPSTimedEntry timedEntry;
	BOOL do_motd, loginHook;
}

+ new;

- appDidInit:sender;
- windowWillClose:sender;
- free;

- setMailPanel:anObject;
- setMailText:anObject;
- setMailTitle:anObject;

- txt;
- rtf;
- rtfd;

- setWindow:anObject;
- setDocView:anObject;

- quitButton;
- setQuitButton:anObject;

- holdButton;
- setHoldButton:anObject;

- cancelButton;
- setCancelButton:anObject;

- (const char *) userName;
- setUserName:(const char *) pw_name;

- (int) UID;
- setUID:(int) pw_uid;

- (BOOL) do_Motd;
- setDo_Motd:(BOOL) aBoolean;

- (MailLevel) mailLevel;
- setMailLevel:(MailLevel) aMailLevel;

- (const char *) file;
- setFile:(const char *) aString;

- (BOOL) loginHook;
- setLoginHook:(BOOL) aBoolean;

- (int) wait;
- setWait:(int) anInteger;

- cancelLogin:sender;

@end