/* Stuff stolen from 2.1 sys/table.h which disappeared in 3.0 */
#import <sys/dk.h>
#import <bsd/machine/table.h>

#define TBL_CPUINFO		12	/* (no index), generic CPU info */
#define TBL_IOINFO		13	/* (no index), generic I/O info */
#define	TBL_DISKINFO		14	/* indexed by dk slot */
#define TBL_NETINFO		15	/* index by network slot */

/*
 * TBL_CPUINFO data layout
 */
struct tbl_cpuinfo
{
    int		ci_swtch;		/* # context switches */
    int		ci_intr;		/* # interrupts */
    int		ci_syscall;		/* # system calls */
    int		ci_traps;		/* # system traps */
    int		ci_hz;			/* # ticks per second */
    int		ci_phz;			/* profiling hz */
    int		ci_cptime[CPUSTATES];	/* cpu state times */
};

/*
 * TBL_IOINFO data layout
 */
struct tbl_ioinfo
{
    int		io_ttin;	/* # bytes of tty input */
    int		io_ttout;	/* # bytes of tty output */
    int		io_dkbusy;	/* drives active? */
    int		io_ndrive;	/* number disk drives configured */
    int		io_nif;		/* number of network interfaces */
};

/*
 * TBL_DISKINFO data layout (not generically implemented)
 */
struct tbl_diskinfo
{
    int		di_time;	/* ticks drive active */
    int		di_seek;	/* # drive seeks */
    int		di_xfer;	/* # drive transfers */
    int		di_wds;		/* # sectors transfered */
    int		di_bps;		/* drive transfer rate (bytes per second) */
    char	di_name[8];	/* drive name */
};

/*
 * TBL_NETINFO data layout
 */
struct tbl_netinfo
{
    int		ni_ipackets;	/* # input packets */
    int		ni_ierrors;	/* # input errors */
    int		ni_opackets;	/* # output packets */
    int		ni_oerrors;	/* # output errors */
    int		ni_collisions;	/* # # collisions on csma if's */
    char	ni_name[8];	/* interface name */
};
