#import <objc/NXStringTable.h>

#import <defaults/defaults.h>

#import <appkit/Application.h>
#import <appkit/color.h>

#define SYSTEM "System"

#define getDefault(s) NXGetDefaultValue([NXApp appName], s)

#define getIntDefault(s) atoi(getDefault(s))

#define getBoolDefault(s) ((strncasecmp(getDefault(s), "Yes", 1) == 0) ? YES : NO)

#define getStringDefault(s) getDefault(s)

#define getFloatDefault(s) atof(getDefault(s))

#define getSystemDefault(s) NXGetDefaultValue(SYSTEM, s)

#define writeDefault(s, v) NXWriteDefault([NXApp appName], s, v)

#define writeBoolDefault(s, v) writeDefault(s, (v) ? "Yes" : "No")

int writeIntDefault(const char *name, int value);

int writePointDefault(const char *name, NXPoint point);
NXPoint getPointDefault(const char *name);

int writeColorDefault(const char *name, NXColor color);
NXColor getColorDefault(const char *name);

@interface DefaultsTable : NXStringTable

- initFromFile:(const char *) file;
- registerDefaults:(const char *) owner;
- writeDefaults:(const char *) owner;
- updateDefaults;

- (int) applyToDefaults:(const char *) owner function:(int (*)(const char *, const NXDefaultsVector)) routine;

@end
