/* File: Magnify.h - Application class for 'Magnify'
 *
 * By: Christopher Lane
 * Symbolic Systems Resources Group
 * Knowledge Systems Laboratory
 * Stanford University
 *
 * Date:  9 November 1992
 *
 * Copyright: 1990, 1991 & 1992 by The Leland Stanford Junior University.
 * This program may be distributed without restriction for non-commercial use.
 */
 
#import <objc/NXBundle.h>
#import <appkit/Application.h>

#define VERSION __DATE__

#define OFFSTRING "Off"
#define YESSTRING "Yes"

#define FROZENMENUCELLTAG (1)
#define FROZENMENUTITLE "Freeze"
#define UNFROZENMENUTITLE "Unfreeze"

#define HALF ((float) 0.5)

#define FLOAT "%g"
#define DOUBLE "%G"

@interface Magnify : Application
{ 
	id view;
	id version;
	id defaults;
	id gridField;
	id gridSlider;
	id gridButton;
	id scaleField;
	id scaleSlider;
	id updateField;
	id updateSlider;
	id updateButton;
	id cursorButton;
	
	NXBundle *bundle;
	DPSTimedEntry timedEntry;
}

+ new;

- appDidInit:sender;
- appWillTerminate:sender;
- hide:sender;
- unhide:sender;
- free;

- adjust:sender;

- changeScale:sender;
- showScale:(float) scale andSlider:(BOOL) flag;

- changeGrid:sender;
- showGrid:(float) grid andSlider:(BOOL) flag;

- changeUpdate:sender;
- showUpdate:(double) update andSlider:(BOOL) flag;

- toggleFrozen:sender;
- toggleCursor:sender;

- getView;
- setView:anObject;

- setVersion:anObject;
- (int) msgVersion:(const char **) aString ok:(int *) flag;

@end
