// -------------------------------------------------------------------------------------
// ExecMonitor
// -------------------------------------------------------------------------------------

#import <objc/Object.h>
#import <appkit/graphics.h>

// -------------------------------------------------------------------------------------
@interface ExecMonitor : Object
{

	id					shellCommands;

	const char			*saveFileName;
	BOOL				useRunServer;
	BOOL				cmdInProcess;
	BOOL				shutDown;

	id					exeRunServer;
	
	id					exeWindow;
	id					exeShellScroll;
	id					exeExecute;
	id					exeCommandScroll;
	id					exeHost;
	id					exeUser;
	id					exePassword;
	
	execHandle_t		execId;

	id					exeControlBox;
	NXSize				minWinSize;

	id					textFont;
	float				textGray;
	
}

// -------------------------------------------------------------------------------------

+ (const char*)findUserPassword:(const char*)user;
+ updateUser:(const char*)user password:(const char*)password;
+ removeUserPassword:(const char*)user;

+ newExecHost:(const char*)host server:(const char*)server;
- setRemoteHost:(const char*)host server:(const char*)server;
- showPanel:sender;

- exeExecute:sender;

+ closeAllWindows;
- closeWindow:sender;

+ terminalCommand:(const char*)cmd title:(const char*)title;

- saveAs:sender;
- save:sender;

@end
