/*---------------------------------------------------------------------------
Help.m -- Copyright (c) 1991 Rex Pruess

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or send
   electronic mail to the the author.

This routine loads and displays the help panel.

Rex Pruess <rpruess@umaxc.weeg.uiowa.edu>

$Header: /rpruess/apps/Remotes3.0/RCS/Help.m,v 3.0 92/09/23 22:13:38 rpruess Exp $
-----------------------------------------------------------------------------
$Log:	Help.m,v $
Revision 3.0  92/09/23  22:13:38  rpruess
Checked in to RCS to get the revision number updated to 3.0.

Revision 2.1  92/09/23  21:29:53  rpruess
Updated code for NeXT System Release 3.0.

Revision 2.0  91/01/22  15:33:31  rpruess
Remotes-2.0 was upgraded for NeXT System Release 2.0 (standard or extended).
Remotes-2.0 supports the NeXT supplied Terminal application and the Stuart
shareware product.

Revision 1.1  90/04/10  14:25:30  rpruess
Initial revision

-----------------------------------------------------------------------------*/

/* Help class header file */
#import "Help.h"

/* Appkit header files */
#import <appkit/Application.h>
#import <appkit/Panel.h>

@implementation Help

- init
{
   self = [super init];
   [NXApp loadNibSection:"Help.nib" owner:self withNames:NO];
   [helpPanel setMiniwindowIcon:"app"];
   return self;
}

- showHelpPanel:sender
{
   [helpPanel makeKeyAndOrderFront:sender];
   return self;
}

- setHelpPanel:anObject
{
   helpPanel = anObject;
   return self;
}

@end
