/* You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to
 * its fitness for any particular use.
 */

/* Modified hideously by Subrata K. Sircar for use with MultApp */
/* To localize something with MultApp one should:				*/
/* 1.  Build the foreign-language string tables and nib files	*/
/* 2.  After creating the project directories, load the string	*/
/*	   tables into the nib files and attach them in IB to the	*/
/*	   application delegate.									*/
/* 3.  Modify the XXX_main.m file to use LoadLocalNib.			*/
/*  That should be it.  Every other string/image/etc in the code*/
/*  uses the appropriate LocalXYZ call, which all check the 	*/
/*  application delegate for its string table, etc.				*/
 
typedef struct {
	char	month;
	char	day;
	char	year;
	char	hour;
	char	minute;
	char	second;
} DAY_TIME;

#import <appkit/Application.h>
#import	<objc/NXStringTable.h>
#import <defaults.h>
#import	<time.h>
#import "MultApp.h"


#define	MESS_MAX	MAX_NXSTRINGTABLE_LENGTH

extern id LoadLocalNib(const char *nibFile, id owner, BOOL withNames, NXZone *zone);
extern char *LocalString(char *string);
extern id LocalImageRep(const char *file, NXZone *zone);
extern id LocalImage(const char *file, NXZone *zone);
extern void LocalHelp(char *path, const char *file);
extern char *LocalHelpFont();
extern void getDateString(DAY_TIME *date, char *string);

