#import <appkit/Responder.h>

/* Version 0.9b			Apr-19-92		First Public Release	*/
/* Version 0.95b		Apr-29-92		Multiple Save Types		*/
/* Version 1.0b			Aug-10-92		Minor Bug Fixes			*/

@interface MultDoc : Responder
{
    id 		view;				/* the document's View */
    id 		window;				/* the window the View is in */
    id 		printInfo;			/* Print Margins etc. */
    char 	*name;				/* the name of the document */
    char 	*directory;			/* the directory it is in */
    BOOL 	haveSavedDocument;	/* whether document has associated disk file */
	BOOL	dirty;				/* Whether or not the document needs saving */
	BOOL	empty;				/* is the document empty? */
}

/* Factory methods */

+ initialize;
+ setExtension:(const char *)newExtension;
+ (const char *)extension;
+ setDefault:(const char *)newDefault;
+ (const char *)default;

+ (NXZone *)newZone;

/* Factory Creation Methods */

+ new;
+ newFromZone:(NXZone *)zone;
+ newFromFile:(const char *)file;
- instanceAwake;
- setUpNib;
 
- free;

/* Public methods */

- view;
- printInfo;
- (BOOL)isEmpty;
- setEmpty:(BOOL)flag;
- (BOOL)hasSavedDocument;
- setSavedDocument:(BOOL)flag;
- (BOOL)needsSaving;
- dirty:(BOOL)flag;

- changeLayout:sender;

/* Target/Action methods */

- save:sender;
- saveAs:sender;
- revertToSaved:sender;

/* Document name and file handling methods */

- (const char *)fileName;
- (const char *)directory;
- (const char *)name;
- setName:(const char *)name andDirectory:(const char *)directory;
- setName:(const char *)name;
- save;

/* Window delegate methods */

- windowWillClose:sender;
- windowDidBecomeMain:sender;
- windowWillMiniaturize:sender toMiniwindow:counterpart;

/* Text delegate methods */

- textDidGetKeys:sender isEmpty:(BOOL)flag;

/* Menu command validation method */

- (BOOL)validateCommand:menuCell;

@end
